package it.finanze.dogane.accise.aautotrasportatori.model;

import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;
import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.model.AbstractRecord;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

public class AutotrasportatoriQuadroA extends AutotrasportatoriRecord {
	private BigInteger progressivoRecord = BigInteger.valueOf(0);
	private String targa = "";
	private String titoloPossesso = "";
	private BigInteger dataInizioPossesso = BigInteger.valueOf(0);
	private BigInteger dataFinePossesso = BigInteger.valueOf(0);
	private BigInteger numeroFatture = BigInteger.valueOf(0);
	private BigInteger numeroSchede = BigInteger.valueOf(0);
	private BigInteger litriConsumati = BigInteger.valueOf(0);
	private BigInteger chilometriPercorsi = BigInteger.valueOf(0);
	private BigDecimal importo = BigDecimal.valueOf(0, 0);
	// private String autoveicoloMassaMassimaNonInferiore11 ="";commentato reply
	private String tipoQuadroA = ""; // aggiunto reply
	// dichiarazione dimenzioni variabili
	private static final int dimProgressivoRecord = 4;
	private static final int dimTarga = 12;
	private static final int dimTitoloPossesso = 1;
	private static final int dimDataInizioPossesso = 4;
	private static final int dimDataFinePossesso = 4;
	private static final int dimNumeroFatture = 4;
	private static final int dimNumeroSchede = 4;
	private static final int dimLitriConsumati = 10;
	private static final int dimChilometriPercorsi = 14;
	private static final int dimImportoInt = 10;
	private static final int dimImportoDec = 2;
	private static int progRecQuadroA1 = 0;
	// private static final int dimAutoveicoloMassaMassimaNonInferiore11=1; commentato reply
	private static final int dimTipoQuadroA = 1; // aggiunto reply //FHF
	public static final BigDecimal ALIQUOTA_QUADRO_A1_OLD = new BigDecimal(0.00978609);
	public static final BigDecimal ALIQUOTA_QUADRO_A1 = new BigDecimal(0.01278609);

	// modifica 06/08/2008 cambio aliquota
	// public static final BigDecimal ALIQUOTA_QUADRO_A2 = new BigDecimal(0.01278609);
	public static final BigDecimal ALIQUOTA_QUADRO_A2 = new BigDecimal(0.01978609);// 19,78609 -->
																					// 0,01978609
																					// per 1000
																					// litri

	public static AutotrasportatoriQuadroA getNewObject(ProspettoConsumo prospettoConsumo) {
		AutotrasportatoriQuadroA retvalue = new AutotrasportatoriQuadroA();
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		retvalue.setAnnoDic(frontespizio.getAnnoDic());
		retvalue.setPartitaIva(frontespizio.getPartitaIva());
		retvalue.setProgPartitaIva(frontespizio.getProgPartitaIva());
		return retvalue;
	}

	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		// if(VisualConfig.TIPO_LETTURA_RECORD==2007&&(tipoQuadroA!=null)/*&&(!tipoQuadroA.equals("2"))*/){
		if (tipoQuadroA != null) {
			// FHF per lasciare ANCHE la situazione precedente --
			Contatori.PROGRESSIVO_FILE_QUADRO_A1++;
			BigInteger progressivoRecordShadow = progressivoRecord;
			progressivoRecord = new BigInteger("" + Contatori.PROGRESSIVO_FILE_QUADRO_A1);
			// ---------------------------------------------------
			super.scriviOggetto(out);
			out.write(normalizzaCampo(progressivoRecord, dimProgressivoRecord));
			out.write(normalizzaCampo(targa, dimTarga));
			out.write(normalizzaCampo(titoloPossesso, dimTitoloPossesso));
			out.write(normalizzaCampo(dataInizioPossesso, dimDataInizioPossesso));
			out.write(normalizzaCampo(dataFinePossesso, dimDataFinePossesso));
			out.write(normalizzaCampo(numeroFatture, dimNumeroFatture));
			out.write(normalizzaCampo(numeroSchede, dimNumeroFatture));
			out.write(normalizzaCampo(litriConsumati, dimLitriConsumati));
			out.write(normalizzaCampo(chilometriPercorsi, dimChilometriPercorsi));
			out.write(normalizzaCampo(importo, dimImportoInt, dimImportoDec));
			// out.write(normalizzaCampo(autoveicoloMassaMassimaNonInferiore11,
			// dimAutoveicoloMassaMassimaNonInferiore11));commentato reply
			out.write(normalizzaCampo(tipoQuadroA, dimTipoQuadroA));// aggiunto reply
			scriviFineRiga(out);
			// FHF per lasciare ANCHE la situazione precedente ----
			progressivoRecord = progressivoRecordShadow;
			// -----------------------------------------------------
		}
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);

		progressivoRecord = readFieldBigInteger(in, dimProgressivoRecord);
		targa = readFieldString(in, dimTarga);
		titoloPossesso = readFieldString(in, dimTitoloPossesso);
		dataInizioPossesso = readFieldBigInteger(in, dimDataInizioPossesso);
		dataFinePossesso = readFieldBigInteger(in, dimDataFinePossesso);
		numeroFatture = readFieldBigInteger(in, dimNumeroFatture);
		numeroSchede = readFieldBigInteger(in, dimNumeroSchede);
		litriConsumati = readFieldBigInteger(in, dimLitriConsumati);
		chilometriPercorsi = readFieldBigInteger(in, dimChilometriPercorsi);
		importo = readFieldBigDecimal(in, dimImportoInt, dimImportoDec);
		// autoveicoloMassaMassimaNonInferiore11 = readFieldString(in,
		// dimAutoveicoloMassaMassimaNonInferiore11);commentato reply
		tipoQuadroA = readFieldString(in, dimTipoQuadroA);// aggiunto reply
		saltaFineRiga(in);
	}

	public Object clone() throws CloneNotSupportedException {
		AutotrasportatoriQuadroA clonato = new AutotrasportatoriQuadroA();

		clonato.setProgressivoRecord(this.progressivoRecord);
		clonato.setTarga(this.targa);
		clonato.setTitoloPossesso(this.titoloPossesso);
		clonato.setDataInizioPossesso(this.dataInizioPossesso);
		clonato.setDataFinePossesso(this.dataFinePossesso);
		clonato.setNumeroFatture(this.numeroFatture);
		clonato.setNumeroSchede(this.numeroSchede);
		clonato.setLitriConsumati(this.litriConsumati);
		clonato.setChilometriPercorsi(this.chilometriPercorsi);
		clonato.setImporto(this.importo);
		// clonato.setAutoveicoloMassaMassimaNonInferiore11(this.autoveicoloMassaMassimaNonInferiore11);commentato
		// reply
		clonato.setTipoQuadroA(this.tipoQuadroA);// aggiunto reply

		clonato.setPartitaIva(this.getPartitaIva());
		clonato.setProgPartitaIva(this.getProgPartitaIva());
		clonato.setAnnoDic(this.getAnnoDic());
		clonato.setTipoRecord(this.getTipoRecord());

		return clonato;
	}

	/**
	 * @return
	 */
	public static int getDimChilometriPercorsi() {
		return dimChilometriPercorsi;
	}

	/**
	 * @return
	 */
	public static int getDimDataFinePossesso() {
		return dimDataFinePossesso;
	}

	/**
	 * @return
	 */
	public static int getDimDataInizioPossesso() {
		return dimDataInizioPossesso;
	}

	/**
	 * @return
	 */
	public static int getDimImportoDec() {
		return dimImportoDec;
	}

	/**
	 * @return
	 */
	public static int getDimImportoInt() {
		return dimImportoInt;
	}

	/**
	 * @return
	 */
	public static int getDimLitriConsumati() {
		return dimLitriConsumati;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroFatture() {
		return dimNumeroFatture;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroSchede() {
		return dimNumeroSchede;
	}

	/**
	 * @return
	 */
	public static int getDimProgressivoRecord() {
		return dimProgressivoRecord;
	}

	/**
	 * @return
	 */
	public static int getDimTarga() {
		return dimTarga;
	}

	/**
	 * @return
	 */
	public static int getDimTitoloPossesso() {
		return dimTitoloPossesso;
	}

	/**
	 * @return
	 */

	/**
	 * @return
	 */
	public BigInteger getChilometriPercorsi() {
		return chilometriPercorsi;
	}

	/**
	 * @return
	 */
	public BigInteger getDataFinePossesso() {
		return dataFinePossesso;
	}

	/**
	 * @return
	 */
	public BigInteger getDataInizioPossesso() {
		return dataInizioPossesso;
	}

	/**
	 * @return
	 */
	public BigDecimal getImporto() {
		return importo;
	}

	/**
	 * @return
	 */
	public BigInteger getLitriConsumati() {
		return litriConsumati;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroFatture() {
		return numeroFatture;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroSchede() {
		return numeroSchede;
	}

	/**
	 * @return
	 */
	public BigInteger getProgressivoRecord() {
		return progressivoRecord;
	}

	/**
	 * @return
	 */
	public String getTarga() {
		return targa;
	}

	/**
	 * @return
	 */
	public String getTitoloPossesso() {
		return titoloPossesso;
	}

	/**
	 * @param integer
	 */

	/**
	 * @param integer
	 */
	public void setChilometriPercorsi(BigInteger integer) {
		chilometriPercorsi = integer;
	}

	/**
	 * @param integer
	 */
	public void setDataFinePossesso(BigInteger integer) {
		dataFinePossesso = integer;
	}

	/**
	 * @param integer
	 */
	public void setDataInizioPossesso(BigInteger integer) {
		dataInizioPossesso = integer;
	}

	/**
	 * @param decimal
	 */
	public void setImporto(BigDecimal importoIn) {
		// arrotondo alla seconda cifra decimale ...
		// BigDecimal importoRound= importoIn.setScale(2,BigDecimal.ROUND_HALF_UP);
		importo = importoIn;
	}

	/**
	 * @param integer
	 */
	public void setLitriConsumati(BigInteger integer) {
		litriConsumati = integer;
	}

	/**
	 * @param integer
	 */
	public void setNumeroFatture(BigInteger integer) {
		numeroFatture = integer;
	}

	/**
	 * @param integer
	 */
	public void setNumeroSchede(BigInteger integer) {
		numeroSchede = integer;
	}

	/**
	 * @param integer
	 */
	public void setProgressivoRecord(BigInteger integer) {
		progressivoRecord = integer;
	}

	/**
	 * @param string
	 */
	public void setTarga(String string) {
		targa = string;
	}

	/**
	 * @param string
	 */
	public void setTitoloPossesso(String string) {
		titoloPossesso = string;
	}

	/**
	 * @return
	 */
	public String getTipoQuadroA() {
		return tipoQuadroA;
	}

	/**
	 * @param string
	 */
	public void setTipoQuadroA(String string) {
		tipoQuadroA = string;
	}

	// metodo di utilit per la stampa
	public Object[] getQuadroToArray() {

		// purtroppo hanno codificato le date come BigInteger
		String strDtIn = dataInizioPossesso.toString();
		int lenDtInizio = strDtIn.length();
		boolean lenIn = lenDtInizio == 3;
		String dtInizioGG = lenIn ? "0" + strDtIn.substring(0, 1) : strDtIn.substring(0, 2);
		String dtInizioMM = lenIn ? strDtIn.substring(1) : strDtIn.substring(2);

		String strDtFi = dataFinePossesso.toString();
		int lenDtFine = strDtFi.length();
		boolean lenFi = lenDtFine == 3;
		String dtFineGG = lenFi ? "0" + strDtFi.substring(0, 1) : strDtFi.substring(0, 2);
		String dtFineMM = lenFi ? strDtFi.substring(1) : strDtFi.substring(2);

		return new Object[] { targa, titoloPossesso, (dtInizioGG + "/" + dtInizioMM), (dtFineGG + "/" + dtFineMM), numeroFatture, numeroSchede, litriConsumati, chilometriPercorsi,
				importo };
	}

}
