package it.finanze.dogane.accise.aautotrasportatori.model;

import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;
import it.finanze.dogane.accise.model.AbstractRecord;

import java.io.IOException;
import java.math.BigInteger;

public  class AutotrasportatoriQuadroC extends AutotrasportatoriRecord {
	
	private BigInteger progressivoRecord=BigInteger.valueOf(0);             
	private String targa="";        
	private String tipoAutoveicolo ="";          
	private BigInteger dataInizioPossesso =BigInteger.valueOf(0);             
	private BigInteger dataFinePossesso=BigInteger.valueOf(0);                
                                       
                                       
                                       
	private static final int dimProgressivoRecord=4;           
	private static final int dimTarga=12;        
	private static final int dimTipoAutoveicolo =30;          
	private static final int dimDataInizioPossesso =4;          
	private static final int dimDataFinePossesso=4;             

	public void scriviOggetto(java.io.OutputStream out) throws IOException {
		// FHF per lasciare ANCHE la situazione precedente --
		Contatori.PROGRESSIVO_FILE_QUADRO_C++;
		BigInteger progressivoRecordShadowC=progressivoRecord;
		progressivoRecord=new BigInteger(""+Contatori.PROGRESSIVO_FILE_QUADRO_C);
		//---------------------------------------------------
		super.scriviOggetto(out);
		out.write(normalizzaCampo(progressivoRecord, dimProgressivoRecord));   
		out.write(normalizzaCampo(targa, dimTarga));                           
		out.write(normalizzaCampo(tipoAutoveicolo, dimTipoAutoveicolo));       
		out.write(normalizzaCampo(dataInizioPossesso, dimDataInizioPossesso)); 
		out.write(normalizzaCampo(dataFinePossesso, dimDataFinePossesso));     
		scriviFineRiga(out);
		// FHF per lasciare ANCHE la situazione precedente ----
		progressivoRecord=progressivoRecordShadowC;
		//-----------------------------------------------------	
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);
		progressivoRecord = readFieldBigInteger(in, dimProgressivoRecord);      
		targa = readFieldString(in, dimTarga);	                            
		tipoAutoveicolo = readFieldString(in, dimTipoAutoveicolo);	        
		dataInizioPossesso = readFieldBigInteger(in, dimDataInizioPossesso);	  
		dataFinePossesso = readFieldBigInteger(in, dimDataFinePossesso);	      
 		saltaFineRiga(in);
	}             

	public Object clone() throws CloneNotSupportedException {
		AutotrasportatoriQuadroC clonato = new AutotrasportatoriQuadroC();

		clonato.setProgressivoRecord(this.progressivoRecord);
		clonato.setTarga(this.targa);
		clonato.setTipoAutoveicolo(this.tipoAutoveicolo);
		clonato.setDataInizioPossesso(this.dataInizioPossesso);
		clonato.setDataFinePossesso(this.dataFinePossesso);

		clonato.setPartitaIva(this.getPartitaIva());
		clonato.setProgPartitaIva(this.getProgPartitaIva());
		clonato.setAnnoDic(this.getAnnoDic());
		clonato.setTipoRecord(this.getTipoRecord());

		return clonato;
	}

	public static AutotrasportatoriQuadroC getNewObject(ProspettoConsumo prospettoConsumo) {
		AutotrasportatoriQuadroC retvalue = new AutotrasportatoriQuadroC();
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		retvalue.setAnnoDic(frontespizio.getAnnoDic());
		retvalue.setPartitaIva(frontespizio.getPartitaIva());
		retvalue.setProgPartitaIva(frontespizio.getProgPartitaIva());
		return retvalue;
	}

	/**
	 * @return
	 */
	public static int getDimDataFinePossesso() {
		return dimDataFinePossesso;
	}

	/**
	 * @return
	 */
	public static int getDimDataInizioPossesso() {
		return dimDataInizioPossesso;
	}

	/**
	 * @return
	 */
	public static int getDimProgressivoRecord() {
		return dimProgressivoRecord;
	}

	/**
	 * @return
	 */
	public static int getDimTarga() {
		return dimTarga;
	}

	/**
	 * @return
	 */
	public static int getDimTipoAutoveicolo() {
		return dimTipoAutoveicolo;
	}

	/**
	 * @return
	 */
	public BigInteger getDataFinePossesso() {
		return dataFinePossesso;
	}

	/**
	 * @return
	 */
	public BigInteger getDataInizioPossesso() {
		return dataInizioPossesso;
	}

	/**
	 * @return
	 */
	public BigInteger getProgressivoRecord() {
		return progressivoRecord;
	}

	/**
	 * @return
	 */
	public String getTarga() {
		return targa;
	}

	/**
	 * @return
	 */
	public String getTipoAutoveicolo() {
		return tipoAutoveicolo;
	}

	/**
	 * @param integer
	 */
	public void setDataFinePossesso(BigInteger integer) {
		dataFinePossesso = integer;
	}

	/**
	 * @param integer
	 */
	public void setDataInizioPossesso(BigInteger integer) {
		dataInizioPossesso = integer;
	}

	/**
	 * @param integer
	 */
	public void setProgressivoRecord(BigInteger integer) {
		progressivoRecord = integer;
	}

	/**
	 * @param string
	 */
	public void setTarga(String string) {
		targa = string;
	}

	/**
	 * @param string
	 */
	public void setTipoAutoveicolo(String string) {
		tipoAutoveicolo = string;
	}
	
	//metodo di utilit per la stampa 
	public Object[] getQuadroToArray(){	
		
		//purtroppo hanno codificato le date come BigInteger
		String strDtIn =  dataInizioPossesso.toString();		
		int lenDtInizio = strDtIn.length();	
		boolean lenIn = lenDtInizio == 3;	
		String dtInizioGG = lenIn ? "0"+strDtIn.substring(0,1): strDtIn.substring(0,2);
		String dtInizioMM = lenIn ?  strDtIn.substring(1) : strDtIn.substring(2);
		
		String strDtFi =  dataFinePossesso.toString();		
		int lenDtFine = strDtFi.length();	
		boolean lenFi = lenDtFine == 3;	
		String dtFineGG = lenFi ? "0"+strDtFi.substring(0,1): strDtFi.substring(0,2);
		String dtFineMM = lenFi ?  strDtFi.substring(1) : strDtFi.substring(2);
			            	

		return new Object[]{targa,tipoAutoveicolo,(dtInizioGG+"/"+dtInizioMM),(dtFineGG+"/"+dtFineMM)};
	}

}

