/*
 * Creato il 17-feb-09
 *
 * Per modificare il modello associato a questo file generato, aprire
 * Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e commenti
 */
package it.finanze.dogane.accise.aautotrasportatori.model;

import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

/**
 * @author nsidev66
 *
 * Per modificare il modello associato al commento di questo tipo generato, aprire
 * Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e commenti
 */
public class DatiContabiliRecord extends AutotrasportatoriRecord {

	private BigInteger progressivoRecord=BigInteger.valueOf(0);     
	private BigInteger progressivoRiga=BigInteger.valueOf(0);     
	private BigInteger totaleLitri=BigInteger.valueOf(0);     
	private BigDecimal totaleImportoCredito=BigDecimal.valueOf(0); 
	
	
	
	
	
	public static final int dimProgressivoRecord=4;
	public static final int dimProgressivoRiga=1;
	public static final int dimTotaleLitri=12;           
	public static final int dimImpACreditoInt=12;           
	public static final int dimImpACreditoDec=2;   
	
	public DatiContabiliRecord(BigInteger litri, BigDecimal importi,BigInteger riga){
	
		
		this.totaleLitri = litri;
		this.totaleImportoCredito = importi;
		this.progressivoRiga = riga;
	}
	public DatiContabiliRecord(){}
	
	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		super.scriviOggetto(out);
		Contatori.PROGRESSIVO_DATI_CONTABILI++;
		progressivoRecord=new BigInteger(""+Contatori.PROGRESSIVO_DATI_CONTABILI);	
		out.write(normalizzaCampo(progressivoRecord, dimProgressivoRecord));
		out.write(normalizzaCampo(progressivoRiga, dimProgressivoRiga));
		out.write(normalizzaCampo(totaleLitri, dimTotaleLitri));
		out.write(normalizzaCampo(totaleImportoCredito, dimImpACreditoInt, dimImpACreditoDec));
		
		scriviFineRiga(out);	
	}
	        
	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);
			
		progressivoRecord = readFieldBigInteger(in, dimProgressivoRecord);
		progressivoRiga = readFieldBigInteger(in, dimProgressivoRiga); 
		totaleLitri = readFieldBigInteger(in, dimTotaleLitri); 	 		
		totaleImportoCredito= readFieldBigDecimal(in, dimImpACreditoInt, dimImpACreditoDec); 
		saltaFineRiga(in);
	}
	/**
	 * @return
	 */
	public BigInteger getProgressivoRiga() {
		return progressivoRiga;
	}

	/**
	 * @return
	 */
	public BigDecimal getTotaleImportoCredito() {
		return totaleImportoCredito;
	}

	/**
	 * @return
	 */
	public BigInteger getTotaleLitri() {
		return totaleLitri;
	}

}
