package it.finanze.dogane.accise.aautotrasportatori.model;

import it.finanze.dogane.accise.aautotrasportatori.config.Contatori;
import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;

import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.math.BigInteger;

public class Frontespizio extends AutotrasportatoriRecord {
	
	private String codUffTecnicoFinanza ="";
	private String cognomeRappresentanteDichiarazione ="";
	private String nomeRappresentanteDichiarazione ="";
	private String codicefiscaleRappresentanteDichiarazione ="";
	private String qualificaRappresentanteDichiarazione ="";
	private String denominazione ="";
	private String provinciaSedeLegale  ="";
	private String comuneSedeLegale ="";
	private String indirizzoSedeLegale  ="";
	private String provinciaSedeAmministrativa ="";
	private String comuneSedeAmministrativa ="";
	private String indirizzoSedeAmministrativa ="";
	private String codiceAttivita ="";
	private String esercente  ="";
	private String autoTrasportoMerci ="";
	private String estremiLicenza ="";
	private BigInteger allegatiCertificatiImmatricolazione =BigInteger.valueOf(0);
	private BigInteger allegatiTitoliPossesso =BigInteger.valueOf(0);
	private BigInteger totaleLitriConsumati =BigInteger.valueOf(0);
	private BigDecimal totaleImportCredito  =BigDecimal.valueOf(0,0);
	private String valuta ="";
	private String modalitaFruizioneCredito  ="";
	private BigInteger bancaABI =BigInteger.valueOf(0);
	private BigInteger bancaCAB =BigInteger.valueOf(0);
	private String bancaContoCorrente ="";
	private String postaContoCorrente ="";
	private String IBAN ="";
	private String BIC ="";
	// fhf private BigInteger periodoCarbontax =BigInteger.valueOf(0);
	private String periodoCarbontax = "A";
	private BigInteger tipoEsercente=BigInteger.valueOf(0);
	private BigInteger periodoDich=BigInteger.valueOf(0);
	private BigInteger totaleFileRecord  =BigInteger.valueOf(0);
	private BigInteger totaleRecordQuadroA =BigInteger.valueOf(0);
	private BigInteger flagQuadroB      =BigInteger.valueOf(0);
	private BigInteger totaleRecordQuadroC  =BigInteger.valueOf(0);
	private BigInteger numeroTotaleDatiContabili =BigInteger.valueOf(0);
	private BigInteger numeroSupportiDichiarazione =BigInteger.valueOf(0);
	
	
	/* commentato reply
	private String presentataProspettoCarbontaxStessoAnno="";
	private BigInteger totaleLitriConsumatiAutoveicoliMassaMassimaSupa3 =BigInteger.valueOf(0);
	private BigDecimal totaleImportoCreditoAutoveicoliMassaMassima3 =BigDecimal.valueOf(0,0);
	private BigInteger totaleLitriConsumatiAutoveicoliMassaMassimaNonInf11 =BigInteger.valueOf(0);
	private BigDecimal totaleImportoCreditoAutoveicoliMassaMassimaNonInf11 =BigDecimal.valueOf(0,0);
	*/
	
	// aggiunti reply
	private String flagAllegatoQuadroBbis="";
	
		
	/*private BigInteger totaleLitriConsumatiA1 =BigInteger.valueOf(0);
	private BigDecimal importoAcreditoA1 =BigDecimal.valueOf(0,0);
	private BigInteger totaleLitriConsumatiA2 =BigInteger.valueOf(0);
	private BigDecimal importoAcreditoA2 =BigDecimal.valueOf(0,0);*/
	
	private BigInteger[] arrayLitriConsumati;
	private BigDecimal[] arrayImportoACredito;
	
	//dichiarazione dimenzioni variabili
	private static final int dimCodUffTecnicoFinanza =20;                                                                    
	private static final int dimCognomeRappresentanteDichiarazione =24;                                                      
	private static final int dimNomeRappresentanteDichiarazione =20;                                                         
	private static final int dimCodicefiscaleRappresentanteDichiarazione =16;                                                
	private static final int dimQualificaRappresentanteDichiarazione =25;                                                    
	private static final int dimDenominazione =60;                                                                           
	private static final int dimProvinciaSedeLegale  =2;                                                                    
	private static final int dimComuneSedeLegale =45;                                                                        
	private static final int dimIndirizzoSedeLegale  =45;                                                                    
	private static final int dimProvinciaSedeAmministrativa =2;                                                             
	private static final int dimComuneSedeAmministrativa =45;                                                                
	private static final int dimIndirizzoSedeAmministrativa =45;                                                             
	private static final int dimCodiceAttivita =6;                                                                          
	private static final int dimEsercente  =1;                                                                              
	private static final int dimAutoTrasportoMerci =1;                                                                      
	private static final int dimEstremiLicenza =20;                                                                          
	private static final int dimAllegatiCertificatiImmatricolazione =5;                                                     
	private static final int dimAllegatiTitoliPossesso =5;                                                                  
	private static final int dimTotaleLitriCconsumati =12;                                                                   
	private static final int dimTotaleImportCreditoInt  =12;                                                                 
	private static final int dimTotaleImportCreditoDec  =2;                                                                 
	private static final int dimValuta =1;   
	private static final int dimModalitaFruizioneCredito =1;                                                                                  
	private static final int dimBancaABI =4;                                                                                
	private static final int dimBancaCAB =5;                                                                                
	private static final int dimBancaContoCorrente =20;                                                                      
	private static final int dimPostaContoCorrente =20;                                                                      
	private static final int dimIBAN =27;                                                                      
	private static final int dimBIC =13;                                                                      
	private static final int dimPeriodoCarbontax =1;                                                                        
	private static final int dimTipoEsercente=1;                                                                            
	private static final int dimTotaleFileRecord  =6;                                                                       
	private static final int dimTotaleecordQuadroA =4;                                                                      
	private static final int dimFlagQuadroB =4;                                                                        
	private static final int dimTotaleRecordQuadroC  =4;                                                                    
	private static final int dimNumeroSupportiDichiarazione =2;
	private static final int dimNumeroTotaleDatiContabili =4;
	private static final int dimPeriodoDich =3;
	              
	
	/*commentato reply                                                             
	private static final int dimPresentataProspettoCarbontaxStessoAnno=1;                                                   
	private static final int dimTotaleLitriConsumatiAutoveicoliMassaMassimaSupa3 =12;                                     
	private static final int dimTotaleImportoCreditoAutoveicoliMassaMassima3Int =12;  
	private static final int dimTotaleImportoCreditoAutoveicoliMassaMassima3Dec =2;                                     
	private static final int dimTotaleLitriConsumatiAutoveicoliMassaMassimaNonInf11 =12;                                     
	private static final int dimTotaleImportoCreditoAutoveicoliMassaMassimaNonInferiore11Int =12;                            
	private static final int dimTotaleImportoCreditoAutoveicoliMassaMassimaNonInf11Dec =2;     
	*/
	
	//	aggiunti reply
	private static final int dimFlagAllegatoQuadroBbis=1;
	private static final int dimTotaleLitriConsumatiA1 =12;
	private static final int dimImportoAcreditoA1Int =12;
	private static final int dimImportoAcreditoA1Dec =2;
	private static final int dimTotaleLitriConsumatiA2 = 12;
	private static final int dimImportoAcreditoA2Int = 12;
	private static final int dimImportoAcreditoA2Dec = 2;
	
	
	private static final int dimImportoAcreditoInt =12;
	private static final int dimImportoAcreditoDec =2;
	private static final int dimTotaleLitriConsumati =12;
	
	public void initArrayLitriImporti(int size){
		
		arrayLitriConsumati = new BigInteger[size];
		arrayImportoACredito  = new BigDecimal[size];
		
		for (int i = 0; i < size; i++) {
							
			arrayLitriConsumati[i]= BigInteger.valueOf(0);
			arrayImportoACredito[i]= BigDecimal.valueOf(0,0);
		}
	}
	
	public void scriviOggetto(java.io.OutputStream out) throws IOException {

		super.scriviOggetto(out);
		out.write(normalizzaCampo(codUffTecnicoFinanza, dimCodUffTecnicoFinanza));
		out.write(normalizzaCampo(cognomeRappresentanteDichiarazione, dimCognomeRappresentanteDichiarazione));
		out.write(normalizzaCampo(nomeRappresentanteDichiarazione, dimNomeRappresentanteDichiarazione));
		out.write(normalizzaCampo(codicefiscaleRappresentanteDichiarazione, dimCodicefiscaleRappresentanteDichiarazione));
		out.write(normalizzaCampo(qualificaRappresentanteDichiarazione, dimQualificaRappresentanteDichiarazione));
		out.write(normalizzaCampo(denominazione, dimDenominazione));
		out.write(normalizzaCampo(provinciaSedeLegale, dimProvinciaSedeLegale));
		out.write(normalizzaCampo(comuneSedeLegale, dimComuneSedeLegale));
		out.write(normalizzaCampo(indirizzoSedeLegale, dimIndirizzoSedeLegale));
		out.write(normalizzaCampo(provinciaSedeAmministrativa, dimProvinciaSedeAmministrativa));
		out.write(normalizzaCampo(comuneSedeAmministrativa, dimComuneSedeAmministrativa));
		out.write(normalizzaCampo(indirizzoSedeAmministrativa, dimIndirizzoSedeAmministrativa));
		out.write(normalizzaCampo(codiceAttivita , dimCodiceAttivita));
		out.write(normalizzaCampo(esercente, dimEsercente));
		out.write(normalizzaCampo(autoTrasportoMerci, dimAutoTrasportoMerci));
		out.write(normalizzaCampo(estremiLicenza, dimEstremiLicenza));
		out.write(normalizzaCampo(allegatiCertificatiImmatricolazione, dimAllegatiCertificatiImmatricolazione));
		out.write(normalizzaCampo(allegatiTitoliPossesso, dimAllegatiTitoliPossesso));
		out.write(normalizzaCampo(totaleLitriConsumati, dimTotaleLitriCconsumati));
		out.write(normalizzaCampo(totaleImportCredito, dimTotaleImportCreditoInt, dimTotaleImportCreditoDec));
		out.write(normalizzaCampo(valuta ,dimValuta));
		scriviFruizioneDelCredito(out);
		//out.write(normalizzaCampo("A" /* periodoCarbontax */, dimPeriodoCarbontax)); // 2007, forzato ad A
		out.write(normalizzaCampo(periodoDich, dimPeriodoDich));//Periodo: (11) per dichiarazione 2008
		
		out.write(normalizzaCampo(tipoEsercente, dimTipoEsercente));
		
		
		out.write(normalizzaCampo(BigInteger.valueOf(totaleFileRecord.intValue()+numeroTotaleDatiContabili.intValue()), dimTotaleFileRecord));
		out.write(normalizzaCampo(totaleRecordQuadroA, dimTotaleRecordQuadroC));
		out.write(normalizzaCampo(flagQuadroB, dimFlagQuadroB));
		out.write(normalizzaCampo(totaleRecordQuadroC, dimTotaleRecordQuadroC));	
			
		out.write(normalizzaCampo(numeroTotaleDatiContabili, dimNumeroTotaleDatiContabili));
		out.write(normalizzaCampo(numeroSupportiDichiarazione, dimNumeroSupportiDichiarazione));
		
		// modifica reply
		//out.write(normalizzaCampo( flagAllegatoQuadroBbis, dimFlagAllegatoQuadroBbis) );
		
		/*out.write(normalizzaCampo( totaleLitriConsumatiA1, dimTotaleLitriConsumatiA1) );
		out.write(normalizzaCampo( importoAcreditoA1, dimImportoAcreditoA1Int, dimImportoAcreditoA1Dec) );
		out.write(normalizzaCampo( totaleLitriConsumatiA2, dimTotaleLitriConsumatiA2) );
		out.write(normalizzaCampo( importoAcreditoA2, dimImportoAcreditoA2Int, dimImportoAcreditoA2Dec ) );
		*/
		
		/*for (int i = 0; i < arrayImportoACredito.length; i++) {
			
			out.write(normalizzaCampo(arrayLitriConsumati[i], dimTotaleLitriConsumati) );
			out.write(normalizzaCampo( arrayImportoACredito[i], dimImportoAcreditoInt, dimImportoAcreditoDec) );
			
		}*/
		
		scriviFineRiga(out);
	}    
	
	
	
	/**
	 * @param out
	 */
	private void scriviFruizioneDelCredito(OutputStream out) throws IOException {
		String tmp = "";
		if(modalitaFruizioneCredito.equals("1")) {
			bancaABI = BigInteger.ZERO;
			bancaCAB = BigInteger.ZERO;
		} else if(modalitaFruizioneCredito.equals("2")) {
			tmp = bancaContoCorrente;
		} else if(modalitaFruizioneCredito.equals("3")) {
			bancaABI = BigInteger.ZERO;
			bancaCAB = BigInteger.ZERO;
			tmp = new String(normalizzaCampo("", dimBancaContoCorrente)) + postaContoCorrente;
		} else if(modalitaFruizioneCredito.equals("4")) {
			bancaABI = BigInteger.ZERO;
			bancaCAB = BigInteger.ZERO;
			tmp = new String(normalizzaCampo(IBAN, dimIBAN)) + BIC;
		}

		out.write(normalizzaCampo(modalitaFruizioneCredito, dimModalitaFruizioneCredito));
		out.write(normalizzaCampo(bancaABI, dimBancaABI));
		out.write(normalizzaCampo(bancaCAB, dimBancaCAB));
		out.write(normalizzaCampo(tmp, dimBancaContoCorrente+dimPostaContoCorrente));
	}

	public void leggiOggetto(java.io.InputStream in) throws IOException {

		super.leggiOggetto(in);

		codUffTecnicoFinanza = readFieldString(in, dimCodUffTecnicoFinanza);                                                                    
		cognomeRappresentanteDichiarazione = readFieldString(in, dimCognomeRappresentanteDichiarazione);                                                     
		nomeRappresentanteDichiarazione = readFieldString(in, dimNomeRappresentanteDichiarazione);                                                         
		codicefiscaleRappresentanteDichiarazione = readFieldString(in, dimCodicefiscaleRappresentanteDichiarazione);                                                
		qualificaRappresentanteDichiarazione = readFieldString(in, dimQualificaRappresentanteDichiarazione);                                                    
		denominazione = readFieldString(in, dimDenominazione);                                                                          
		provinciaSedeLegale = readFieldString(in, dimProvinciaSedeLegale );                                                                   
		comuneSedeLegale = readFieldString(in, dimComuneSedeLegale  );                                                                      
		indirizzoSedeLegale = readFieldString(in, dimIndirizzoSedeLegale  );                                                                  
		provinciaSedeAmministrativa   = readFieldString(in, dimProvinciaSedeAmministrativa );                                                          
		comuneSedeAmministrativa = readFieldString(in, dimComuneSedeAmministrativa  );                                                              
		indirizzoSedeAmministrativa = readFieldString(in, dimIndirizzoSedeAmministrativa );                                                            
		codiceAttivita = readFieldString(in,  dimCodiceAttivita            );                                                            
		esercente = readFieldString(in, dimEsercente );                                                                             
		autoTrasportoMerci = readFieldString(in, dimAutoTrasportoMerci );                                                                     
		estremiLicenza = readFieldString(in, dimEstremiLicenza );                                                                         
		allegatiCertificatiImmatricolazione = readFieldBigInteger(in, dimAllegatiCertificatiImmatricolazione);                                                     
		allegatiTitoliPossesso = readFieldBigInteger(in, dimAllegatiTitoliPossesso   );                                                              
		totaleLitriConsumati = readFieldBigInteger(in, dimTotaleLitriCconsumati );                                                                  
		totaleImportCredito = readFieldBigDecimal(in, dimTotaleImportCreditoInt, dimTotaleImportCreditoDec);                                                                   
		valuta = readFieldString(in,  dimValuta  );                                                                             
		modalitaFruizioneCredito = readFieldString(in, dimModalitaFruizioneCredito);                                                                
		bancaABI =readFieldBigInteger(in,dimBancaABI  );                                                                            
		bancaCAB= readFieldBigInteger(in, dimBancaCAB );
		if(modalitaFruizioneCredito.equals("4")) {                                                                               
			IBAN = readFieldString(in,dimIBAN );			                                                                   
			BIC = readFieldString(in, dimBIC );                                                                     
		} else {
			bancaContoCorrente = readFieldString(in,dimBancaContoCorrente );                                                                     
			postaContoCorrente = readFieldString(in, dimPostaContoCorrente );                                                                     
		}
	//	periodoCarbontax =readFieldBigInteger(in, dimPeriodoCarbontax );     
		//periodoCarbontax=readFieldString(in,dimPeriodoCarbontax); 		
		
		periodoDich = readFieldBigInteger(in,dimPeriodoDich);     
		                                                                
		tipoEsercente = readFieldBigInteger(in, dimTipoEsercente  );                                                                        
		totaleFileRecord = readFieldBigInteger(in, dimTotaleFileRecord   );                                                                     
		totaleRecordQuadroA = readFieldBigInteger(in, dimTotaleecordQuadroA  );                                                                    
		flagQuadroB = readFieldBigInteger(in, dimFlagQuadroB  );                                                                           
		totaleRecordQuadroC = readFieldBigInteger(in, dimTotaleRecordQuadroC  ); 
		                                                                  
		numeroTotaleDatiContabili = readFieldBigInteger(in, dimNumeroTotaleDatiContabili );		
		numeroSupportiDichiarazione = readFieldBigInteger(in, dimNumeroSupportiDichiarazione );
		
		// modificato reply                                                      
		//flagAllegatoQuadroBbis = readFieldString(in, dimFlagAllegatoQuadroBbis ); 
		
		/*                                                
		totaleLitriConsumatiA1 = readFieldBigInteger(in, dimTotaleLitriConsumatiA1 );                                      
		importoAcreditoA1 = readFieldBigDecimal(in, dimImportoAcreditoA1Int, dimImportoAcreditoA1Dec);                                        
		totaleLitriConsumatiA2 = readFieldBigInteger(in, dimTotaleLitriConsumatiA2  );                                  
		importoAcreditoA2 = readFieldBigDecimal(in, dimImportoAcreditoA2Int, dimImportoAcreditoA2Dec); 
				
		*/
		
		/*for (int i = 0; i < arrayImportoACredito.length; i++) {
			
			arrayLitriConsumati[i] = readFieldBigInteger(in, dimTotaleLitriConsumati );    
			arrayImportoACredito[i]= readFieldBigDecimal(in, dimImportoAcreditoInt, dimImportoAcreditoDec); 
			
		}*/
		
		
		 
		/*if(VisualConfig.QUADRO_A2_OPZIONE_SELEZIONATA==VisualConfig.QUADRO_A2_DISABLED
		   && VisualConfig.ANNO_DI_RIFERIMENTO.equals("2007")){
			//FHF
			//importoAcreditoA1=importoAcreditoA1.add(importoAcreditoA2);
			importoAcreditoA2=new BigDecimal(0);
			//totaleLitriConsumatiA1=totaleLitriConsumatiA1.add(totaleLitriConsumatiA2);
			totaleLitriConsumatiA2=new BigInteger("0");	
		}*/
		
		
	/*	if(Contatori.ANNO_IN_LETTURA==2006){
			importoAcreditoA1=new BigDecimal(0);
			totaleLitriConsumatiA1=new BigInteger("0");
		   Contatori.ANNO_IN_LETTURA=2007;
		}*/;
		                                
  		// fine
		
		saltaFineRiga(in);
	}                       


	
	

	/**
	 * @return
	 */
	public static int getDimAllegatiCertificatiImmatricolazione() {
		return dimAllegatiCertificatiImmatricolazione;
	}

	/**
	 * @return
	 */
	public static int getDimAllegatiTitoliPossesso() {
		return dimAllegatiTitoliPossesso;
	}

	/**
	 * @return
	 */
	public static int getDimAutoTrasportoMerci() {
		return dimAutoTrasportoMerci;
	}

	/**
	 * @return
	 */
	public static int getDimBancaABI() {
		return dimBancaABI;
	}

	/**
	 * @return
	 */
	public static int getDimBancaCAB() {
		return dimBancaCAB;
	}

	/**
	 * @return
	 */
	public static int getDimBancaContoCorrente() {
		return dimBancaContoCorrente;
	}
	
	//modifica 07/08/2008 inserimento metodo getDimIban()
	/**
	 * @return
	 */
	public static int getDimIban() {
		return dimIBAN;
	}

	/**
	 * @return
	 */
	public static int getDimCodiceAttivita() {
		return dimCodiceAttivita;
	}

	/**
	 * @return
	 */
	public static int getDimCodicefiscaleRappresentanteDichiarazione() {
		return dimCodicefiscaleRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public static int getDimCodUffTecnicoFinanza() {
		return dimCodUffTecnicoFinanza;
	}

	/**
	 * @return
	 */
	public static int getDimCognomeRappresentanteDichiarazione() {
		return dimCognomeRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public static int getDimComuneSedeAmministrativa() {
		return dimComuneSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public static int getDimComuneSedeLegale() {
		return dimComuneSedeLegale;
	}

	/**
	 * @return
	 */
	public static int getDimDenominazione() {
		return dimDenominazione;
	}

	/**
	 * @return
	 */
	public static int getDimEsercente() {
		return dimEsercente;
	}

	/**
	 * @return
	 */
	public static int getDimEstremiLicenza() {
		return dimEstremiLicenza;
	}

	/**
	 * @return
	 */
	public static int getDimFlagQuadroB() {
		return dimFlagQuadroB;
	}

	/**
	 * @return
	 */
	public static int getDimIndirizzoSedeAmministrativa() {
		return dimIndirizzoSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public static int getDimIndirizzoSedeLegale() {
		return dimIndirizzoSedeLegale;
	}

	/**
	 * @return
	 */
	public static int getDimModalitaFruizioneCredito() {
		return dimModalitaFruizioneCredito;
	}

	/**
	 * @return
	 */
	public static int getDimNomeRappresentanteDichiarazione() {
		return dimNomeRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public static int getDimNumeroSupportiDichiarazione() {
		return dimNumeroSupportiDichiarazione;
	}

	/**
	 * @return
	 */
	public static int getDimPeriodoCarbontax() {
		return dimPeriodoCarbontax;
	}

	/**
	 * @return
	 */
	public static int getDimPostaContoCorrente() {
		return dimPostaContoCorrente;
	}


	/**
	 * @return
	 */
	public static int getDimProvinciaSedeAmministrativa() {
		return dimProvinciaSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public static int getDimProvinciaSedeLegale() {
		return dimProvinciaSedeLegale;
	}

	/**
	 * @return
	 */
	public static int getDimQualificaRappresentanteDichiarazione() {
		return dimQualificaRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public static int getDimTipoEsercente() {
		return dimTipoEsercente;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleecordQuadroA() {
		return dimTotaleecordQuadroA;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleFileRecord() {
		return dimTotaleFileRecord;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleImportCreditoDec() {
		return dimTotaleImportCreditoDec;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleImportCreditoInt() {
		return dimTotaleImportCreditoInt;
	}


	/**
	 * @return
	 */
	public static int getDimTotaleLitriCconsumati() {
		return dimTotaleLitriCconsumati;
	}


	/**
	 * @return
	 */
	public static int getDimTotaleRecordQuadroC() {
		return dimTotaleRecordQuadroC;
	}

	/**
	 * @return
	 */
	public static int getDimValuta() {
		return dimValuta;
	}

	/**
	 * @return
	 */
	public BigInteger getAllegatiCertificatiImmatricolazione() {
		return allegatiCertificatiImmatricolazione;
	}

	/**
	 * @return
	 */
	public BigInteger getAllegatiTitoliPossesso() {
		return allegatiTitoliPossesso;
	}

	/**
	 * @return
	 */
	public String getAutoTrasportoMerci() {
		return autoTrasportoMerci;
	}

	/**
	 * @return
	 */
	public BigInteger getBancaABI() {
		return bancaABI;
	}

	/**
	 * @return
	 */
	public BigInteger getBancaCAB() {
		return bancaCAB;
	}

	/**
	 * @return
	 */
	public String getBancaContoCorrente() {
		return bancaContoCorrente;
	}

	/**
	 * @return
	 */
	public String getCodiceAttivita() {
		return codiceAttivita;
	}

	/**
	 * @return
	 */
	public String getCodicefiscaleRappresentanteDichiarazione() {
		return codicefiscaleRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public String getCodUffTecnicoFinanza() {
		return codUffTecnicoFinanza;
	}

	/**
	 * @return
	 */
	public String getCognomeRappresentanteDichiarazione() {
		return cognomeRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public String getComuneSedeAmministrativa() {
		return comuneSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public String getComuneSedeLegale() {
		return comuneSedeLegale;
	}

	/**
	 * @return
	 */
	public String getDenominazione() {
		return denominazione;
	}

	/**
	 * @return
	 */
	public String getEsercente() {
		return esercente;
	}

	/**
	 * @return
	 */
	public String getEstremiLicenza() {
		return estremiLicenza;
	}

	/**
	 * @return
	 */
	public BigInteger getFlagQuadroB() {
		return flagQuadroB;
	}

	/**
	 * @return
	 */
	public String getIndirizzoSedeAmministrativa() {
		return indirizzoSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public String getIndirizzoSedeLegale() {
		return indirizzoSedeLegale;
	}

	/**
	 * @return
	 */
	public String getModalitaFruizioneCredito() {
		return modalitaFruizioneCredito;
	}

	/**
	 * @return
	 */
	public String getNomeRappresentanteDichiarazione() {
		return nomeRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroSupportiDichiarazione() {
		return numeroSupportiDichiarazione;
	}

//	/**
//	 * @return
//	 */
//	public BigInteger getPeriodoCarbontax() {
//		return periodoCarbontax;
//	}
	/**
	 * @return
	 */
	public String getPeriodoCarbontax() {
		return periodoCarbontax;
	}
	/**
	 * @return
	 */
	public String getPostaContoCorrente() {
		return postaContoCorrente;
	}


	/**
	 * @return
	 */
	public String getProvinciaSedeAmministrativa() {
		return provinciaSedeAmministrativa;
	}

	/**
	 * @return
	 */
	public String getProvinciaSedeLegale() {
		return provinciaSedeLegale;
	}

	/**
	 * @return
	 */
	public String getQualificaRappresentanteDichiarazione() {
		return qualificaRappresentanteDichiarazione;
	}

	/**
	 * @return
	 */
	public BigInteger getTipoEsercente() {
		return tipoEsercente;
	}

	/**
	 * @return
	 */
	public BigInteger getTotaleFileRecord() {
		return totaleFileRecord;
	}

	/**
	 * @return
	 */
	public BigDecimal getTotaleImportCredito() {
		return totaleImportCredito;
	}


	/**
	 * @return
	 */
	public BigInteger getTotaleLitriConsumati() {
		return totaleLitriConsumati;
	}


	/**
	 * @return
	 */
	public BigInteger getTotaleRecordQuadroA() {
		return totaleRecordQuadroA;
	}

	/**
	 * @return
	 */
	public BigInteger getTotaleRecordQuadroC() {
		return totaleRecordQuadroC;
	}

	/**
	 * @return
	 */
	public String getValuta() {
		return valuta;
	}

	/**
	 * @param i
	 */
	
	/**
	 * @param integer
	 */
	public void setAllegatiCertificatiImmatricolazione(BigInteger integer) {
		allegatiCertificatiImmatricolazione = integer;
	}

	/**
	 * @param integer
	 */
	public void setAllegatiTitoliPossesso(BigInteger integer) {
		allegatiTitoliPossesso = integer;
	}

	/**
	 * @param string
	 */
	public void setAutoTrasportoMerci(String string) {
		autoTrasportoMerci = string;
	}

	/**
	 * @param integer
	 */
	public void setBancaABI(BigInteger integer) {
		bancaABI = integer;
	}

	/**
	 * @param integer
	 */
	public void setBancaCAB(BigInteger integer) {
		bancaCAB = integer;
	}

	/**
	 * @param string
	 */
	public void setBancaContoCorrente(String string) {
		bancaContoCorrente = string;
	}

	/**
	 * @param string
	 */
	public void setCodiceAttivita(String string) {
		codiceAttivita = string;
	}

	/**
	 * @param string
	 */
	public void setCodicefiscaleRappresentanteDichiarazione(String string) {
		codicefiscaleRappresentanteDichiarazione = string;
	}

	/**
	 * @param string
	 */
	public void setCodUffTecnicoFinanza(String string) {
		codUffTecnicoFinanza = string;
	}

	/**
	 * @param string
	 */
	public void setCognomeRappresentanteDichiarazione(String string) {
		cognomeRappresentanteDichiarazione = string;
	}

	/**
	 * @param string
	 */
	public void setComuneSedeAmministrativa(String string) {
		comuneSedeAmministrativa = string;
	}

	/**
	 * @param string
	 */
	public void setComuneSedeLegale(String string) {
		comuneSedeLegale = string;
	}

	/**
	 * @param string
	 */
	public void setDenominazione(String string) {
		denominazione = string;
	}

	/**
	 * @param string
	 */
	public void setEsercente(String string) {
		esercente = string;
	}

	/**
	 * @param string
	 */
	public void setEstremiLicenza(String string) {
		estremiLicenza = string;
	}

	/**
	 * @param integer
	 */
	public void setFlagQuadroB(BigInteger integer) {
		flagQuadroB = integer;
	}

	/**
	 * @param string
	 */
	public void setIndirizzoSedeAmministrativa(String string) {
		indirizzoSedeAmministrativa = string;
	}

	/**
	 * @param string
	 */
	public void setIndirizzoSedeLegale(String string) {
		indirizzoSedeLegale = string;
	}

	/**
	 * @param string
	 */
	public void setModalitaFruizioneCredito(String string) {
		modalitaFruizioneCredito = string;
	}

	/**
	 * @param string
	 */
	public void setNomeRappresentanteDichiarazione(String string) {
		nomeRappresentanteDichiarazione = string;
	}

	/**
	 * @param integer
	 */
	public void setNumeroSupportiDichiarazione(BigInteger integer) {
		numeroSupportiDichiarazione = integer;
	}

//	/**
//	 * @param integer
//	 */
//	public void setPeriodoCarbontax(BigInteger integer) {
//		periodoCarbontax = integer;
//	}
	/**
	 * @param integer
	 */
	public void setPeriodoCarbontax(String integer) {
		periodoCarbontax = integer;
	}
	/**
	 * @param string
	 */
	public void setPostaContoCorrente(String string) {
		postaContoCorrente = string;
	}


	/**
	 * @param string
	 */
	public void setProvinciaSedeAmministrativa(String string) {
		provinciaSedeAmministrativa = string;
	}

	/**
	 * @param string
	 */
	public void setProvinciaSedeLegale(String string) {
		provinciaSedeLegale = string;
	}

	/**
	 * @param string
	 */
	public void setQualificaRappresentanteDichiarazione(String string) {
		qualificaRappresentanteDichiarazione = string;
	}

	/**
	 * @param integer
	 */
	public void setTipoEsercente(BigInteger integer) {
		tipoEsercente = integer;
	}

	/**
	 * @param integer
	 */
	public void setTotaleFileRecord(BigInteger integer) {
		totaleFileRecord = integer;
	}

	/**
	 * @param decimal
	 */
	public void setTotaleImportCredito(BigDecimal decimal) {
		totaleImportCredito = decimal;
	}


	/**
	 * @param integer
	 */
	public void setTotaleLitriConsumati(BigInteger integer) {
		totaleLitriConsumati = integer;
	}


	/**
	 * @param integer
	 */
	public void setTotaleRecordQuadroA(BigInteger integer) {
		totaleRecordQuadroA = integer;
	}

	/**
	 * @param integer
	 */
	public void setTotaleRecordQuadroC(BigInteger integer) {
		totaleRecordQuadroC = integer;
	}

	/**
	 * @param string
	 */
	public void setValuta(String string) {
		valuta = string;
	}

	public BigInteger getTipoRecord() {
		return BigInteger.ZERO;
	}


	/**
	 * @return
	 */
	public String getBIC() {
		return BIC;
	}

	/**
	 * @return
	 */
	public String getIBAN() {
		return IBAN;
	}

	/**
	 * @param string
	 */
	public void setBIC(String string) {
		BIC = string;
	}

	/**
	 * @param string
	 */
	public void setIBAN(String string) {
		IBAN = string;
	}

	/**
	 * @return
	 */
	public static int getDimFlagAllegatoQuadroBbis() {
		return dimFlagAllegatoQuadroBbis;
	}

	/**
	 * @return
	 */
	public static int getDimImportoAcreditoA1Dec() {
		return dimImportoAcreditoA1Dec;
	}

	/**
	 * @return
	 */
	public static int getDimImportoAcreditoA1Int() {
		return dimImportoAcreditoA1Int;
	}

	/**
	 * @return
	 */
	public static int getDimImportoAcreditoA2Dec() {
		return dimImportoAcreditoA2Dec;
	}

	/**
	 * @return
	 */
	public static int getDimImportoAcreditoA2Int() {
		return dimImportoAcreditoA2Int;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleLitriConsumatiA1() {
		return dimTotaleLitriConsumatiA1;
	}

	/**
	 * @return
	 */
	public static int getDimTotaleLitriConsumatiA2() {
		return dimTotaleLitriConsumatiA2;
	}

	/**
	 * @return
	 */
	public String getFlagAllegatoQuadroBbis() {
		return flagAllegatoQuadroBbis;
	}

	/**
	 * @return
	 */
	/*public BigDecimal getImportoAcreditoA1() {
		return importoAcreditoA1;
	}

	
	public BigDecimal getImportoAcreditoA2() {
		return importoAcreditoA2;
	}

	public BigInteger getTotaleLitriConsumatiA1() {
		return totaleLitriConsumatiA1;
	}

	
	public BigInteger getTotaleLitriConsumatiA2() {
		return totaleLitriConsumatiA2;
	}

	

	
	public void setImportoAcreditoA1(BigDecimal decimal) {
		importoAcreditoA1 = decimal;
	}

	
	public void setImportoAcreditoA2(BigDecimal decimal) {
		importoAcreditoA2 = decimal;
	}

	
	public void setTotaleLitriConsumatiA1(BigInteger integer) {
		totaleLitriConsumatiA1 = integer;
	}

	
	public void setTotaleLitriConsumatiA2(BigInteger integer) {
		totaleLitriConsumatiA2 = integer;
	}*/
	
	public void setFlagAllegatoQuadroBbis(String string) {
		flagAllegatoQuadroBbis = string;
	}

	/**
	 * @return
	 */
	public BigInteger[] getArrayLitriConsumati() {
		return arrayLitriConsumati;
	}

	/**
	 * @param integers
	 */
	public void setArrayLitriConsumati(int indice, BigInteger integer) {
		arrayLitriConsumati[indice] = integer;
	}

	/**
	 * @return
	 */
	public BigDecimal[] getArrayImportoACredito() {
		return arrayImportoACredito;
	}

	/**
	 * @param integers
	 */
	public void setArrayImportoACredito(int indice, BigDecimal decimal) {
		arrayImportoACredito[indice] = decimal ;
	}
	
	public BigDecimal getValoreImportoACredito(int indice) {
		return arrayImportoACredito[indice];
	}
	
	public BigInteger getValoreLitriConsumati(int indice) {
		return arrayLitriConsumati[indice];
	}

	/**
	 * @return
	 */
	public BigInteger getPeriodoDich() {
		return periodoDich;
	}

	/**
	 * @param integer
	 */
	public void setPeriodoDich(BigInteger integer) {
		periodoDich = integer;
	}

	/**
	 * @return
	 */
	public BigInteger getNumeroTotaleDatiContabili() {
		return numeroTotaleDatiContabili;
	}

	/**
	 * @param integer
	 */
	public void setNumeroTotaleDatiContabili(BigInteger integer) {
		numeroTotaleDatiContabili = integer;
	}

}
