

package it.finanze.dogane.accise.aautotrasportatori.pdf;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroB;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriRecord;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriFrame;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoUfficio;
import it.finanze.dogane.accise.pdf.AbstractPdfProspectWriter;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;

import java.awt.Color;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.lowagie.text.Cell;
import com.lowagie.text.Chunk;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Element;
import com.lowagie.text.Font;
import com.lowagie.text.Paragraph;
import com.lowagie.text.Rectangle;
import com.lowagie.text.Table;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.Phrase;

public class PdfProspectWriter extends AbstractPdfProspectWriter
{

	public PdfProspectWriter()
	{
	}
	
	public List getListaRecord(GestoreQuadro gestoreQuadro){
		
		Quadro quadro = ((Quadro)gestoreQuadro);
		int[]tipoRecord = this.getTipiRecord(gestoreQuadro);
		
		List list = null;	
		
		
		ProspettoConsumo prospetto = quadro.getProspettoConsumo();
		if(prospetto == null)
			return new ArrayList();
			
			
		if(tipoRecord[0] == Quadro.QUADRO_A[0])
			list = prospetto.getListaQuadroA( quadro.getTipoQuadroA() );
			
		if(tipoRecord[0] == Quadro.QUADRO_B[0])
			list = prospetto.getListaQuadro( tipoRecord );
			
		if(tipoRecord[0] == Quadro.QUADRO_C[0])
			list = prospetto.getListaQuadro( tipoRecord );
			
		
		
		return list;
	}
	
	public int[] getHeaderWidths(int[]tipoRecord){		
		
		if(tipoRecord[0] == Quadro.QUADRO_A[0])
			return new int[]{ 22, 9, 11, 10, 9, 10, 11, 9, 9 };
			
		if(tipoRecord[0] == Quadro.QUADRO_C[0])
			return new int[]{ 25, 25,25,25 };
			
		return null;
	}
	
	public String[] getColumnNames(int[]tipoRecord){
		
				
		if(tipoRecord[0] == Quadro.QUADRO_A[0])
			return new String[]{"Targa","Titolo possesso","Data inizio possesso","Data fine possesso","Numero fatture",
								"Numero schede","Litri consumati","Km percorsi","Importo"}; 
		
		if(tipoRecord[0] == Quadro.QUADRO_C[0])
				return new String[]{"Targa","Tipo autoveicolo","Data inizio possesso","Data fine possesso"};
		
		return null;
	}
	public String getSecondTitle(int[]tipoRecord){
		
				
		if(tipoRecord[0] == Quadro.QUADRO_A[0]){
			//String massaA = "Autoveicoli adibiti al trasporto merci con massa massima complessiva superiore A 3.5T/\nAutoveicoli adibiti a trasporto di persone\n";
			String massaA = "Autoveicoli adibiti al trasporto merci con massa massima complessiva pari o superiore A 7.5T/\nAutoveicoli adibiti a trasporto di persone\n";
			return new String(massaA); 
		}
		if(tipoRecord[0] == Quadro.QUADRO_B[0]){		
			return new String("ESERCENTE CON DISTRIBUTORE PRIVATO DI CARBURANTE"); 
		}	
			
		if(tipoRecord[0] == Quadro.QUADRO_C[0]){
			return new String("Altri automezzi, riforniti a mezzo distributore privato (Quadro B),\n non aventi titolo alla riduzione degli oneri\n"); 
		}
			
		return null;
	}
	
	protected void gestionePrintQuadroB(Quadro quadro,int[]tipoRecord, List lista, PdfBuilder pdfBuilder)
	{
		
		List listaSup10 = new ArrayList();
		List listaInf10 = new ArrayList();
		
		for (Iterator iter = lista.iterator(); iter.hasNext();) {
			
			AutotrasportatoriQuadroB element = (AutotrasportatoriQuadroB) iter.next();
			
				
			if(element.getTipoSerbatoio().equalsIgnoreCase("A")){				
				listaSup10.add(element);			
									
			}else if(element.getTipoSerbatoio().equalsIgnoreCase("B")){				
				listaInf10.add(element);								
			}
	   }//for	
	   
		   if(listaSup10.size() > 0){
				printQuadroBSup10(quadro,tipoRecord,listaSup10,pdfBuilder);
				if(listaInf10.size() > 0)
					pdfBuilder.newPage();	
		   }
				
		   if(listaInf10.size() > 0){				
				printQuadroBInf10(quadro,tipoRecord,listaInf10,pdfBuilder);	
			   	
	   }
	  		
	   
	}		
		
	protected void printQuadroBInf10(Quadro quadro,int[]tipoRecord, List lista, PdfBuilder pdfBuilder)
	{
				
		String	title=quadro.getTitle();
		
		Font font = new Font(Font.BOLD,19f,1);
		Chunk chunkQuadro = new Chunk(title+"\n",font);
		Phrase phrase1 = new Phrase(chunkQuadro);
		
		Paragraph paragraph = new Paragraph();
		paragraph.add(phrase1);
		
		
		Font font2 = new Font(Font.BOLD,18f,1);
		Paragraph paragraph2 = new Paragraph();
		
		Chunk chunkAutoveicoli = new Chunk(this.getSecondTitle(tipoRecord)+"\n",font2);
		Phrase phrase2 = new Phrase(chunkAutoveicoli);
		paragraph2.add(phrase2);
		paragraph2.setAlignment(Element.ALIGN_CENTER);
		
		
		font = new Font(Font.TIMES_ROMAN,17f);
		Paragraph paragraph3 = new Paragraph();
		
		
		
		AutotrasportatoriQuadroB recordGasolio = (AutotrasportatoriQuadroB) lista.get(0);
		String gasolio = "";
		if(recordGasolio.getGasolioUtilizzatoRifornimAutovQuadroA().equalsIgnoreCase("S"))
			gasolio ="SI";
		else if(recordGasolio.getGasolioUtilizzatoRifornimAutovQuadroA().equalsIgnoreCase("N"))
			gasolio ="NO";
			
		Chunk chunk3 = new Chunk("\nGasolio utilizzato per il rifornimento dei soli autoveicoli presenti nel QUADRO A: "+gasolio,font);
		Phrase phrase3 = new Phrase(chunk3);
		paragraph3.add(phrase3);
		paragraph3.setAlignment(Element.ALIGN_LEFT);
		paragraph3.setIndentationLeft(20f);
		
		font = new Font(Font.BOLD,17f,Font.BOLD);
		Paragraph paragraph4 = new Paragraph();
	
		Chunk chunk4 = new Chunk("\nDistributore collegato con serbatoio/i avente capacit inferiore o pari a 10 mc:\n\n",font);
		Phrase phrase4 = new Phrase(chunk4);
		paragraph4.add(phrase4);
		paragraph4.setAlignment(Element.ALIGN_LEFT);
		paragraph4.setIndentationLeft(20f);
		
		
		
		font = new Font(Font.TIMES_ROMAN,17f,Font.BOLD);
		int numColumns = 3;
		
		PdfPCell cell = null;
		
		try {
			
			pdfBuilder.getDocument().add(paragraph);		
			pdfBuilder.getDocument().add(paragraph2);
			pdfBuilder.getDocument().add(paragraph3);
			pdfBuilder.getDocument().add(paragraph4);
			
			int headerwidths[] = new int[]{45,10,45};	
			PdfPTable table = new PdfPTable(3);		
			table.setWidths(headerwidths);
			table.setWidthPercentage(95); 
			cell = table.getDefaultCell();
			cell.setBorderWidth(2);
			cell.setPadding(0);
			cell.setBorderWidth(1);			
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setBackgroundColor(new Color(244,244,244));
			
			int intHeight = 50;
			
			PdfPTable nested1 = new PdfPTable(numColumns);			
			PdfPCell cellNested1 = nested1.getDefaultCell();
			
			cellNested1.setFixedHeight(intHeight);
			
			cellNested1.setPadding(5);
			cellNested1.setBorderWidth(2);			
			cellNested1.setHorizontalAlignment(Element.ALIGN_CENTER);
			cellNested1.setBackgroundColor(new Color(244,244,244));
			cellNested1.setColspan(3);	
			
					
			Chunk chunkNested1 = new Chunk("Ubicazione impianto:",font);
			Phrase phraseNested1  = new Phrase(chunkNested1);				
			nested1.addCell(phraseNested1);
			cellNested1.setColspan(1);
			chunkNested1 = new Chunk("Provincia",font);
			phraseNested1  = new Phrase(chunkNested1);	
			nested1.addCell(phraseNested1);
			chunkNested1 = new Chunk("Comune",font);
			phraseNested1  = new Phrase(chunkNested1);	
			nested1.addCell(phraseNested1);
			chunkNested1 = new Chunk("Indirizzo",font);
			phraseNested1  = new Phrase(chunkNested1);	
			nested1.addCell(phraseNested1);
			
					
			
			
				
			
			
			
			PdfPTable nested2 = new PdfPTable(3);			
			PdfPCell cellNested2 = nested2.getDefaultCell();
			cellNested2.setFixedHeight(intHeight);
			
			cellNested2.setPadding(5);
			cellNested2.setBorderWidth(2);				
			cellNested2.setHorizontalAlignment(Element.ALIGN_CENTER);
			cellNested2.setBackgroundColor(new Color(244,244,244));
			cellNested2.setColspan(3);	
					
			Chunk chunkNested2 = new Chunk("Fatture di acquisto del gasolio:",font);
			Phrase phraseNested2  = new Phrase(chunkNested2);				
			nested2.addCell(phraseNested2);
			cellNested2.setColspan(1);
			
			chunkNested2 = new Chunk("Numero fatture",font);
			phraseNested2  = new Phrase(chunkNested2);	
			nested2.addCell(phraseNested2);
			chunkNested2 = new Chunk("Totale litri fatturati",font);
			phraseNested2  = new Phrase(chunkNested2);	
			nested2.addCell(phraseNested2);
			chunkNested2 = new Chunk("Totale importo (euro)",font);
			phraseNested2  = new Phrase(chunkNested2);	
			nested2.addCell(phraseNested2);
			
			
			PdfPTable nested3 = new PdfPTable(1);
			PdfPCell cellNested3 = nested3.getDefaultCell();		
			cellNested3.setFixedHeight(intHeight);
			
			
			cellNested3.setBackgroundColor(new Color(244,244,244));
			cellNested3.setHorizontalAlignment(Element.ALIGN_CENTER);
			cellNested3.setVerticalAlignment(Element.ALIGN_MIDDLE);
			Chunk  chunkNested3 = new Chunk("Capacit stoccaggio mc",font);
			Phrase phraseNested3  = new Phrase(chunkNested3);
			cellNested3.setBorderWidth(2);
			cellNested3.setFixedHeight(80);							
			nested3.addCell(phraseNested3);
				
			
			
			
			
			PdfPTable nested4 = new PdfPTable(7);
			int headerwidthsInner[] = new int[]{15,15,15,10,15,15,15};	
			nested4.setWidths(headerwidthsInner);			
			PdfPCell cellNested4 = nested4.getDefaultCell();			
			cellNested4.setPadding(5);
			cellNested4.setBorderWidth(1);			
			cellNested4.setBackgroundColor(Color.WHITE);			
			
			
			
						
			font = new Font(Font.TIMES_ROMAN,17f);			
			
			for (int x = 0; x < lista.size(); x++) {
			
			AutotrasportatoriRecord record = (AutotrasportatoriRecord) lista.get(x);
			Object[] recordToArray = record.getQuadroToArray();
			
			
				for (int y = 0; y < 7; y++) {
					
					Object object = recordToArray[y];	
									
					Chunk chunk = new Chunk(object.toString(),font);
					Phrase phrase = new Phrase(chunk);
					
					
					
					
					if(object instanceof BigInteger || object instanceof BigDecimal)
						cellNested4.setHorizontalAlignment(Element.ALIGN_RIGHT);
					else
						cellNested4.setHorizontalAlignment(Element.ALIGN_LEFT);
					
					nested4.addCell(phrase);
					
					
					
					
				}			
			}
			
		
			
			table.addCell(nested1);
			table.addCell(nested3);
			table.addCell(nested2);
			cell.setColspan(3);	
			table.addCell(nested4);	
			
			table.setHeaderRows(1);	
		
			pdfBuilder.getDocument().add(table);
		
		} catch (DocumentException e) {			
			e.printStackTrace();
		}
		
		
	}
	
	protected int[] getTipiRecord(GestoreQuadro gestoreQuadro)
	{
		Quadro quadro = ((Quadro)gestoreQuadro);		
		return quadro.getTipiRecord();
	}
	
	
	protected void printQuadro(GestoreQuadro gestoreQuadro,PdfBuilder pdfBuilder)
	{
			Quadro quadro = ((Quadro)gestoreQuadro);
			int[]tipoRecord = this.getTipiRecord(gestoreQuadro);	
			List lista = this.getListaRecord(gestoreQuadro);
			
			if(tipoRecord[0] == Quadro.QUADRO_A[0])
				printQuadroAC(quadro,tipoRecord,lista,pdfBuilder);
			else if(tipoRecord[0] == Quadro.QUADRO_B[0]) 
				gestionePrintQuadroB(quadro,tipoRecord,lista,pdfBuilder);
			else if(tipoRecord[0] == Quadro.QUADRO_C[0]) 
				printQuadroAC(quadro,tipoRecord,lista,pdfBuilder);
			
	}	
	
	
	
	
	protected void printQuadroAC(Quadro quadro,int[]tipoRecord, List lista, PdfBuilder pdfBuilder)
	{
				
		String	title=quadro.getTitle();
		
		Font font = new Font(Font.BOLD,19f,1);
		Chunk chunkQuadro = new Chunk(title+"\n\n",font);
		Phrase phrase1 = new Phrase(chunkQuadro);
		
		Paragraph paragraph = new Paragraph();
		paragraph.add(phrase1);
		
		
		Font font2 = new Font(Font.BOLD,16f,1);
		Paragraph paragraph2 = new Paragraph();
		
		Chunk chunkAutoveicoli = new Chunk(this.getSecondTitle(tipoRecord)+"\n",font2);
		Phrase phrase2 = new Phrase(chunkAutoveicoli);
		paragraph2.add(phrase2);
		paragraph2.setAlignment(Element.ALIGN_CENTER);
		
		
		boolean boolQuadroA = tipoRecord[0] == Quadro.QUADRO_A[0];
		//solo per il quadro A
		Paragraph paragraph3 = new Paragraph();
		if(boolQuadroA){
		
			
			Chunk periodo = new Chunk(AutotrasportatoriFrame.getArrayStringPeriodi()[quadro.getQuadroSelezionato()],font2);
			Phrase phrasePeriodo = new Phrase(periodo);
			paragraph3.add(phrasePeriodo);
			paragraph3.setAlignment(Element.ALIGN_LEFT);
		}
		
		
		PdfPCell cell = null;
		
		
		
		try {
			
		pdfBuilder.getDocument().add(paragraph);		
		pdfBuilder.getDocument().add(paragraph2);
		if(boolQuadroA)
			pdfBuilder.getDocument().add(paragraph3);
		
		int headerwidths[] = this.getHeaderWidths(tipoRecord);	
		String[]columnNames =  this.getColumnNames(tipoRecord);	
		int NumColumns = headerwidths.length;
		
		PdfPTable datatable = new PdfPTable(NumColumns);
		
		
		
		datatable.setWidths(headerwidths);
		datatable.setWidthPercentage(95); 
		
		cell = datatable.getDefaultCell();
		
		cell.setPadding(5);
		cell.setBorderWidth(2);
		cell.setHorizontalAlignment(Element.ALIGN_CENTER);
		cell.setBackgroundColor(new Color(244,244,244));
		
		font = new Font(Font.TIMES_ROMAN,17f,Font.BOLD);
		
		for (int i = 0; i < columnNames.length; i++) {
			
			Chunk chunk = new Chunk(columnNames[i],font);
			Phrase phrase = new Phrase(chunk);
			datatable.addCell(phrase);
			
		}
		
		
		cell.setBorderWidth(1f);
		cell.setBackgroundColor(Color.WHITE);
		
		font = new Font(Font.TIMES_ROMAN,17f);
		
		for (int x = 0; x < lista.size(); x++) { 
			
			AutotrasportatoriRecord record = (AutotrasportatoriRecord) lista.get(x);
			Object[] recordToArray = record.getQuadroToArray();
			
			for (int y = 0; y < columnNames.length; y++) {
				Object object = recordToArray[y];
				
				if(object instanceof BigInteger ||object instanceof BigDecimal)
					cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
				else
					cell.setHorizontalAlignment(Element.ALIGN_LEFT);
				
				Chunk chunk = new Chunk(object.toString(),font);
				Phrase phrase = new Phrase(chunk);
				
				datatable.addCell(phrase);
			}
			
			
		}
		
		datatable.setHeaderRows(1);
		
		
		
		pdfBuilder.getDocument().add(datatable);
		
		} catch (DocumentException e) {			
			e.printStackTrace();
		}
		
		
	}

	protected void printQuadroBSup10(Quadro quadro,int[]tipoRecord, List lista, PdfBuilder pdfBuilder)
	{
				
		String	title=quadro.getTitle();
		
		Font font = new Font(Font.BOLD,19f,1);
		Chunk chunkQuadro = new Chunk(title+"\n",font);
		Phrase phrase1 = new Phrase(chunkQuadro);
		
		Paragraph paragraph = new Paragraph();
		paragraph.add(phrase1);
		
		
		Font font2 = new Font(Font.BOLD,18f,1);
		Paragraph paragraph2 = new Paragraph();
		
		Chunk chunkAutoveicoli = new Chunk(this.getSecondTitle(tipoRecord)+"\n",font2);
		Phrase phrase2 = new Phrase(chunkAutoveicoli);
		paragraph2.add(phrase2);
		paragraph2.setAlignment(Element.ALIGN_CENTER);
		
		
		font = new Font(Font.TIMES_ROMAN,17f);
		Paragraph paragraph3 = new Paragraph();
		
		
		
		AutotrasportatoriQuadroB recordGasolio = (AutotrasportatoriQuadroB) lista.get(0);
		String gasolio = "";
		if(recordGasolio.getGasolioUtilizzatoRifornimAutovQuadroA().equalsIgnoreCase("S"))
			gasolio ="SI";
		else if(recordGasolio.getGasolioUtilizzatoRifornimAutovQuadroA().equalsIgnoreCase("N"))
			gasolio ="NO";
			
		Chunk chunk3 = new Chunk("\nGasolio utilizzato per il rifornimento dei soli autoveicoli presenti nel QUADRO A: "+gasolio,font);
		Phrase phrase3 = new Phrase(chunk3);
		paragraph3.add(phrase3);
		paragraph3.setAlignment(Element.ALIGN_LEFT);
		paragraph3.setIndentationLeft(20f);
		
		font = new Font(Font.BOLD,17f,1);
		Paragraph paragraph4 = new Paragraph();
	
		Chunk chunk4 = new Chunk("\nDistributore collegato con serbatoio/i avente capacit superiore a 10 mc:",font);
		Phrase phrase4 = new Phrase(chunk4);
		paragraph4.add(phrase4);
		paragraph4.setAlignment(Element.ALIGN_LEFT);
		paragraph4.setIndentationLeft(20f);
		
		
		Cell cell =null;	
		font = new Font(Font.TIMES_ROMAN,17f,1);
		int numColumns = 4;
		
		try {
			
			pdfBuilder.getDocument().add(paragraph);		
			pdfBuilder.getDocument().add(paragraph2);
			pdfBuilder.getDocument().add(paragraph3);
			pdfBuilder.getDocument().add(paragraph4);
			
			Table table = new Table(numColumns);
			table.setWidth(95f);	
			table.setBorderWidth(1);			 
			table.setPadding(5);
			
			
			
			
			
			
			cell = new Cell(new Chunk("Codice ditta",font));			
			cell.setBackgroundColor(new Color(244,244,244));
			cell.setRowspan(2);
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setVerticalAlignment(Element.ALIGN_MIDDLE);
			cell.setBorderWidth(2);			
			table.addCell(cell);
			
			
			cell = new Cell(new Chunk("Fatture di acquisto del gasolio",font));
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setBackgroundColor(new Color(244,244,244));	
			cell.setColspan(3);	
			cell.setBorderWidth(2);				 
			table.addCell(cell);
			 
			 
			cell = new Cell(new Chunk("Numero Fatture",font));			
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setBackgroundColor(new Color(244,244,244));
			cell.setBorderWidth(2);			
			table.addCell(cell);
			
			cell = new Cell(new Chunk("Totale litri fatturati",font));	
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setBackgroundColor(new Color(244,244,244));
			cell.setBorderWidth(2);			
			table.addCell(cell);
			
			cell = new Cell(new Chunk("Totale importo (Euro)",font));	
			cell.setHorizontalAlignment(Element.ALIGN_CENTER);
			cell.setBackgroundColor(new Color(244,244,244));
			cell.setBorderWidth(2);			
			table.addCell(cell);
			 
			table.endHeaders();
			
			
			font = new Font(Font.TIMES_ROMAN,17f);
			
			for (int x = 0; x < lista.size(); x++) {
			
			AutotrasportatoriRecord record = (AutotrasportatoriRecord) lista.get(x);
			Object[] recordToArray = record.getQuadroToArray();
			
				for (int y = 0; y < numColumns; y++) {
					
					Object object = recordToArray[y];
					
					Chunk chunk = new Chunk(object.toString(),font);
					Phrase phrase = new Phrase(chunk);
					cell = new Cell(phrase);	
					
					if(object instanceof BigInteger || object instanceof BigDecimal)
						cell.setHorizontalAlignment(Element.ALIGN_RIGHT);
					else
						cell.setHorizontalAlignment(Element.ALIGN_LEFT);
					
					
					table.addCell(cell);
				}			
			}	
		
			pdfBuilder.getDocument().add(table);
		
		} catch (DocumentException e) {			
			e.printStackTrace();
		}
		
		
	}

	protected void printFrontespizio(PdfBuilder pdfBuilder)
	{
		
		ProspettoConsumo prospetto = (ProspettoConsumo)getProspect();
		Frontespizio frontespizio = prospetto.getFrontespizio();
		String descrizioneUfficio = ComboDataSource.getInstance().getUfficio(frontespizio.getCodUffTecnicoFinanza()).getDescrizione();
		
		int numeroAliquote = AutotrasportatoriFrame.getNumeroAliquote();
		int newFont = 7;
		float floatMoveX = 450F;
		
		pdfBuilder.newPage();
	
		
		pdfBuilder.writeCenteredLabel("Ufficio di " + descrizioneUfficio, 12+newFont);
		pdfBuilder.writeCenteredLabel("", 12+newFont);
		pdfBuilder.writeLeftLabel("RIDUZIONE DELL'ALIQUOTA DI ACCISA SUL GASOLIO PER AUTOTRAZIONE", 14+newFont);
		pdfBuilder.writeCenteredLabel("", 6+newFont);
		
		int contDecreto = 1;
		for (int i = 0; i < AutotrasportatoriFrame.getSetStringDecretiLegge().length; i++) {
			//System.out.println("decreto i     " + AutotrasportatoriFrame.getSetStringDecretiLegge()[i]);
			pdfBuilder.writeLeftLabel(contDecreto+" - "+(String) AutotrasportatoriFrame.getSetStringDecretiLegge()[i],8+newFont);
			contDecreto++;			
		}
		
		//pdfBuilder.writeLeftLabel("1 - Decreto 3 ottobre 2006, n.262 convertito con modificazioni nella legge del 24 novembre 2006, n.286", 8+newFont);
		//pdfBuilder.writeLeftLabel("2 - D. Lgs. 2 febbraio 2007 n.26, art. 6", 8+newFont);
		pdfBuilder.writeCenteredLabel("", 20+newFont);
		pdfBuilder.writeCenteredLabel("Dichiarazione", 16+newFont);
		pdfBuilder.writeCenteredLabel("", 10+newFont);
		pdfBuilder.writeCenteredLabel("(Dichiarazione sostitutiva di atto di notoriet\340 - artt. 47 e 48 del DPR 28.12.2000 n.445)", 8+newFont);
		pdfBuilder.writeCenteredLabel("", 10+newFont);
		pdfBuilder.writeCenteredLabel("PERIODO DI RIFERIMENTO "+AutotrasportatoriFrame.getPeriodo()+" "+AutotrasportatoriFrame.getAnnoRiferimento(), 10+newFont);
		pdfBuilder.writeCenteredLabel("", 30+newFont);
		pdfBuilder.writeLeftLabel("Presentata, sotto la propria responsabilit\340, dal sign. " + frontespizio.getCognomeRappresentanteDichiarazione() + " " + frontespizio.getNomeRappresentanteDichiarazione(), 10+newFont);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		float y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("C.F. " + frontespizio.getCodicefiscaleRappresentanteDichiarazione(), 10+newFont);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.setYPen(y);
		pdfBuilder.writeLeftLabel("nella qualit\340 di " + frontespizio.getQualificaRappresentanteDichiarazione(), 10+newFont);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 30);
		String tipoEsercente = "";
		if(frontespizio.getTipoEsercente().intValue() == 1)
			tipoEsercente = "Esercente servizi di trasporto merci";
		else
		if(frontespizio.getTipoEsercente().intValue() == 2)
			tipoEsercente = "Aziende e societ\340 che esercitano servizi di trasporto pubblico di pass.";
		else
		if(frontespizio.getTipoEsercente().intValue() == 3)
			tipoEsercente = "Imprese che esercitano autoservizi di competenza statale";
		else
		if(frontespizio.getTipoEsercente().intValue() == 4)
			tipoEsercente = "Imprese che esercitano autoservizi di competenza regionale o locale";
		else
		if(frontespizio.getTipoEsercente().intValue() == 5)
			tipoEsercente = "Imprese che esercitano autoservizi di linea internazionali di competenza statale";
		pdfBuilder.writeLeftLabel("IMPRESA: Denom. " + frontespizio.getDenominazione() + " P.IVA " + frontespizio.getPartitaIva(), 10+newFont);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		pdfBuilder.writeLeftLabel("Tipo esercente: " + tipoEsercente, 10+newFont);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Sede legale : Comune " + frontespizio.getComuneSedeLegale(), 10+newFont);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.setYPen(y);
		pdfBuilder.writeLeftLabel("Indirizzo : " + frontespizio.getIndirizzoSedeLegale(), 10+newFont);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Sede amm. : Comune " + frontespizio.getComuneSedeAmministrativa(), 10+newFont);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.setYPen(y);
		pdfBuilder.writeLeftLabel("Indirizzo : " + frontespizio.getIndirizzoSedeAmministrativa(), 10+newFont);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		pdfBuilder.writeLeftLabel("Codice attivit\340 : " + frontespizio.getCodiceAttivita(), 10+newFont);
		pdfBuilder.writeCenteredLabel("", 4+newFont);
		y = pdfBuilder.getYPen();
		String strEsercente = "";
		if(frontespizio.getEsercente().trim().equals("1"))
			strEsercente = "NAZIONALE";
		if(frontespizio.getEsercente().trim().equals("2"))
			strEsercente = "COMUNITARIO";
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Esercente : " + strEsercente, 10+newFont);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.setYPen(y);
		String strAutotrasporti = "";
		if(frontespizio.getAutoTrasportoMerci().trim().equals("1"))
			strAutotrasporti = "CONTO PROPRIO";
		if(frontespizio.getAutoTrasportoMerci().trim().equals("2"))
			strAutotrasporti = "CONTO TERZI";
		pdfBuilder.writeLeftLabel("Autotrasporti merci : " + strAutotrasporti, 10+newFont);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeLeftLabel("", 4+newFont);
		pdfBuilder.writeLeftLabel("Estremi licenza / iscrizione albo / codice ident.esercente comunitario : " + frontespizio.getEstremiLicenza(), 10+newFont);
		pdfBuilder.writeLeftLabel("", 4+newFont);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Numero allegato: certificati di immatricolazione : " + frontespizio.getAllegatiCertificatiImmatricolazione(), 10+newFont);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.setYPen(y);
		pdfBuilder.writeLeftLabel("titoli di possesso : " + frontespizio.getAllegatiTitoliPossesso(), 10+newFont);
		pdfBuilder.setXPen(30F);
		//pdfBuilder.moveYPen(20F);
		
		BigInteger[] arrayLitriConsumati = frontespizio.getArrayLitriConsumati();
		BigDecimal[] arrayImportoACredito = frontespizio.getArrayImportoACredito();
		String[]arrayLabelPeriodi = AutotrasportatoriFrame.getArrayStringPeriodi();
		
		if(numeroAliquote > 1){		
			for (int i = 0; i < numeroAliquote; i++) {
			
			
				pdfBuilder.writeLeftLabel("", 30+newFont);
				pdfBuilder.writeLeftLabel(arrayLabelPeriodi[i], 10+newFont);
				y = pdfBuilder.getYPen();			
				pdfBuilder.writeLeftLabel("    Litri consumati : " +arrayLitriConsumati[i], 10+newFont);
				pdfBuilder.setYPen(y);
				pdfBuilder.moveXPen(floatMoveX);
				pdfBuilder.writeLeftLabel("Importo a credito (Euro): " + arrayImportoACredito[i].toString(), 10+newFont);
				pdfBuilder.setXPen(30F);
				pdfBuilder.writeCenteredLabel("", 4+newFont);
				pdfBuilder.writeLeftLabel("", 4+newFont);
				pdfBuilder.setYPen(y);
				
			}
		}
		
		
		//modifica 27/08/2008  inserimento litri e importo quadro
		/*pdfBuilder.writeLeftLabel("", 30);
		pdfBuilder.writeLeftLabel("1) Dal 1 gennaio al 31 maggio", 10);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("    Litri consumati : " + complementaASinistra(frontespizio.getTotaleLitriConsumatiA1().toString(), 12, "  "), 10);
		pdfBuilder.setYPen(y);
		pdfBuilder.moveXPen(250F);
		pdfBuilder.writeLeftLabel("Importo a credito (Euro): " + complementaASinistra(frontespizio.getImportoAcreditoA1().toString(), 15, "  "), 10);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 4);
		pdfBuilder.writeLeftLabel("", 4);
		pdfBuilder.writeLeftLabel("2) Dal 1 giugno al 31 dicembre", 10);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("    Litri consumati : " + complementaASinistra(frontespizio.getTotaleLitriConsumatiA2().toString(), 12, "  "), 10);
		pdfBuilder.setYPen(y);
		pdfBuilder.moveXPen(250F);
		pdfBuilder.writeLeftLabel("Importo a credito (Euro): " + complementaASinistra(frontespizio.getImportoAcreditoA2().toString(), 15, "  "), 10);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 4);
		pdfBuilder.writeLeftLabel("", 4);
		//fine modifica 27/08/2008
		*/
		
		
		
		pdfBuilder.writeLeftLabel("", 30+newFont);
		pdfBuilder.writeLeftLabel("Totali", 10+newFont);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("    Litri consumati : " + frontespizio.getTotaleLitriConsumati(), 10+newFont);
		pdfBuilder.setYPen(y);
		pdfBuilder.moveXPen(floatMoveX);
		pdfBuilder.writeLeftLabel("Importo a credito (Euro): " + frontespizio.getTotaleImportCredito(), 10+newFont);
		pdfBuilder.setXPen(30F);
		pdfBuilder.writeCenteredLabel("", 12+newFont);
		pdfBuilder.writeLeftLabel("Modalit\340 prescelta di fruizione del credito : ", 10+newFont);
		if(frontespizio.getModalitaFruizioneCredito().trim().equals("1"))
			pdfBuilder.writeLeftLabel("- Compensazione ai sensi dell'art. 17 decreto n\260 241/97 (Mod. F24)", 10+newFont);
		else
		if(frontespizio.getModalitaFruizioneCredito().trim().equals("2"))
			pdfBuilder.writeLeftLabel("- Rimborso: (Coord. Bancarie nazionali :       Cod. ABI.." + frontespizio.getBancaABI() + " Cod. CAB.." + frontespizio.getBancaCAB() + " C.C. n\260 " + frontespizio.getBancaContoCorrente() + " )", 8+newFont);
		else
		if(frontespizio.getModalitaFruizioneCredito().trim().equals("3"))
			pdfBuilder.writeLeftLabel("- Rimborso: (Coord. Postali  nazionali :       Conto corrente postale " + frontespizio.getPostaContoCorrente() + " )", 8+newFont);
		else
		if(frontespizio.getModalitaFruizioneCredito().trim().equals("4"))
			pdfBuilder.writeLeftLabel("- Rimborso: (Coord. Bancarie europee   :       IBAN.." + frontespizio.getIBAN() + "       BIC.." + frontespizio.getBIC() + " )", 8+newFont);
		String quadriCompilati = "";
		
		//int quadroA1 = prospetto.getListaQuadroA("1").size();
		//int quadroA2 = prospetto.getListaQuadroA("2").size();
		
		int contQuadri = 1;
		int[]arrayQuadriCompilati = new int[numeroAliquote];
		for (int i = 0; i < numeroAliquote; i++) {
			int quadroA = prospetto.getListaQuadroA(""+(contQuadri++)+"").size();
			arrayQuadriCompilati[i]=quadroA;
		}
		int quadroB = prospetto.getListaQuadro(Quadro.QUADRO_B).size();
		int quadroC = prospetto.getListaQuadro(Quadro.QUADRO_C).size();
		//25/08/2008 abilitazione quadro A-2, modifica stampa pdf
		// FHF ----------------
		//quadroA2=0;
		//---------------------
		/*if(quadroA1 > 0)
			quadriCompilati = " A-1 ";
		if(quadroA2 > 0)
			quadriCompilati = quadriCompilati + " A-2 ";*/
			
		contQuadri = 1;	
		for (int i = 0; i < numeroAliquote; i++) {
			int quadroA = arrayQuadriCompilati[i];
			if(quadroA > 0)
				quadriCompilati = quadriCompilati + " A-"+(contQuadri);
			contQuadri++;	
		}	
		
		if(quadroB > 0)
			quadriCompilati = quadriCompilati + " B ";
		if(quadroC > 0)
			quadriCompilati = quadriCompilati + " C ";
		pdfBuilder.writeLeftLabel("", 30+newFont);
		pdfBuilder.writeLeftLabel("Il contribuente dichiara di aver compilato i seguenti quadri: " + quadriCompilati, 11+newFont);
		pdfBuilder.writeLeftLabel("", 30+newFont);

		newFont = 5;
		pdfBuilder.writeLeftLabel("PROTOCOLLO E DATA DI ARRIVO ", 11+newFont);
		pdfBuilder.writeCenteredLabel("", 10+newFont);
		pdfBuilder.writeLeftLabel("Protocollo : ", 11+newFont);
		// ATTENZIONE!! questa riga va aggiunta o tolta insieme al set a seconda della lunghezza della prima pagina
		//y = pdfBuilder.getYPen();
		//System.out.println("DOPO: " + y);
		pdfBuilder.writeCenteredLabel("", 20+newFont);
		pdfBuilder.writeLeftLabel("Data : ", 11+newFont);
		pdfBuilder.moveXPen(290f);
		//pdfBuilder.setYPen(y);
		float x = pdfBuilder.getXPen();
		pdfBuilder.writeLeftLabel("Il dichiarante si impegna a presentare, a richiesta dell'ufficio,", 8+newFont);
		pdfBuilder.writeLeftLabel("i documenti giustuficativi concernenti gli elementi dichiarati", 8+newFont);
		pdfBuilder.writeCenteredLabel("", 6+newFont);
		pdfBuilder.writeLeftLabel("Con la firma del presente modulo autorizzo il trattamento dei dati personali,", 8+newFont);
		pdfBuilder.writeLeftLabel("che verranno utilizzati dagli addetti per l'erogazione del beneficio richiesto", 8+newFont);
		pdfBuilder.writeLeftLabel("e per i relativi controlli fiscali", 8+newFont);
		pdfBuilder.writeCenteredLabel("", 10+newFont);
		y = pdfBuilder.getYPen();
		pdfBuilder.writeLeftLabel("Data", 10+newFont);
		pdfBuilder.moveXPen(80F);
		pdfBuilder.setYPen(y);
		float x1 = pdfBuilder.getXPen();
		pdfBuilder.writeLeftLabel("Firma del dichiarante", 10+newFont);
		pdfBuilder.writeLeftLabel("(Firma da apporre ai sensi dell'art. 38 del D.P.R.28.12.2000,n.445)", 8+newFont);
		pdfBuilder.setXPen(x);
		y = pdfBuilder.getYPen();
		
		pdfBuilder.setYPen(y);
		
		pdfBuilder.writeLeftLabel("", 11);
		pdfBuilder.writeLeftLabel("________   ___________________________________________", 10+newFont);
		pdfBuilder.setXPen(x1);
		//pdfBuilder.setYPen(y);
		//pdfBuilder.writeLeftLabel("", 11);
		//pdfBuilder.writeLeftLabel("___________________________________________", 10+newFont);
		pdfBuilder.setXPen(30F);
	}

	private String complementaASinistra(String stringa, int lunghezzastringa, String caratteri)
	{
		int ncaratteri = lunghezzastringa - stringa.length();
		StringBuffer stringaParziale = new StringBuffer(stringa);
		for(int i = 0; i < ncaratteri; i++)
			stringaParziale.insert(0, caratteri);

		return stringaParziale.toString();
	}
}
