package it.finanze.dogane.accise.aautotrasportatori.ui;

import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.renderer.AutotrasportatoriTableCellRender;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroATM;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.combo.TipoPossesso;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

public abstract class AutotrasportatoriQuadroADialog
	extends JDialog
	implements
		ActionListener,
		ListSelectionListener,
		QuadroDialog,
		PdfPrintable,
		FocusListener {

	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelIntestazioneQuadro = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabelTarga = null;
	private javax.swing.JLabel jLabelTitPoss1 = null;
	private javax.swing.JLabel jLabelTitPoss2 = null;
	private javax.swing.JLabel jLabelDataInizPoss = null;
	private javax.swing.JLabel jLabelDataInizPoss2 = null;
	private javax.swing.JLabel jLabelDataInizPoss3 = null;
	private javax.swing.JLabel jLabelDataFinPoss1 = null;
	private javax.swing.JLabel jLabelDataFinPoss2 = null;
	private javax.swing.JLabel jLabelDataFinPoss3 = null;
	private javax.swing.JLabel jLabelNumFatture = null;
	private javax.swing.JLabel jLabelNumSchede = null;
	private javax.swing.JLabel jLabel1LitriConsumati = null;
	private javax.swing.JLabel jLabel1Kmpercorsi = null;
	private javax.swing.JLabel jLabel1ImportEuro = null;
	private javax.swing.JScrollPane jScrollPaneLista = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JTextField jTextFieldTarga = null;
	private javax.swing.JComboBox jComboBoxTitoloPossesso = null;
	private javax.swing.JTextField jTextFieldDataIniPoss = null;
	private javax.swing.JTextField jTextFieldDataFinPoss = null;
	private javax.swing.JTextField jTextFieldNumFatt = null;
	private javax.swing.JTextField jTextFieldNumSchede = null;
	protected javax.swing.JTextField jTextFieldLitrCons = null;
	private javax.swing.JTextField jTextFieldKmPerc = null;
	private javax.swing.JTextField jTextFieldImporto = null;
	private javax.swing.JPanel jPanel3 = null;
	private javax.swing.JButton jButtonInserisci = null;
	private javax.swing.JButton jButtonModifica = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabelPeriodo= null;

	private boolean flagModifica = false;
	private List listaValidate = null;
	protected ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	protected AutotrasportatoriFrame autotrasportatoriFrame = null;

	private List tipiPossesso = null;
	
	protected String titolo = "";
	private int quadroSelezionato;
	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriQuadroADialog(
		Frame frame,
		String titolo ,
		String description,
		String secondDescription) {
		
		super(frame, titolo, true);
		this.titolo = titolo;
		initialize();
		autotrasportatoriFrame=(AutotrasportatoriFrame)frame;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		//this.setSize(800, 600);
		this.setSize(
			RealDim.getAbsoluteXValue(800),
			RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		//String massaA = "Autoveicoli adibiti al trasporto merci con massa massima complessiva superiore A 3.5T/ Autoveicoli adibiti a trasporto di persone";
		String massaA = "Autoveicoli adibiti al trasporto merci con massa massima complessiva pari o superiore A 7.5T/ Autoveicoli adibiti a trasporto di persone";
		this.setTitle(massaA);

		tipiPossesso = initTipiPossesso();
		/*
		JOptionPane.showMessageDialog(this,"A partire dall'anno 2008 "+
		 "sono ammessi al beneficio i veicoli adibiti al trasporto merci\n con massa massima complessiva "+
		"pari o superiore a 7,5 tonnellate" ,"Attenzione",JOptionPane.WARNING_MESSAGE);
			*/	
	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
		
		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		this.quadro = (Quadro) gestoreQuadro;

		List lista = prospettoConsumo.getListaQuadroA( quadro.getTipoQuadroA() );
		
		if(!quadro.getTipoQuadroA().equals(Quadro.TIPO_QUADRO_A1) && lista.size()==0){
			lista=prospettoConsumo.getListaQuadroA(Quadro.TIPO_QUADRO_A1);//lista record quadro A-1
			List listTmp=new ArrayList();
			for(int i=0; i < lista.size() ; i++){			
				AutotrasportatoriQuadroA quadroArecord = (AutotrasportatoriQuadroA)lista.get(i);
				quadroArecord.setTipoQuadroA(Quadro.getTipoQuadroA(getQuadroSelezionato()));				
				quadroArecord.setDataInizioPossesso(new BigInteger(quadro.getDataInizioPossesso()));				
				quadroArecord.setDataFinePossesso(new BigInteger(quadro.getDataFinePossesso()));		
				quadroArecord.setNumeroFatture(BigInteger.valueOf(0));
				quadroArecord.setNumeroSchede(BigInteger.valueOf(0));
				quadroArecord.setLitriConsumati(BigInteger.valueOf(0));
				quadroArecord.setChilometriPercorsi(BigInteger.valueOf(0));
				quadroArecord.setImporto(BigDecimal.valueOf(0));
				listTmp.add(i,quadroArecord);
			}
			lista=listTmp;
		}else{
			if(lista.size()>0){
				List listTmp=new ArrayList();
				for(int i=0; i < lista.size() ; i++){			
					AutotrasportatoriQuadroA quadroArecord = (AutotrasportatoriQuadroA)lista.get(i);				
					
					listTmp.add(i,quadroArecord);				
				}
				lista=listTmp;	
			}
		}
		listaValidate = lista;
		AutotrasportatoriQuadroATM model = new AutotrasportatoriQuadroATM(lista);
		jTable.setModel(model);
		
		for (int i = 0; i < jTable.getColumnCount(); i++) {
			DefaultTableCellRenderer d = new DefaultTableCellRenderer();
			jTable.getColumnModel().getColumn(i).setCellRenderer(d);
		}				
		//colonne allineate a destra
		String [] colDestra = new String[]{ "N. fatture", "N. schede","Litri consumati","Km percorsi","Importo"};
		for (int i=0; i<colDestra.length;i++){
			DefaultTableCellRenderer dtcr = (DefaultTableCellRenderer)jTable.getColumn(colDestra[i]).getCellRenderer();
			dtcr.setHorizontalAlignment(JLabel.RIGHT);
		}
		
		
		
		TableUtil.redimTable(jTable, jScrollPaneLista);

		ComboUtil.setValues(jComboBoxTitoloPossesso, tipiPossesso);		
		jLabelPeriodo.setText(AutotrasportatoriFrame.getArrayStringPeriodi()[this.getQuadroSelezionato()]);
		
		
	}
	

	/**
	 * Non si utilizza il combo data source perch si tratta di tre valori utilizzati solo
	 * da questo quadro...
	 * @return
	 */
	private List initTipiPossesso() {
		List retlist = new LinkedList();
		TipoPossesso tipoPossesso = null;

		tipoPossesso = new TipoPossesso();
		tipoPossesso.setCodice("A");
		retlist.add(tipoPossesso);

		tipoPossesso = new TipoPossesso();
		tipoPossesso.setCodice("B");
		retlist.add(tipoPossesso);

		tipoPossesso = new TipoPossesso();
		tipoPossesso.setCodice("C");
		retlist.add(tipoPossesso);

		return retlist;
	}

	private TipoPossesso getTipoPossesso(String codice) {
		TipoPossesso retvalue = null;
		Iterator it = tipiPossesso.iterator();
		while (it.hasNext() && retvalue == null) {
			TipoPossesso item = (TipoPossesso) it.next();
			if (item.getCodice().equalsIgnoreCase(codice)) {
				retvalue = item;
			}
		}

		return retvalue;
	}

	public void plot(PdfBuilder builder, String quadroStr) {
		
		builder.startCommandBlock();
		float y = builder.getYPen();
		builder.writeLeftLabel(quadroStr.toUpperCase(), 12);
		//SALVATORE
		builder.endCommandBlock();
		builder.startDefineTableHeader();		
		//
		float y2 = builder.getYPen();
		builder.moveYPen(y - y2);
		String titolo1 = "";
		String titolo2 = "";
		if( this.getTitle().length() > 43 ) {
			titolo1 = this.getTitle().substring(0, this.getTitle().length() - 44);
			titolo2 = this.getTitle().substring(
													this.getTitle().length() - 44,
													this.getTitle().length()
												);
		}
		builder.writeRightLabel(titolo1.toUpperCase(), 12);
		builder.writeRightLabel(titolo2.toUpperCase(), 12);
		
		builder.setXPen(PdfBuilder.MARGINE);
		builder.writeLeftLabel("", 20);
		//SALVATORE
		//builder.endCommandBlock();
		builder.endDefineTableHeader();		
		//

		builder.writeTable(this, jTable, jScrollPaneLista);
		builder.setXPen(PdfBuilder.MARGINE);
		builder.moveYPen(50);		
		
		/*
		 * builder.moveXPen(50);
		float y2 = builder.getYPen();
		builder.moveYPen(y - y2); // All'interno di un blocco non si pu utilizzare una setYPen		
		String titolo1 = "";
		String titolo2 = "";
		if (this.getTitle().length() > 43) {
			titolo1 =
				this.getTitle().substring(0, this.getTitle().length() - 57);
			titolo2 =
				this.getTitle().substring(
					this.getTitle().length() - 57,
					this.getTitle().length());
		}
		builder.writeRightLabel(titolo1.toUpperCase(), 12);
		builder.writeRightLabel(titolo2.toUpperCase(), 12);*/
	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/

	public void actionPerformed(ActionEvent event) {
		try {
			if (event.getSource() == jButtonChiudi) {
				doClose();
			} else if (event.getSource() == jButtonConferma) {
				doConfirm();
			} else if (event.getSource() == jButtonElimina) {
				doDelete();
			} else if (event.getSource() == jButtonInserisci) {
				doInsert();
			} else if (event.getSource() == jButtonModifica) {
				doUpdate();
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				e.getMessage(),
				"Errore",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void doUpdate() {
		boolean updateExecuted=false;
		if( campiobbligatori() ){
		
			AutotrasportatoriQuadroATM model =
				(AutotrasportatoriQuadroATM) jTable.getModel();
			int selectedRow = jTable.getSelectedRow();
			if (selectedRow != -1) {
				AutotrasportatoriQuadroA record =
					(AutotrasportatoriQuadroA) model.getRecord(selectedRow);
				try {
					boolean check = validateUpdateMatricola(listaValidate,selectedRow) ;
					if(!check){
						loadRecordFromUI(record);
						record.setTipoQuadroA(Quadro.getTipoQuadroA(this.getQuadroSelezionato()));						
						model.setRecord(selectedRow, record);
						flagModifica = true;		
						updateExecuted=true;			
					} 
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						this,
						e.getMessage(),
						"Errore",
						JOptionPane.ERROR_MESSAGE);
				}
			} else {
				JOptionPane.showMessageDialog(
					this,
					"Selezionare un elemento dalla lista",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
			}
			
		}
		if(updateExecuted) jTable.removeRowSelectionInterval( 0, jTable.getRowCount()-1 );
	}

	/**
	 * 
	 */
	private void doInsert() {
		if (campiobbligatori()) {
			boolean insert = false;
			

			AutotrasportatoriQuadroATM model = (AutotrasportatoriQuadroATM) jTable.getModel();
			AutotrasportatoriQuadroA record = AutotrasportatoriQuadroA.getNewObject(prospettoConsumo);
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			try {
				loadRecordFromUI(record);				
				record.setTipoQuadroA(Quadro.getTipoQuadroA(this.getQuadroSelezionato()));
				insert = validateMatricola(listaValidate) ;
				if (insert != true) {
					model.insertRecord(record);
					clearFields();
					flagModifica = true;	
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(
					this,
					e.getMessage(),
					"Errore",
					JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	private boolean validateData(String dataGGMM) {
		boolean isValida=true;
		// la data in ingresso  del tipo ggmm
		String giornoStr = "";
		String meseStr = "";
		if (dataGGMM.length()==4){
			giornoStr=StringUtil.nullify(dataGGMM.substring(0,2));
			meseStr=StringUtil.nullify(dataGGMM.substring(2,4));
		} else if (dataGGMM.length()==3){
			giornoStr=StringUtil.nullify(dataGGMM.substring(0,1));
			meseStr=StringUtil.nullify(dataGGMM.substring(1,3));
		} else {
			isValida=false; // data non valida
			return isValida;
		}

		if (giornoStr==null || meseStr == null 
			|| Integer.parseInt(giornoStr)<=0 
			|| Integer.parseInt(giornoStr)>31 
			|| Integer.parseInt(meseStr)<=0 
			|| Integer.parseInt(meseStr)>12
			|| ((Integer.parseInt(giornoStr)>30) && (Integer.parseInt(meseStr)==4 || Integer.parseInt(meseStr)==9 
					|| Integer.parseInt(meseStr)==11 || Integer.parseInt(meseStr)==6 ))
			|| ((Integer.parseInt(meseStr)==2)&& (Integer.parseInt(giornoStr)>29))
			|| ((Integer.parseInt(meseStr)==2)&& (Integer.parseInt(giornoStr)==29) && ((VisualConfig.ANNO_DI_RIFERIMENTO_INT%4)!=0))
			)
			{
			isValida=false; // giorno o mese non valido
			}
		// TO DO..: bisognerebbe considerare il mese di febbraio che pu essere di 28 o 29 giorni
		// tale controllo non  implementato sull'applicazione originale quindi viene tralasciato
		return isValida;
	}

	private String validateDataInPeriodo(String dataGGMM) {
		String msg="";
		
		if (dataGGMM.length()==3) dataGGMM="0"+dataGGMM;

		

		//ggmm
		// modifica reply
		String minStr = getDataInizioPeriodo();
		String maxStr = getDataFinePeriodo();
		// fine

		//mmgg
		String minMMStr = minStr.substring(2,4);
		String minGGStr = minStr.substring(0,2);
		BigInteger newMin=new BigInteger(minMMStr+minGGStr);
		//mmgg
		String maxMMStr = maxStr.substring(2,4);
		String maxGGStr = maxStr.substring(0,2);
		BigInteger newMax=new BigInteger(maxMMStr+maxGGStr);

		String dataInMM = dataGGMM.substring(2,4);
		String dataInGG = dataGGMM.substring(0,2);
		BigInteger dataIn=new BigInteger(dataInMM+dataInGG);

		if (dataIn.compareTo(newMin)<0){
			msg="La data di possesso " + formatDate(dataGGMM)+" deve essere maggiore o uguale del " + formatDate(minStr);
		} else if (dataIn.compareTo(newMax)>0){
			msg="La data di possesso " + formatDate(dataGGMM)+" deve essere minore o uguale del " + formatDate(maxStr);
		} else {
			msg="ok";
		}
		return msg;
	}

	public static final String compareDataInizioFine(String dataIniGGMM,String dataFinGGMM) {
		String msg="";

		if (dataIniGGMM.length()==3)
			dataIniGGMM="0"+dataIniGGMM;
		if (dataFinGGMM.length()==3)
			dataFinGGMM="0"+dataFinGGMM;

		//mmgg
		String dataIniMM = dataIniGGMM.substring(2,4);
		String dataIniGG = dataIniGGMM.substring(0,2);
		BigInteger newDataIniGGMM=new BigInteger(dataIniMM+dataIniGG);
		//mmgg
		String dataFinMM = dataFinGGMM.substring(2,4);
		String dataFinGG = dataFinGGMM.substring(0,2);
		BigInteger newDataFinGGMM=new BigInteger(dataFinMM+dataFinGG);

		if (newDataIniGGMM.compareTo(newDataFinGGMM)==1){
			msg="La data di inizio possesso "+formatDate(dataIniGGMM)+" deve essere precedente alla data di fine possesso "+formatDate(dataFinGGMM)+" .";
		} else {
			msg="ok";
		}
		return msg;
	}

	// modifica reply
	protected abstract String getDataInizioPeriodo();
	protected abstract String getDataFinePeriodo();
	// fine

	public static final String formatDate(String dataStr) {
		dataStr=StringUtil.nullify(dataStr);
		if (dataStr.length()==3)
			dataStr="0"+dataStr;
		StringBuffer buffer = new StringBuffer(dataStr);
		buffer.insert(2, "/");
		return buffer.toString();
	}

	private boolean validateMatricola(List list) {
		boolean isPresent = false;

		Iterator it = list.iterator();
		boolean found = false;
		while (it.hasNext()) {
			AutotrasportatoriQuadroA record =
				(AutotrasportatoriQuadroA) it.next();
			if (record.getTarga().equals(jTextFieldTarga.getText())) {
				JOptionPane.showMessageDialog(
					this,
					"Targa gi presente nel quadro",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isPresent = true;
				jTextFieldTarga.selectAll();
				jTextFieldTarga.grabFocus();
			}
		}
		return isPresent;
	}
	
	private boolean validateUpdateMatricola(List list,int rowToUpdate) {
		boolean isPresent = false;
		Iterator it = list.iterator();
		boolean found = false;
		int rowToCheck=-1;
		while (it.hasNext()) {
			rowToCheck++;
			AutotrasportatoriQuadroA record =
				(AutotrasportatoriQuadroA) it.next();
			if (record.getTarga().equals(jTextFieldTarga.getText())&&(rowToCheck!=rowToUpdate)) {
				JOptionPane.showMessageDialog(
					this,
					"Targa gi presente nel quadro",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isPresent = true;
				jTextFieldTarga.selectAll();
				jTextFieldTarga.grabFocus();
			}
		}
		return isPresent;
	}

	private boolean campiobbligatori() {
		boolean isOk = true;

		if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) == null) {
			jTextFieldDataIniPoss.setText(this.getDataInizioPeriodo());
		}
		if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) == null) {
			jTextFieldDataFinPoss.setText(this.getDataFinePeriodo());
		}

		if (StringUtil.nullify(jTextFieldTarga.getText()) == null) {
			JOptionPane.showMessageDialog(
				this,
				"Digitare la targa.",
				"Attenzione",
				JOptionPane.ERROR_MESSAGE);
			isOk = false;
			jTextFieldTarga.selectAll();
			jTextFieldTarga.grabFocus();
			/**
		} else if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) == null) {
			JOptionPane.showMessageDialog(
				this,
				"Specificare la data di inizio possesso.",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk = false;
			jTextFieldDataIniPoss.selectAll();
			jTextFieldDataIniPoss.grabFocus();
			**/
		} else if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) != null) {
			String msg = "";
			// controllo se  una data valida (controllo sintattico)
			boolean isValida=false;
			isValida=validateData(StringUtil.nullify(this.jTextFieldDataIniPoss.getText()));
			if (isValida) {
				// devo controllare se la data  nel range
				msg = this.validateDataInPeriodo(StringUtil.nullify(this.jTextFieldDataIniPoss.getText()));
				if (!StringUtil.nullify(msg).equals("ok")){
					isValida=false;
				}
			}
			if (!isValida) {
				jTextFieldDataFinPoss.setText("");
				if (StringUtil.nullify(msg)==null)
					JOptionPane.showMessageDialog(this,"La data di inizio possesso "+StringUtil.nullify(this.jTextFieldDataIniPoss.getText())+" non  valida!","Errore",JOptionPane.ERROR_MESSAGE);
				else
					JOptionPane.showMessageDialog(this,msg,"Errore",JOptionPane.ERROR_MESSAGE);
				isOk = false;
				jTextFieldDataIniPoss.selectAll();
				jTextFieldDataIniPoss.grabFocus();
				/**
				} else if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) == null) {
				JOptionPane.showMessageDialog(this,"Specificare la data di fine possesso.","Attenzione",JOptionPane.WARNING_MESSAGE);
				isOk = false;
				jTextFieldDataFinPoss.selectAll();
				jTextFieldDataFinPoss.grabFocus();
				**/
				} else if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) != null) {
					isValida=false;
					isValida=validateData(StringUtil.nullify(this.jTextFieldDataFinPoss.getText()));
					msg = "";
					if (isValida) {
						// devo controllare se la data  nel range
						msg = this.validateDataInPeriodo(StringUtil.nullify(this.jTextFieldDataFinPoss.getText()));
						if (StringUtil.nullify(msg).equals("ok")){
							// controllo se la data di inizio  successiva alla data di fine possesso
							msg = compareDataInizioFine(this.jTextFieldDataIniPoss.getText(),this.jTextFieldDataFinPoss.getText());
						}
						if (!StringUtil.nullify(msg).equals("ok")){
							isValida=false;
						}
					}
					if (!isValida) {
						if (StringUtil.nullify(msg)==null)
							JOptionPane.showMessageDialog(this,"La data di fine possesso "+StringUtil.nullify(this.jTextFieldDataFinPoss.getText())+" non  valida!","Errore",JOptionPane.ERROR_MESSAGE);
						else
							JOptionPane.showMessageDialog(this,msg,"Errore",JOptionPane.ERROR_MESSAGE);
						isOk = false;
						jTextFieldDataFinPoss.selectAll();
						jTextFieldDataFinPoss.grabFocus();						
					} else if (StringUtil.nullify(jTextFieldLitrCons.getText()) == null || jTextFieldLitrCons.getText().equals("0")) {// modifica 27/08/2008 inserimento controllo litri a zero
							JOptionPane.showMessageDialog(this,"Specificare i litri consumati.","Attenzione",JOptionPane.WARNING_MESSAGE);
							isOk = false;
							jTextFieldLitrCons.selectAll();
							jTextFieldLitrCons.grabFocus();
					} else if (StringUtil.nullify(jTextFieldKmPerc.getText()) == null  || Integer.parseInt(StringUtil.nullify(jTextFieldKmPerc.getText())) <=0  ) {
							JOptionPane.showMessageDialog(this,"Specificare i chilometri percorsi.","Attenzione",JOptionPane.WARNING_MESSAGE);
							isOk = false;
							jTextFieldKmPerc.selectAll();
							jTextFieldKmPerc.grabFocus();
					}else if(StringUtil.nullify(jTextFieldImporto.getText()) == null  || Double.parseDouble(StringUtil.nullify(jTextFieldImporto.getText())) <=0 ) {
							JOptionPane.showMessageDialog(this,"Specificare l'importo.","Attenzione",JOptionPane.WARNING_MESSAGE);
							isOk = false;
							jTextFieldImporto.selectAll();
							jTextFieldImporto.grabFocus();
					}
				}
		}
		return isOk;
	}
	/**
	 * 
	 */
	private void doDelete() {
		AutotrasportatoriQuadroATM model =
			(AutotrasportatoriQuadroATM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFields();
			flagModifica = true;	
		} else {
			JOptionPane.showMessageDialog(
				this,
				"Selezionare un elemento dalla lista",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void doConfirm() {
		AutotrasportatoriQuadroATM model =
			(AutotrasportatoriQuadroATM) jTable.getModel();
		List listaQuadro = model.getRecords();

		prospettoConsumo.setListaQuadroA( listaQuadro, quadro.getTipoQuadroA() );
		

		// calcolo il totale dei litri e degli importi
		Iterator i = listaQuadro.iterator();
		BigInteger totaleLitri=BigInteger.valueOf(0);
		BigDecimal totaleCredito=BigDecimal.valueOf(0);
		while (i.hasNext()){
			AutotrasportatoriQuadroA record = (AutotrasportatoriQuadroA) i.next();
			if (record.getLitriConsumati().equals(BigInteger.ZERO)) {// modifica 27/08/2008 inserimento controllo litri a zero
				JOptionPane.showMessageDialog(this,"Il valore litri consumati non pu essere zero.","Attenzione",JOptionPane.WARNING_MESSAGE);
				prospettoConsumo.setListaQuadroA( new ArrayList(), quadro.getTipoQuadroA() );
				return;
			}
			if (record.getChilometriPercorsi().equals(BigInteger.ZERO)) {// modifica 27/08/2008 inserimento controllo km a zero
				JOptionPane.showMessageDialog(this,"Il valore km percorsi non pu essere zero.","Attenzione",JOptionPane.WARNING_MESSAGE);
				prospettoConsumo.setListaQuadroA( new ArrayList(), quadro.getTipoQuadroA() );
				return;
			}
			totaleLitri=totaleLitri.add(record.getLitriConsumati());		
			totaleCredito=totaleCredito.add(record.getImporto());
		}		
		
		// modifica reply
		//this.autotrasportatoriFrame.getJTextFieldTOTLitriConsumati().setText(totaleLitri.toString());
		//this.autotrasportatoriFrame.getJTextFieldTOTACredito().setText(totaleCredito.toString());
		valorizzaDatiContabiliDelFrontespizio( totaleLitri, totaleCredito );
		this.autotrasportatoriFrame.aggiornaTotaliSuiDatiContabili();
		// fine
		
		this.setVisible(false);
	}
	
	// aggiunto reply
	protected abstract void valorizzaDatiContabiliDelFrontespizio( BigInteger totaleLitri, BigDecimal totaleCredito );

	private void doClose() {
		int val = validateExitText();
		if (val == JOptionPane.YES_OPTION) {
			doConfirm();
		} else if (val == JOptionPane.NO_OPTION) {
			this.setVisible(false);
		} else if (val == JOptionPane.CANCEL_OPTION) {
		}
	}

	private int validateExitText() {
		int retvalue = JOptionPane.NO_OPTION;
		if (flagModifica == true) {
			retvalue =
				JOptionPane.showConfirmDialog(
					this,
					"Le modifiche effettuate verranno perse. Vuoi salvare le modifiche?",
					"",
					JOptionPane.YES_NO_CANCEL_OPTION);
		}
		return retvalue;
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadUIFromRecord();
		}
	}

	/**
	 * @param record
	 */
	protected void loadRecordFromUI(AutotrasportatoriQuadroA record) {

		String str = null;

		try {
			str = jTextFieldDataIniPoss.getText();
			BigInteger i = new BigInteger(str);
			record.setDataInizioPossesso(i);
		} catch (NumberFormatException e) {
			record.setDataInizioPossesso(BigInteger.ZERO);
		}

		try {
			str = jTextFieldDataFinPoss.getText();
			BigInteger i = new BigInteger(str);
			record.setDataFinePossesso(i);
		} catch (NumberFormatException e) {
			record.setDataFinePossesso(BigInteger.ZERO);
		}

		try {
			str = jTextFieldImporto.getText();
			BigDecimal d = new BigDecimal(str);
			record.setImporto(d);
		} catch (NumberFormatException e) {
			record.setImporto(BigDecimal.valueOf(0));
		}

		try {
			str = jTextFieldKmPerc.getText();
			BigInteger i = new BigInteger(str);
			record.setChilometriPercorsi(i);
		} catch (NumberFormatException e) {
			record.setChilometriPercorsi(BigInteger.ZERO);
		}

		try {
			str = jTextFieldLitrCons.getText();
			BigInteger i = new BigInteger(str);
			record.setLitriConsumati(i);
		} catch (NumberFormatException e) {
			record.setLitriConsumati(BigInteger.ZERO);
		}

		try {
			str = jTextFieldNumFatt.getText();
			BigInteger i = new BigInteger(str);
			record.setNumeroFatture(i);
		} catch (NumberFormatException e) {
			record.setNumeroFatture(BigInteger.ZERO);
		}

		try {
			str = jTextFieldNumSchede.getText();
			BigInteger i = new BigInteger(str);
			record.setNumeroSchede(i);
		} catch (NumberFormatException e) {
			record.setNumeroSchede(BigInteger.ZERO);
		}

		record.setTarga(jTextFieldTarga.getText());

		AbstractTipo tipo =
			(AbstractTipo) jComboBoxTitoloPossesso.getSelectedItem();
		record.setTitoloPossesso(tipo.getCodice());
	}

	private void loadUIFromRecord() {
		AutotrasportatoriQuadroATM model =
			(AutotrasportatoriQuadroATM) jTable.getModel();

		int selectedRow = jTable.getSelectedRow();
		if (selectedRow == -1) {
			clearFields();
		} else {

			AutotrasportatoriQuadroA record =
				(AutotrasportatoriQuadroA) model.getRecord(selectedRow);

			jTextFieldDataIniPoss.setText(
				record.getDataInizioPossesso().toString());
			jTextFieldDataFinPoss.setText(
				record.getDataFinePossesso().toString());

			jTextFieldImporto.setText(record.getImporto().toString());
			jTextFieldKmPerc.setText(record.getChilometriPercorsi().toString());
			jTextFieldLitrCons.setText(record.getLitriConsumati().toString());
			jTextFieldNumFatt.setText(record.getNumeroFatture().toString());
			jTextFieldNumSchede.setText(record.getNumeroSchede().toString());
			jTextFieldTarga.setText(record.getTarga());

			jComboBoxTitoloPossesso.setSelectedItem(
				getTipoPossesso(record.getTitoloPossesso()));
		}
	}
	
	
	protected abstract String calcolaImporto();//retro compatibilita 

	private void clearFields() {
		jTextFieldDataIniPoss.setText("");
		jTextFieldDataFinPoss.setText("");
		jTextFieldImporto.setText("");
		jTextFieldKmPerc.setText("");
		jTextFieldLitrCons.setText("");
		jTextFieldNumFatt.setText("");
		jTextFieldNumSchede.setText("");
		jTextFieldTarga.setText("");

		jComboBoxTitoloPossesso.setSelectedIndex(0);
	}

	public void focusGained(FocusEvent event) {
	}

	public void focusLost(FocusEvent event) {
		/*
			jTextFieldDataIniPoss
			jTextFieldDataFinPoss
			jTextFieldNumFatt	
			jTextFieldNumSchede
			jTextFieldLitrCons
			jTextFieldKmPerc
			jTextFieldImporto
			jTextFieldTarga
		 */
		 
		 
		//System.out.println("ciaooooooooo");
		
		if (event.getSource()==jTextFieldLitrCons)
			this.getJTextFieldImporto().setText( calcolaImporto() );
		
		
	}


	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/


	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelIntestazioneQuadro(), null);
			
			
			jPanel.add(getJLabelPeriodo(), null);
			
			jPanel.setBounds(10, 16, 789, 61);
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					titolo,
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabelIntestazioneQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelIntestazioneQuadro() {
		if (jLabelIntestazioneQuadro == null) {
			jLabelIntestazioneQuadro = new javax.swing.JLabel();
			jLabelIntestazioneQuadro.setBounds(100, 20, 580, 21);
			//String labelMassa = "Autoveicoli adibiti al trasporto merci con massa massima complessiva superiore A 3.5T/ Autoveicoli adibiti a trasporto di persone";
			String labelMassa = "<html><p style='text-align: center;'>Autoveicoli adibiti al trasporto merci con massa massima complessiva pari o superiore A 7.5T/ <br>Autoveicoli adibiti a trasporto di persone</p></html>";
			jLabelIntestazioneQuadro.setText(labelMassa);
			jLabelIntestazioneQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelIntestazioneQuadro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelIntestazioneQuadro;
	}
	private javax.swing.JLabel getJLabelPeriodo() {
			
			jLabelPeriodo = new javax.swing.JLabel();
			jLabelPeriodo.setBounds(5, 30, 200, 30);			
			jLabelPeriodo.setHorizontalAlignment(
						javax.swing.SwingConstants.LEFT);
			jLabelPeriodo.setHorizontalTextPosition(
						javax.swing.SwingConstants.LEFT);
			
			return jLabelPeriodo;
		}
	
	
	
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			jPanel1.add(getJPanel2(), null);
			jPanel1.add(getJScrollPaneLista(), null);
			jPanel1.add(getJTextFieldTarga(), null);
			jPanel1.add(getJComboBoxTitoloPossesso(), null);
			jPanel1.add(getJTextFieldDataIniPoss(), null);
			jPanel1.add(getJTextFieldDataFinPoss(), null);
			jPanel1.add(getJTextFieldNumFatt(), null);
			jPanel1.add(getJTextFieldNumSchede(), null);
			jPanel1.add(getJTextFieldLitrCons(), null);
			jPanel1.add(getJTextFieldKmPerc(), null);
			jPanel1.add(getJTextFieldImporto(), null);
			jPanel1.add(getJPanel3(), null);
			jPanel1.setBounds(10, 87, 789, 329);
			jPanel1.setBackground(java.awt.Color.lightGray);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			jPanel2.setLayout(null);
			jPanel2.setLayout(FullScreenLayoutManager.getInstance());
			jPanel2.add(getJLabelTarga(), null);
			jPanel2.add(getJLabelTitPoss1(), null);
			jPanel2.add(getJLabelTitPoss2(), null);
			jPanel2.add(getJLabelDataInizPoss(), null);
			jPanel2.add(getJLabelDataInizPoss2(), null);
			jPanel2.add(getJLabelDataInizPoss3(), null);
			jPanel2.add(getJLabelDataFinPoss1(), null);
			jPanel2.add(getJLabelDataFinPoss2(), null);
			jPanel2.add(getJLabelDataFinPoss3(), null);
			jPanel2.add(getJLabelNumFatture(), null);
			jPanel2.add(getJLabelNumSchede(), null);
			jPanel2.add(getJLabel1LitriConsumati(), null);
			jPanel2.add(getJLabel1Kmpercorsi(), null);
			jPanel2.add(getJLabel1ImportEuro(), null);
			jPanel2.add(getJLabel(), null);
			jPanel2.setBounds(14, 194, 766, 55);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jLabelTarga
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTarga() {
		if (jLabelTarga == null) {
			jLabelTarga = new javax.swing.JLabel();
			jLabelTarga.setBounds(0, 16, 90, 19);
			jLabelTarga.setText("Targa");
			jLabelTarga.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTarga.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTarga;
	}
	/**
	 * This method initializes jLabelTitPoss1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitPoss1() {
		if (jLabelTitPoss1 == null) {
			jLabelTitPoss1 = new javax.swing.JLabel();
			jLabelTitPoss1.setBounds(87, 11, 58, 19);
			jLabelTitPoss1.setText("Titolo");
			jLabelTitPoss1.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTitPoss1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTitPoss1;
	}
	/**
	 * This method initializes jLabelTitPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitPoss2() {
		if (jLabelTitPoss2 == null) {
			jLabelTitPoss2 = new javax.swing.JLabel();
			jLabelTitPoss2.setBounds(87, 29, 58, 19);
			jLabelTitPoss2.setText("possesso");
			jLabelTitPoss2.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTitPoss2.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTitPoss2;
	}
	/**
	 * This method initializes jLabelDataInizPoss
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss() {
		if (jLabelDataInizPoss == null) {
			jLabelDataInizPoss = new javax.swing.JLabel();
			jLabelDataInizPoss.setBounds(149, 2, 91, 19);
			jLabelDataInizPoss.setText("Data");
			jLabelDataInizPoss.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss;
	}
	/**
	 * This method initializes jLabelDataInizPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss2() {
		if (jLabelDataInizPoss2 == null) {
			jLabelDataInizPoss2 = new javax.swing.JLabel();
			jLabelDataInizPoss2.setBounds(149, 16, 91, 19);
			jLabelDataInizPoss2.setText("inizio possesso");
			jLabelDataInizPoss2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss2;
	}
	/**
	 * This method initializes jLabelDataInizPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss3() {
		if (jLabelDataInizPoss3 == null) {
			jLabelDataInizPoss3 = new javax.swing.JLabel();
			jLabelDataInizPoss3.setBounds(149, 31, 91, 19);
			jLabelDataInizPoss3.setText("ggmm");
			jLabelDataInizPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss3;
	}
	/**
	 * This method initializes jLabelDataFinPoss1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss1() {
		if (jLabelDataFinPoss1 == null) {
			jLabelDataFinPoss1 = new javax.swing.JLabel();
			jLabelDataFinPoss1.setBounds(245, 2, 91, 19);
			jLabelDataFinPoss1.setText("Data");
			jLabelDataFinPoss1.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss1;
	}
	/**
	 * This method initializes jLabelDataFinPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss2() {
		if (jLabelDataFinPoss2 == null) {
			jLabelDataFinPoss2 = new javax.swing.JLabel();
			jLabelDataFinPoss2.setBounds(245, 16, 91, 19);
			jLabelDataFinPoss2.setText("fine possesso");
			jLabelDataFinPoss2.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss2.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss2;
	}
	/**
	 * This method initializes jLabelDataFinPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss3() {
		if (jLabelDataFinPoss3 == null) {
			jLabelDataFinPoss3 = new javax.swing.JLabel();
			jLabelDataFinPoss3.setBounds(245, 32, 91, 19);
			jLabelDataFinPoss3.setText("ggmm");
			jLabelDataFinPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss3;
	}
	/**
	 * This method initializes jLabelNumFatture
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNumFatture() {
		if (jLabelNumFatture == null) {
			jLabelNumFatture = new javax.swing.JLabel();
			jLabelNumFatture.setBounds(340, 25, 67, 19);
			jLabelNumFatture.setText("N Fatture");
			jLabelNumFatture.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelNumFatture.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelNumFatture;
	}
	/**
	 * This method initializes jLabelNumSchede
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNumSchede() {
		if (jLabelNumSchede == null) {
			jLabelNumSchede = new javax.swing.JLabel();
			jLabelNumSchede.setBounds(412, 25, 59, 19);
			jLabelNumSchede.setText("N Schede");
			jLabelNumSchede.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelNumSchede.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelNumSchede;
	}
	/**
	 * This method initializes jLabel1LitriConsumati
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1LitriConsumati() {
		if (jLabel1LitriConsumati == null) {
			jLabel1LitriConsumati = new javax.swing.JLabel();
			jLabel1LitriConsumati.setBounds(475, 11, 76, 19);
			jLabel1LitriConsumati.setText("Litri");
			jLabel1LitriConsumati.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabel1LitriConsumati.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel1LitriConsumati;
	}
	/**
	 * This method initializes jLabel1Kmpercorsi
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1Kmpercorsi() {
		if (jLabel1Kmpercorsi == null) {
			jLabel1Kmpercorsi = new javax.swing.JLabel();
			jLabel1Kmpercorsi.setBounds(555, 22, 105, 19);
			jLabel1Kmpercorsi.setText("Km percorsi");
			jLabel1Kmpercorsi.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel1Kmpercorsi.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabel1Kmpercorsi;
	}
	/**
	 * This method initializes jLabel1ImportEuro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1ImportEuro() {
		if (jLabel1ImportEuro == null) {
			jLabel1ImportEuro = new javax.swing.JLabel();
			jLabel1ImportEuro.setBounds(661, 22, 100, 19);
			jLabel1ImportEuro.setText("Importo");
			jLabel1ImportEuro.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabel1ImportEuro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel1ImportEuro;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if (jTable == null) {
			jTable = new javax.swing.JTable(); // se torna il CellRenderer, togliere la ";" e decommentare
//			{
//					TableCellRenderer tcr=new AutotrasportatoriTableCellRender();
//					/* (non Javadoc)
//					 * @see javax.swing.JTable#getCellRenderer(int, int)
//					 */
//					public TableCellRenderer getCellRenderer(
//						int arg0,
//						int arg1) {
//						// TODO Stub di metodo generato automaticamente
//						return tcr;
//					}
//
//			};


			

			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPaneLista
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPaneLista() {
		if (jScrollPaneLista == null) {
			jScrollPaneLista = new javax.swing.JScrollPane();
			jScrollPaneLista.setBounds(11, 9, 766, 178);
			jScrollPaneLista.setViewportView(getJTable());
		}
		return jScrollPaneLista;
	}
	/**
	 * This method initializes jTextFieldTarga
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTarga() {
		if (jTextFieldTarga == null) {
			jTextFieldTarga = new javax.swing.JTextField();
			jTextFieldTarga.setBounds(14, 251, 90, 21);
			jTextFieldTarga.setDocument(
				new StringDocument(AutotrasportatoriQuadroA.getDimTarga()));
			jTextFieldTarga.addFocusListener(this);
		}
		return jTextFieldTarga;
	}
	/**
	 * This method initializes jComboBoxTitoloPossesso
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxTitoloPossesso() {
		if (jComboBoxTitoloPossesso == null) {
			jComboBoxTitoloPossesso = new javax.swing.JComboBox();
			jComboBoxTitoloPossesso.setBounds(108, 251, 51, 21);
			//jComboBoxTitoloPossesso.setDocument(new StringDocument(AutotrasportatoriQuadroA.getDimTitoloPossesso()));
		}
		return jComboBoxTitoloPossesso;
	}
	/**
	 * This method initializes jTextFieldDataIniPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataIniPoss() {
		if (jTextFieldDataIniPoss == null) {
			jTextFieldDataIniPoss = new javax.swing.JTextField();
			jTextFieldDataIniPoss.setBounds(163, 251, 91, 21);
			jTextFieldDataIniPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimDataInizioPossesso()));
			jTextFieldDataIniPoss.addFocusListener(this);
		}
		return jTextFieldDataIniPoss;
	}
	/**
	 * This method initializes jTextFieldDataFinPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataFinPoss() {
		if (jTextFieldDataFinPoss == null) {
			jTextFieldDataFinPoss = new javax.swing.JTextField();
			jTextFieldDataFinPoss.setBounds(258, 251, 92, 21);
			jTextFieldDataFinPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimDataFinePossesso()));
			jTextFieldDataFinPoss.addFocusListener(this);
		}
		return jTextFieldDataFinPoss;
	}
	/**
	 * This method initializes jTextFieldNumFatt
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNumFatt() {
		if (jTextFieldNumFatt == null) {
			jTextFieldNumFatt = new javax.swing.JTextField();
			jTextFieldNumFatt.setBounds(354, 251, 67, 21);
			jTextFieldNumFatt.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimNumeroFatture()));
			jTextFieldNumFatt.addFocusListener(this);
		}
		return jTextFieldNumFatt;
	}
	/**
	 * This method initializes jTextFieldNumSchede
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNumSchede() {
		if (jTextFieldNumSchede == null) {
			jTextFieldNumSchede = new javax.swing.JTextField();
			jTextFieldNumSchede.setBounds(425, 251, 60, 21);
			jTextFieldNumSchede.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimNumeroSchede()));
			jTextFieldNumSchede.addFocusListener(this);
		}
		return jTextFieldNumSchede;
	}
	/**
	 * This method initializes jTextFieldLitrCons
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldLitrCons() {
		if (jTextFieldLitrCons == null) {
			jTextFieldLitrCons = new javax.swing.JTextField();
			jTextFieldLitrCons.setBounds(490, 251, 76, 21);
			jTextFieldLitrCons.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimLitriConsumati()));
			jTextFieldLitrCons.addFocusListener(this);
		}
		return jTextFieldLitrCons;
	}
	/**
	 * This method initializes jTextFieldKmPerc
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldKmPerc() {
		if (jTextFieldKmPerc == null) {
			jTextFieldKmPerc = new javax.swing.JTextField();
			jTextFieldKmPerc.setBounds(570, 251, 105, 21);
			jTextFieldKmPerc.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimChilometriPercorsi()));
			jTextFieldKmPerc.addFocusListener(this);
		}
		return jTextFieldKmPerc;
	}
	/**
	 * This method initializes jTextFieldImporto
	 * 
	 * @return javax.swing.JTextField
	 */
	protected javax.swing.JTextField getJTextFieldImporto() {
		if (jTextFieldImporto == null) {
			jTextFieldImporto = new javax.swing.JTextField();
			jTextFieldImporto.setBounds(678, 251, 100, 21);
			jTextFieldImporto.setDocument(
				new BigDecimalDocument(
					AutotrasportatoriQuadroA.getDimImportoInt(),
					AutotrasportatoriQuadroA.getDimImportoDec()));
			jTextFieldImporto.addFocusListener(this);
		}
		return jTextFieldImporto;
	}
	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(null);
			jPanel3.setLayout(FullScreenLayoutManager.getInstance());
			jPanel3.add(getJButtonInserisci(), null);
			jPanel3.add(getJButtonModifica(), null);
			jPanel3.add(getJButtonElimina(), null);
			jPanel3.setBounds(440, 280, 337, 44);
			jPanel3.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
		}
		return jPanel3;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if (jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(17, 7, 93, 28);
			jButtonInserisci.setText("Inserisci");
			jButtonInserisci.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonInserisci.addActionListener(this);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if (jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(121, 8, 93, 28);
			jButtonModifica.setText("Modifica");
			jButtonModifica.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonModifica.addActionListener(this);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if (jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(229, 8, 93, 28);
			jButtonElimina.setText("Elimina");
			jButtonElimina.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonElimina.addActionListener(this);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(15, 429, 93, 28);
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(112, 429, 93, 28);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setBounds(475, 29, 76, 19);
			jLabel.setText("consumati");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	
	/**
		 * @return
		 */
		public int getQuadroSelezionato() {
			return quadroSelezionato;
		}

		/**
		 * @param i
		 */
		public void setQuadroSelezionato(int i) {
			quadroSelezionato = i;
		}
} //  @jve:visual-info  decl-index=0 visual-constraint="10,10"