package it.finanze.dogane.accise.aautotrasportatori.ui;

import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroA;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroB;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.renderer.AutotrasportatoriTableCellRender;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroATM;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroB1TM;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroB2TM;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroBTM;
import it.finanze.dogane.accise.combo.AbstractTipo;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.ComboUtil;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.combo.TipoPossesso;
import it.finanze.dogane.accise.combo.TipoProvincia;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigDecimalDocument;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.ui.validation.Validator;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Component;
import java.awt.Container;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableModel;
import javax.swing.text.JTextComponent;

public class AutotrasportatoriQuadroBNewDialog
	extends JDialog
	implements
		ActionListener,
		ListSelectionListener,
		QuadroDialog,
		PdfPrintable,
		FocusListener {

	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelIntestazioneQuadro = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabelTarga = null;
	private javax.swing.JLabel jLabelTitPoss1 = null;
	private javax.swing.JLabel jLabelTitPoss2 = null;
	private javax.swing.JLabel jLabelDataInizPoss = null;
	private javax.swing.JLabel jLabelDataInizPoss2 = null;
	private javax.swing.JLabel jLabelDataInizPoss3 = null;
	private javax.swing.JLabel jLabelDataFinPoss1 = null;
	private javax.swing.JLabel jLabelDataFinPoss2 = null;
	private javax.swing.JLabel jLabelDataFinPoss3 = null;
	
	private javax.swing.JLabel jLabelNumSchede = null;
	private javax.swing.JLabel jLabel1LitriConsumati = null;
	private javax.swing.JLabel jLabel1Kmpercorsi = null;
	private javax.swing.JLabel jLabel1ImportEuro = null;
	private javax.swing.JScrollPane jScrollPaneLista = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JTextField jTextFieldTarga = null;
	private javax.swing.JComboBox jComboBoxTitoloPossesso = null;
	private javax.swing.JTextField jTextFieldDataIniPoss = null;
	private javax.swing.JTextField jTextFieldDataFinPoss = null;
	private javax.swing.JTextField jTextFieldNumFatt = null;
	private javax.swing.JTextField jTextFieldNumSchede = null;
	protected javax.swing.JTextField jTextFieldLitrCons = null;
	private javax.swing.JTextField jTextFieldKmPerc = null;
	private javax.swing.JTextField jTextFieldImporto = null;
	private javax.swing.JPanel jPanel3 = null;
	private javax.swing.JButton jButtonInserisci = null;
	private javax.swing.JButton jButtonModifica = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JButton jButtonChiudiQuadroB = null;
	
	
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JRadioButton jRadioButtonInvisibile= null;
	private javax.swing.JRadioButton jRadioButtonSuperiore = null;
	private javax.swing.JRadioButton jRadioButtonInferiore = null;
	private ButtonGroup buttonGroupSelezioneInfSup = new ButtonGroup();
	private javax.swing.JLabel jLabel3 = null;
	private javax.swing.JRadioButton jRadioButtonGasolioUtilizzatoSi = null;
	private javax.swing.JRadioButton jRadioButtonGasolioUtilizzatoNo = null;
	private ButtonGroup buttonGroupGasolioUtilizzato = new ButtonGroup();
	
	private javax.swing.JPanel jPanelSerbSup10 = null;
	private javax.swing.JLabel jLabelCodDitta = null;
	private javax.swing.JLabel jLabelNumFatture = null;
	private javax.swing.JLabel jLabelTotLitri = null;
	private javax.swing.JLabel jLabelTotImporto = null;	
	private javax.swing.JTextField jTextCodDitta = null;
	private javax.swing.JTextField jTextNumFatture = null;
	private javax.swing.JTextField jTextTotLitri = null;
	private javax.swing.JTextField jTextTotImporto = null;
	
	private javax.swing.JPanel jPanelSerbInf10 = null;
	private javax.swing.JLabel jLabelProvincia = null;
	private javax.swing.JLabel jLabelComune = null;
	private javax.swing.JLabel jLabelIndirizzo = null;
	private javax.swing.JLabel jLabelCapStoccaggio = null;	
	private javax.swing.JLabel jLabelNumFattureInf = null;
	private javax.swing.JLabel jLabelTotLitriInf = null;
	private javax.swing.JLabel jLabelTotImportoInf = null;	
	
	private javax.swing.JComboBox jComboBoxInferioreProvincia = null;
	private javax.swing.JComboBox jComboBoxInferioreComune = null;
	private javax.swing.JTextField jTextIndirizzo = null;
	private javax.swing.JTextField jTextCapStoccaggio = null;
	private javax.swing.JTextField jTextNumFattureInf = null;
	private javax.swing.JTextField jTextTotLitriInf = null;
	private javax.swing.JTextField jTextTotImportoInf = null;

	private boolean flagModifica = false;
	private List listaValidate = null;
	protected ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	protected AutotrasportatoriFrame autotrasportatoriFrame = null;

	
	
	protected String titolo = "";
	private int quadroSelezionato;
	private AutotrasportatoriQuadroB1TM modelSup10 = null;
	private AutotrasportatoriQuadroB2TM modelInf10 = null;
	private List listaSup10 = new ArrayList();
	private List listaInf10 = new ArrayList();
	
	
	private List listaDiPartenzaSup10 = new ArrayList();
	private List listaDiPartenzaInf10 = new ArrayList();
	private List listaQuadro =  new ArrayList();
	
	private URL urlV = getClass().getClassLoader().getResource("it/finanze/dogane/accise/ui/icons/Tick_Serbatoio.gif");
	private ImageIcon iconV = new ImageIcon(urlV);
	private javax.swing.JLabel jLabelIconSerbSup10 = new javax.swing.JLabel(iconV);
	private javax.swing.JLabel jLabelIconSerbInf10 = new javax.swing.JLabel(iconV);
	
	private String radioGasolioSelezionato = "";
	
	//URL urlNull = getClass().getClassLoader().getResource("it/finanze/dogane/accise/ui/icons/Nullo.gif");
			
	
	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriQuadroBNewDialog(
		Frame frame,
		String titolo ,
		String description,
		String secondDescription) {
		
		super(frame, titolo, true);
		this.titolo = titolo;
		initialize();
		autotrasportatoriFrame=(AutotrasportatoriFrame)frame;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {		
		this.setSize(
			RealDim.getAbsoluteXValue(800),
			RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setTitle("Esercente con distributore privato di carburante");	
		initComboValues();	
	}
	
	private void initComboValues() {
		jComboBoxInferioreComune.removeActionListener(this);
		jComboBoxInferioreProvincia.removeActionListener(this);
	
		ComboUtil.setValues(jComboBoxInferioreProvincia,ComboDataSource.getInstance().getProvince());
		String codiceProvincia =((TipoProvincia) jComboBoxInferioreProvincia.getSelectedItem()).getCodice();
		ComboUtil.setValues(jComboBoxInferioreComune,ComboDataSource.getInstance().getComuni(codiceProvincia));
	
		jComboBoxInferioreProvincia.setSelectedIndex(-1);
		jComboBoxInferioreComune.setSelectedIndex(-1);
		
		jComboBoxInferioreComune.addActionListener(this);
		jComboBoxInferioreProvincia.addActionListener(this);
	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
		
		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		this.quadro = (Quadro) gestoreQuadro;


		List listaCompleta = prospettoConsumo.getListaQuadro( Quadro.QUADRO_B );
		String gasolio ="";	
		
		
		for (Iterator iter = listaCompleta.iterator(); iter.hasNext();) {
			AutotrasportatoriQuadroB element = (AutotrasportatoriQuadroB) iter.next();
			gasolio = element.getGasolioUtilizzatoRifornimAutovQuadroA();
			
			if(element.getTipoSerbatoio().equalsIgnoreCase("A")){				
				listaSup10.add(element);
				try {
					listaDiPartenzaSup10.add(element.clone());
				} catch (CloneNotSupportedException e) {
					e.printStackTrace();
				}
								
			}else if(element.getTipoSerbatoio().equalsIgnoreCase("B")){				
				listaInf10.add(element);				
				try {
					listaDiPartenzaInf10.add(element.clone());
				} catch (CloneNotSupportedException e) {
					e.printStackTrace();
				}							
			}
		}			
	
		if(gasolio.equalsIgnoreCase("S")){
			getJRadioButtonGasolioUtilizzatoSi().setSelected(true);
			radioGasolioSelezionato ="S";
		}else if(gasolio.equalsIgnoreCase("N")){
			getJRadioButtonGasolioUtilizzatoNo().setSelected(true);
			radioGasolioSelezionato ="N";
		}
		
		visualizzaIconSerbatoio(listaSup10,listaInf10);
			
		
		modelSup10 = new AutotrasportatoriQuadroB1TM(listaSup10);
		modelInf10 = new AutotrasportatoriQuadroB2TM(listaInf10);
		
		jTable.setModel(modelSup10);
		//TableUtil.redimTable(jTable, jScrollPaneLista);

		
	}
	

	public void visualizzaIconSerbatoio(List listSup, List listInf) {
		
		if(listSup.size() > 0)
			jLabelIconSerbSup10.setVisible(true);
		else
			jLabelIconSerbSup10.setVisible(false);
				
		if(listInf.size() > 0)
			jLabelIconSerbInf10.setVisible(true);
		else
			jLabelIconSerbInf10.setVisible(false);
		
	}

	public void plot(PdfBuilder builder, String quadroStr) {
		
		builder.startCommandBlock();
		float y = builder.getYPen();
		builder.writeLeftLabel(quadroStr.toUpperCase(), 12);
		//SALVATORE
		builder.endCommandBlock();
		builder.startDefineTableHeader();		
		//
		float y2 = builder.getYPen();
		builder.moveYPen(y - y2);
		String titolo1 = "";
		String titolo2 = "";
		if( this.getTitle().length() > 43 ) {
			titolo1 = this.getTitle().substring(0, this.getTitle().length() - 44);
			titolo2 = this.getTitle().substring(
													this.getTitle().length() - 44,
													this.getTitle().length()
												);
		}
		builder.writeRightLabel(titolo1.toUpperCase(), 12);
		builder.writeRightLabel(titolo2.toUpperCase(), 12);
		
		builder.setXPen(PdfBuilder.MARGINE);
		builder.writeLeftLabel("", 20);
		//SALVATORE
		//builder.endCommandBlock();
		builder.endDefineTableHeader();		
		//

		builder.writeTable(this, jTable, jScrollPaneLista);
		builder.setXPen(PdfBuilder.MARGINE);
		builder.moveYPen(50);		
		
		
	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/

	public void actionPerformed(ActionEvent event) {
		try {
			if (event.getSource() == jButtonChiudi) {
				doClose();
			} else if (event.getSource() == jButtonChiudiQuadroB) {
				chiudiQuadroB("Chiudi");
			}else if (event.getSource() == jButtonConferma) {
				doConfirm();
			} else if (event.getSource() == jButtonElimina) {
				doDelete();
			} else if (event.getSource() == jButtonInserisci) {
				doInsert();
			} else if (event.getSource() == jButtonModifica) {
				doUpdate();
			}else if (event.getSource() == jRadioButtonSuperiore) {				
				gestisciTableModel(modelSup10,true,false);			
			} else if (event.getSource() == jRadioButtonInferiore) {
				gestisciTableModel(modelInf10,false,true);
			}else if (event.getSource() == jComboBoxInferioreProvincia) {
				updateComboValues();
			} else if (event.getSource() == jRadioButtonGasolioUtilizzatoNo || event.getSource() == jRadioButtonGasolioUtilizzatoSi) {
				
				jRadioButtonGasolioUtilizzatoNo.setEnabled(false);
				jRadioButtonGasolioUtilizzatoSi.setEnabled(false);
				JOptionPane.showMessageDialog(this,new JLabel("La  selezione effettuata di Gasolio utilizzato per il rifornimento dei soli autoveicoli del quadro A   valida per entrambe le tipologie di serbatoio"),"Attenzione",JOptionPane.WARNING_MESSAGE);
				
			}
			
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				e.getMessage(),
				"Errore",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void setTableCellAlignmentRIGHT(String[]columnsAlignement) {
		
	
		for (int i=0; i<columnsAlignement.length;i++){
			DefaultTableCellRenderer dtcr = (DefaultTableCellRenderer)jTable.getColumn(columnsAlignement[i]).getCellRenderer();
			dtcr.setHorizontalAlignment(JLabel.RIGHT);
		}
	 }
	
	public void gestisciTableModel(TableModel model, boolean pannelloSup, boolean pannelloInf){
		
		JButton btConferma = getJButtonConferma();
		if(!btConferma.isVisible()){
						
			btConferma.setVisible(true);//visibile il conferma
			getJButtonChiudiQuadroB().setVisible(true);
			getJButtonChiudi().setVisible(false);
		}
		
		if(getJRadioButtonInferiore().isSelected()){
			getJRadioButtonSuperiore().setEnabled(false);			
		}else if(getJRadioButtonSuperiore().isSelected()){
			getJRadioButtonInferiore().setEnabled(false);			
		}		
		
		
		 
		jTable.setModel(model);
		for (int i = 0; i < jTable.getColumnCount(); i++) {
			DefaultTableCellRenderer d = new DefaultTableCellRenderer();
			 jTable.getColumnModel().getColumn(i).setCellRenderer(d);
		}
		if(model instanceof AutotrasportatoriQuadroB1TM)
			this.setTableCellAlignmentRIGHT(new String[]{"Numero fatture d'acquisto","Totale litri fatturati","Totale importo"});
		if(model instanceof AutotrasportatoriQuadroB2TM)
			this.setTableCellAlignmentRIGHT(new String[]{"Capacita'","Numero fatt.","Totale litri","Totale importo"});

		
		
		
		if(model instanceof AutotrasportatoriQuadroB1TM)
			dimensionaTable(jTable,new int[]{175,175,175,175});
		else if(model instanceof AutotrasportatoriQuadroB2TM) 
			dimensionaTable(jTable,new int[]{100,100,240,65,65,65,65});
		
		
		jLabel3.setVisible(true);
		jRadioButtonGasolioUtilizzatoSi.setVisible(true);
		jRadioButtonGasolioUtilizzatoNo.setVisible(true);
		
		//TableUtil.redimTable(jTable, jScrollPaneLista);
		
		
		jScrollPaneLista.setVisible(true);
		jPanel3.setVisible(true);
		jPanelSerbSup10.setVisible(pannelloSup);
		jPanelSerbInf10.setVisible(pannelloInf);
		
		
		
	}
	
	
	public void dimensionaTable(JTable jTable, int[]dimension){
		
		for(int i=0; i<dimension.length; i++) {
			
			jTable.getColumnModel().getColumn(i).setPreferredWidth(RealDim.getAbsoluteXValue(dimension[i]));
			
		}
	}
	
	
	
	public void chiudiQuadroB(String pulsante){	
		
		
		if(pulsante.equalsIgnoreCase("Chiudi")){			
			
			int val = validateExitText();  				
			if (val == JOptionPane.YES_OPTION) {       
				doConfirm();				 				
				return;                           
			}else if (val == JOptionPane.NO_OPTION) {
				flagModifica = false;
			}
			else if (val == JOptionPane.CANCEL_OPTION) {
				return;
			}
			getModelSup10().setNewListaRecord(listaDiPartenzaSup10);
			getModelInf10().setNewListaRecord(listaDiPartenzaInf10);	
			
			 				
				
		}
		
			getJButtonChiudi().setVisible(true);
			getJButtonChiudiQuadroB().setVisible(false);
			getJButtonConferma().setVisible(false);			
			jScrollPaneLista.setVisible(false);
			jPanel3.setVisible(false);
			jPanelSerbSup10.setVisible(false);
			jPanelSerbInf10.setVisible(false);
			getJRadioButtonInferiore().setEnabled(true);
			getJRadioButtonSuperiore().setEnabled(true);
			getJRadioButtonInvisibile().setSelected(true);
			
			//gestione radio gasolio
			jLabel3.setVisible(false);
			jRadioButtonGasolioUtilizzatoSi.setVisible(false);
			jRadioButtonGasolioUtilizzatoNo.setVisible(false);
			jRadioButtonGasolioUtilizzatoSi.setEnabled(true);
			jRadioButtonGasolioUtilizzatoNo.setEnabled(true);
			
			
			clearFields(getModelSup10());
			clearFields(getModelInf10());
			
			if(radioGasolioSelezionato.equalsIgnoreCase("S"))
				getJRadioButtonGasolioUtilizzatoSi().setSelected(true);
			else if(radioGasolioSelezionato.equalsIgnoreCase("N")) 
				getJRadioButtonGasolioUtilizzatoNo().setSelected(true);
	}
	
	
	private void updateComboValues() {
			AbstractTipo tipo =
				(AbstractTipo) jComboBoxInferioreProvincia.getSelectedItem();
			if (tipo == null) {
				tipo = (AbstractTipo) jComboBoxInferioreProvincia.getItemAt(0);
			}
			updateComboValues(tipo.getCodice());
		}
		
		
		private void updateComboValues(String provincia) {
				if (jComboBoxInferioreProvincia.getSelectedIndex()!=-1) {		
					ComboUtil.setValues(
						jComboBoxInferioreComune,
						ComboDataSource.getInstance().getComuni(provincia));
				}

		}
			
	private void doUpdate() {	
			
		AutotrasportatoriQuadroBTM model = (AutotrasportatoriQuadroBTM) jTable.getModel();	
		boolean boolModEseguita = false;
		
		
				int selectedRow = jTable.getSelectedRow();
				if (selectedRow != -1) {
					AutotrasportatoriQuadroB record =
						(AutotrasportatoriQuadroB) model.getRecord(selectedRow);
					try {
						//this.loadRecordFromUI(record,model);
						
						boolean boolObbligatori = this.validaCampi(model) ;
						boolean boolDuplicita = true;
						
						if(model instanceof AutotrasportatoriQuadroB1TM)
							boolDuplicita = this.validateCodiceDittaUpdate(model.getListaRecord(),selectedRow);
						
						if( boolObbligatori && boolDuplicita){
							
						//controllo capacit stoccaggio
						if(model instanceof AutotrasportatoriQuadroB2TM){
										
							if (new BigDecimal(jTextCapStoccaggio.getText()).doubleValue() > 10){
						
									JOptionPane.showMessageDialog(this,"La capacit di stoccaggio  superiore ai 10 mc.","Attenzione",JOptionPane.WARNING_MESSAGE);
									return;			
							}	
						}
						//end controllo capacit stoccaggio	
												
							
							this.loadRecordFromUI(record,model);					
								
														
							model.setRecord(selectedRow, record);	
							boolModEseguita = true;
							flagModifica = true;
							
						}							
						
					} catch (Exception e) {
						JOptionPane.showMessageDialog(
							this,
							e.getMessage(),
							"Errore",
							JOptionPane.ERROR_MESSAGE);
					}
				} else {
					JOptionPane.showMessageDialog(
						this,
						"Selezionare un elemento dalla lista",
						"Attenzione",
						JOptionPane.WARNING_MESSAGE);
				}			
			
			if(boolModEseguita)
				jTable.removeRowSelectionInterval( 0, jTable.getRowCount()-1 );
		
	}

	/**
	 * 
	 */
	private void doInsert() {
				
		AutotrasportatoriQuadroBTM model = (AutotrasportatoriQuadroBTM) jTable.getModel();		
		
		boolean boolObbligatori = this.validaCampi(model) ;
		boolean boolDuplicita = true;
		
		
		
		if(model instanceof AutotrasportatoriQuadroB1TM)
			boolDuplicita =this.validateCodiceDitta(model.getListaRecord());
		
		if (boolObbligatori && boolDuplicita) {						
			
			AutotrasportatoriQuadroB record = AutotrasportatoriQuadroB.getNewObject(prospettoConsumo);
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			try {
				
				
				this.loadRecordFromUI(record,model);
				
				//controllo capacit stoccaggio
				if(model instanceof AutotrasportatoriQuadroB2TM){
										
					if (record.getInferioreCapacitaStoccaggioSerbatoio().doubleValue() > 10){
						
						JOptionPane.showMessageDialog(this,"La capacit di stoccaggio  superiore ai 10 mc.","Attenzione",JOptionPane.WARNING_MESSAGE);
						return;			
					}	
				}
				//end controllo capacit stoccaggio
		
				model.insertRecord(record);
				this.clearFields(model);
				flagModifica = true;
				
				
			} catch (Exception e) {
				JOptionPane.showMessageDialog(
					this,
					e.getMessage(),
					"Errore",
					JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
 private boolean validateCodiceDitta(List list) {
 	
	boolean isPresent = true;

	Iterator it = list.iterator();
	boolean found = false;
	while (it.hasNext()) {
		AutotrasportatoriQuadroB record =
			(AutotrasportatoriQuadroB) it.next();
		if (record.getSuperioreCodiceDitta().equals(jTextCodDitta.getText())) {
			JOptionPane.showMessageDialog(
				this,
				"Codice ditta gi presente nel quadro",
				"Attenzione",
				JOptionPane.ERROR_MESSAGE);
			isPresent = false;
			jTextCodDitta.selectAll();
			jTextCodDitta.grabFocus();
		}
	}
	return isPresent;
}

	private boolean validateCodiceDittaUpdate(List list,int rowToUpdate) {
		boolean isPresent = true;
		Iterator it = list.iterator();
		boolean found = false;
		int rowToCheck=-1;
		while (it.hasNext()) {
			rowToCheck++;
			AutotrasportatoriQuadroB record =
				(AutotrasportatoriQuadroB) it.next();
			if (record.getSuperioreCodiceDitta().equals(jTextCodDitta.getText())&&(rowToCheck!=rowToUpdate)) {
				JOptionPane.showMessageDialog(
					this,
					"Codice ditta gi presente nel quadro",
					"Attenzione",
					JOptionPane.ERROR_MESSAGE);
				isPresent = false;
				jTextCodDitta.selectAll();
				jTextCodDitta.grabFocus();
			}
		}
		return isPresent;
	}

	
	private boolean validaCampi(TableModel model) {
		
		JComponent componentErrore = null;	
		String messaggioErrore ="";
		
		
		if(model instanceof AutotrasportatoriQuadroB1TM){
			
			if(StringUtil.nullify(jTextCodDitta.getText()) == null){
				messaggioErrore ="Digitare il codice ditta.";
				componentErrore = jTextCodDitta;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			
			if(!Validator.isCodiceDittaForCarbonTax(jTextCodDitta.getText())) {
				messaggioErrore ="Codice Ditta errato.";
				componentErrore = jTextCodDitta;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;					
			}
			
			String numfatture = StringUtil.nullify(jTextNumFatture.getText());
			if(numfatture == null || Integer.parseInt(numfatture) <=0 ){
				messaggioErrore ="Digitare il numero di fatture.";
				componentErrore = jTextNumFatture;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			String totLitri = StringUtil.nullify(jTextTotLitri.getText());
			if(totLitri == null || Integer.parseInt(totLitri) <=0 ){
				messaggioErrore ="Digitare il totale litri.";
				componentErrore = jTextTotLitri;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			String totImporto = StringUtil.nullify(jTextTotImporto.getText());
			if(totImporto == null || Double.parseDouble(totImporto) <=0 ){
				messaggioErrore ="Digitare il totale importo.";
				componentErrore = jTextTotImporto;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			
			
		}else if(model instanceof AutotrasportatoriQuadroB2TM){	
			
			
			if(jComboBoxInferioreProvincia.getSelectedIndex() == -1){
				messaggioErrore ="Scegliere la provincia.";
				componentErrore = jComboBoxInferioreProvincia;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			if(jComboBoxInferioreComune.getSelectedIndex() == -1){
				messaggioErrore ="Scegliere il comune.";
				componentErrore = jComboBoxInferioreComune;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}	
			
				
			if(StringUtil.nullify(jTextIndirizzo.getText()) == null){
				messaggioErrore ="Digitare l'indirizzo.";
				componentErrore = jTextIndirizzo;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			String capStoccaggio = StringUtil.nullify(jTextCapStoccaggio.getText());	
			if(capStoccaggio == null || Double.parseDouble(capStoccaggio) <=0 ){
				messaggioErrore ="Digitare la capacit di stoccaggio.";
				componentErrore = jTextCapStoccaggio;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			String numFattureInf = StringUtil.nullify(jTextNumFattureInf.getText());	
			if(numFattureInf == null || Integer.parseInt(numFattureInf) <=0 ){
				messaggioErrore ="Digitare il numero di fatture.";
				componentErrore = jTextNumFattureInf;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;		}
			
			String totLitriInf = StringUtil.nullify(jTextTotLitriInf.getText());	
			if(totLitriInf == null || Integer.parseInt(totLitriInf) <=0 ){
				messaggioErrore ="Digitare il totale litri.";
				componentErrore = jTextTotLitriInf;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}
			
			String totImportoInf = StringUtil.nullify(jTextTotImportoInf.getText());	
			if(totImportoInf == null || Double.parseDouble(totImportoInf) <=0 ){
				messaggioErrore ="Digitare il totale importo.";
				componentErrore = jTextTotImportoInf;
				getMessaggioErrore(componentErrore,messaggioErrore);				
				return false;
			}		
			
			
		}
		
		return true;
	}
	
	
	
	
	public void getMessaggioErrore(JComponent componentErrore,String messaggioErrore){
		
		
		JOptionPane.showMessageDialog(
									this,
									messaggioErrore,
									"Attenzione",
									JOptionPane.ERROR_MESSAGE);	
									
		if(componentErrore instanceof JTextField){
			((JTextField)componentErrore).selectAll();									
		}
		
		componentErrore.grabFocus();
	}
	
	/**
	 * 
	 */
	private void doDelete() {
		
		AutotrasportatoriQuadroBTM model = (AutotrasportatoriQuadroBTM) jTable.getModel();
			
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFields(model);
			flagModifica = true;
		} else {
			JOptionPane.showMessageDialog(
				this,
				"Selezionare un elemento dalla lista",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void doConfirm() {
		
		boolean boolGasolioSi = getJRadioButtonGasolioUtilizzatoSi().isSelected();
		boolean boolGasolioNo = getJRadioButtonGasolioUtilizzatoNo().isSelected();
		
		List listaQuadroC = prospettoConsumo.getListaQuadro( Quadro.QUADRO_C );
		boolean  boolListaQuadroC = listaQuadroC.size() > 0;
		
		
		//tali liste comprendono anche la situazione pregressa,
		//non solo quella attuale
		List list1 = getModelSup10().getListaRecord();
		List list2 = getModelInf10().getListaRecord();		
		int len1 = list1.size();
		int len2 = list2.size();
		
		
		//se  riempito il Quadro C, non si pu 'azzerare' il Quadro B
		if(boolListaQuadroC && len1 == 0 && len2 == 0){
			
			JOptionPane.showMessageDialog(this,"Il quadro B non pu essere cancellato poich risulta compilato il quadro C.","Attenzione",JOptionPane.ERROR_MESSAGE);
			return;//fuori dal metodo				
		}	
		
		
		//se  riempito il Quadro C, non si pu selezionare 'Si' per il Quadro B
		if(boolListaQuadroC && boolGasolioSi){
			
			JOptionPane.showMessageDialog(this,"Non  possibile selezionare SI poich risulta compilato il quadro C.","Attenzione",JOptionPane.ERROR_MESSAGE);
			getJRadioButtonGasolioUtilizzatoNo().setEnabled(true);
			return;//fuori dal metodo				
		}
		
		
		//il ceck gasolio  obbligatorio
		if(!boolGasolioSi && !boolGasolioNo){
			
			JOptionPane.showMessageDialog(this,"Indicare se gasolio utilizzato per il rifornimento dei soli autoveicoli del Quadro A.","Attenzione",JOptionPane.ERROR_MESSAGE);
			return;//fuori dal metodo				
			
		}
		
		if(boolGasolioSi)
			radioGasolioSelezionato ="S";
		else if(boolGasolioNo)
			radioGasolioSelezionato ="N";
		
		
		 
		
		
		//le liste vanno azzerate
		listaQuadro = new ArrayList();
		listaDiPartenzaSup10 = new ArrayList();
		listaDiPartenzaInf10  = new ArrayList();
		
		for (int i = 0; i < len1; i++) {
			AutotrasportatoriQuadroB element = (AutotrasportatoriQuadroB)list1.get(i);
			AutotrasportatoriQuadroB elementClonato = null;			
			try {
				elementClonato = (AutotrasportatoriQuadroB)element.clone();
				elementClonato.setGasolioUtilizzatoRifornimAutovQuadroA(getJRadioButtonGasolioUtilizzatoSi().isSelected());
			} catch (CloneNotSupportedException e1) {				
				e1.printStackTrace();
			}			
			
			listaQuadro.add(elementClonato);
			listaDiPartenzaSup10.add(elementClonato);
			
		}
		
		//BigDecimal totaleCapacita=BigDecimal.valueOf(0);		
		for (int i = 0; i < len2; i++) {
			AutotrasportatoriQuadroB element = (AutotrasportatoriQuadroB)list2.get(i);
			AutotrasportatoriQuadroB elementClonato = null;	
			try {
				elementClonato = (AutotrasportatoriQuadroB)element.clone();
				elementClonato.setGasolioUtilizzatoRifornimAutovQuadroA(getJRadioButtonGasolioUtilizzatoSi().isSelected());
			} catch (CloneNotSupportedException e1) {				
				e1.printStackTrace();
			}		
			
			//totaleCapacita=totaleCapacita.add(element.getInferioreCapacitaStoccaggioSerbatoio());
			listaQuadro.add(elementClonato);
			listaDiPartenzaInf10.add(elementClonato);
			
		}	
		
		this.visualizzaIconSerbatoio(list1,list2);
			
		prospettoConsumo.setListaQuadro( listaQuadro, Quadro.QUADRO_B);
		
		/*if (getJRadioButtonInferiore().isSelected() && totaleCapacita.doubleValue() > 10) {
			JOptionPane.showMessageDialog(this,"La capacit di stoccaggio  superiore ai 10 mc.","Attenzione",JOptionPane.WARNING_MESSAGE);			
		}*/
		
		this.flagModifica = false;//azzeriamo il flag modifica
		this.chiudiQuadroB("Conferma");
		
	}
	
	private void doClose() {		
		
		this.setVisible(false);
		
	}

	private int validateExitText() {
		int retvalue = JOptionPane.NO_OPTION;
		if (flagModifica == true) {
			retvalue =
				JOptionPane.showConfirmDialog(
					this,
					"Le modifiche effettuate verranno perse. Vuoi salvare le modifiche?",
					"",
					JOptionPane.YES_NO_CANCEL_OPTION);
		}
		return retvalue;
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadUIFromRecord();
		}
	}

	/**
	 * @param record
	 */
	protected void loadRecordFromUI(AutotrasportatoriQuadroB record,TableModel model) {

		String str = null;

		if(model instanceof AutotrasportatoriQuadroB1TM){		
		
			str = jTextCodDitta.getText();			
			record.setSuperioreCodiceDitta(str);
			
			try {
				str = jTextNumFatture.getText();
				BigInteger i = new BigInteger(str);
				record.setSuperioreNumeroFatture(i);
			} catch (NumberFormatException e) {
				record.setSuperioreNumeroFatture(BigInteger.ZERO);
			}
		
			
			try {
				str = jTextTotLitri.getText();
				BigInteger d = new BigInteger(str);
				record.setSuperioreTotaleLitri(d);
			} catch (NumberFormatException e) {
				record.setSuperioreTotaleLitri(BigInteger.ZERO);
			}
		
			
		
			try {
				str = jTextTotImporto.getText();
				BigDecimal i = new BigDecimal(str);
				record.setSuperioreTotaleImporto(i);
			} catch (NumberFormatException e) {
				record.setSuperioreTotaleImporto(BigDecimal.valueOf(0));
			}
			
			//tipo serbatoio A
			record.setTipoSerbatoio("A");
		
		}else if (model instanceof AutotrasportatoriQuadroB2TM){
			
			try {	
				record.setInferioreCapacitaStoccaggioSerbatoio(new BigDecimal(jTextCapStoccaggio.getText()));
			} catch (NumberFormatException e) {
				record.setInferioreCapacitaStoccaggioSerbatoio(BigDecimal.valueOf(0));
			}
	
			record.setInferioreIndirizzoUbicazioneImpianto(jTextIndirizzo.getText());
				
			try {
				record.setInferioreNumeroFatture(new BigInteger(jTextNumFattureInf.getText()));
			} catch (NumberFormatException e) {
				record.setInferioreNumeroFatture(BigInteger.valueOf(0));
			}
	
			try {
				record.setInferioreTotaleImporto(new BigDecimal(jTextTotImportoInf.getText()));
			} catch (NumberFormatException e) {
				record.setInferioreTotaleImporto(BigDecimal.valueOf(0));
			}
	
			try {
				record.setInferioreTotaleLitri(new BigInteger(jTextTotLitriInf.getText()));
			} catch (NumberFormatException e) {
				record.setInferioreTotaleLitri(BigInteger.valueOf(0));
			}
	
			//record.setInferioreGasolioUtilizzatoRifornimAutovQuadroA(jRadioButtonInferioreGasolioUtilizzatoSi.isSelected());
				
			AbstractTipo tipo =
				(AbstractTipo) this.jComboBoxInferioreComune.getSelectedItem();
			record.setInferioreComuneUbicazioneImpianto(tipo.getDescrizione());
	
			tipo = (AbstractTipo) this.jComboBoxInferioreProvincia.getSelectedItem();
			record.setInferioreProvinciaUbicazioneImpianto(tipo.getCodice());
			
			//tipo serbatoio B
			record.setTipoSerbatoio("B");
		}
		
	}
	
	

	private void loadUIFromRecord() {
		
		AutotrasportatoriQuadroBTM model = (AutotrasportatoriQuadroBTM) jTable.getModel();
		
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow == -1) {
			//clearFields(model);
		} else {

			AutotrasportatoriQuadroB record =
				(AutotrasportatoriQuadroB) model.getRecord(selectedRow);

			if(model instanceof AutotrasportatoriQuadroB1TM){
				
				jTextCodDitta.setText(record.getSuperioreCodiceDitta().toString());
				jTextNumFatture.setText(record.getSuperioreNumeroFatture().toString());
				jTextTotLitri.setText(record.getSuperioreTotaleLitri().toString());
				jTextTotImporto.setText(record.getSuperioreTotaleImporto().toString());
				
			}else if(model instanceof AutotrasportatoriQuadroB2TM){
				
				ComboDataSource combo = ComboDataSource.getInstance();
				AbstractTipo tipoProvincia = combo.getProvincia(record.getInferioreProvinciaUbicazioneImpianto());
				AbstractTipo tipoComune = combo.getComunePerDescrizione(record.getInferioreProvinciaUbicazioneImpianto(),record.getInferioreComuneUbicazioneImpianto());
				
				jComboBoxInferioreProvincia.setSelectedItem(tipoProvincia);
				jComboBoxInferioreComune.setSelectedItem(tipoComune);				
				jTextIndirizzo.setText(record.getInferioreIndirizzoUbicazioneImpianto().toString());
				jTextCapStoccaggio.setText(record.getInferioreCapacitaStoccaggioSerbatoio().toString());
				jTextNumFattureInf.setText(record.getInferioreNumeroFatture().toString());
				jTextTotLitriInf.setText(record.getInferioreTotaleLitri().toString());
				jTextTotImportoInf.setText(record.getInferioreTotaleImporto().toString());
				
			}

			

			
		}
	}
	
	
	

	private void clearFields(TableModel model) {
		
		if(model instanceof AutotrasportatoriQuadroB1TM){
			
			jTextCodDitta.setText("");
			jTextNumFatture.setText("");
			jTextTotLitri.setText("");
			jTextTotImporto.setText("");			
			
		}else if(model instanceof AutotrasportatoriQuadroB2TM){			
	
			jComboBoxInferioreProvincia.setSelectedIndex(-1);
			jComboBoxInferioreComune.setSelectedIndex(-1);
			jTextIndirizzo.setText("");
			jTextCapStoccaggio.setText("");
			jTextNumFattureInf.setText("");
			jTextTotLitriInf.setText("");
			jTextTotImportoInf.setText("");
		}
		
		
	}

	public void focusGained(FocusEvent event) {}
	public void focusLost(FocusEvent event) {}


	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/


	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanelQuadroB(), null);
			jContentPane.add(getJPanelDistributore(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudiQuadroB(), null);
			jContentPane.add(getJButtonChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	
	private javax.swing.JPanel getJPanelQuadroB() {
			if(jPanel == null) {
				jPanel = new javax.swing.JPanel();
				jPanel.setLayout(null);
				jPanel.setLayout(FullScreenLayoutManager.getInstance());
				jPanel.add(getJLabelEsercente(), null);
				jPanel.setBounds(12, 10, 766, 68);
				jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Quadro B", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			}
			return jPanel;
	}
	
	private javax.swing.JLabel getJLabelEsercente() {
			if(jLabel == null) {
				jLabel = new javax.swing.JLabel();
				jLabel.setBounds(86, 26, 641, 22);
				jLabel.setText("Esercente con distributore privato di carburante");
			}
			return jLabel;
		}
		
	private javax.swing.JPanel getJPanelDistributore() {
		if(jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			
			
			
			jPanel1.add(getJLabelIconSerbatoioSup10(), null);
			jPanel1.add(getJLabelIconSerbatoioInf10(), null);
			
			jPanel1.add(getJLabelSerbatoioSup10(), null);
			jPanel1.add(getJLabelSerbatoioInf10(), null);
			jPanel1.add(getJRadioButtonSuperiore(), null);
			jPanel1.add(getJRadioButtonInferiore(), null);
			jPanel1.add(getJLabel3(), null);
			jPanel1.add(getJRadioButtonGasolioUtilizzatoSi(), null);
			jPanel1.add(getJRadioButtonGasolioUtilizzatoNo(), null);
			jPanel1.add(getJScrollPaneLista(), null);//tabella
			jPanel1.add(getJPanelSerbSup10(), null);//
			jPanel1.add(getJPanelSerbInf10(), null);//
			
			jPanel1.add(getJPanel3(), null);//
			
			/*jPanel1.add(getJLabelSuperiore1(), null);
			jPanel1.add(getJLabelSuperiore2(), null);
			jPanel1.add(getJLabelSuperiore3(), null);
			jPanel1.add(getJLabelSuperiore4(), null);
			jPanel1.add(getJLabelSuperiore5(), null);
			jPanel1.add(getJLabelInferiore1(), null);
			jPanel1.add(getJLabelInferiore2(), null);
			jPanel1.add(getJLabelInferiore3(), null);
			jPanel1.add(getJLabelInferiore4(), null);
			jPanel1.add(getJLabelInferiore5(), null);
			jPanel1.add(getJLabel11(), null);
			jPanel1.add(getJLabel12(), null);
			jPanel1.add(getJLabel13(), null);
			jPanel1.add(getJLabel14(), null);
			jPanel1.add(getJLabel15(), null);
			jPanel1.add(getJLabel16(), null);
			jPanel1.add(getJRadioButtonSuperiore(), null);
			jPanel1.add(getJRadioButtonInferiore(), null);
			jPanel1.add(getJTextFieldSuperioreCodiceDitta(), null);
			jPanel1.add(getJTextFieldSuperioreNumeroFatture(), null);
			jPanel1.add(getJTextFieldInferioreNumeroFatture(), null);
			jPanel1.add(getJTextFieldSuperioreTotaleLitri(), null);
			jPanel1.add(getJTextFieldInferioreTotaleLitri(), null);
			jPanel1.add(getJTextFieldSuperioreTotaleImporto(), null);
			jPanel1.add(getJTextFieldInferioreTotaleImporto(), null);
			jPanel1.add(getJRadioButtonSuperioreGasolioUtilizzatoSi(), null);
			jPanel1.add(getJRadioButtonInferioreGasolioUtilizzatoSi(), null);
			jPanel1.add(getJRadioButtonSuperioreGasolioUtilizzatoNo(), null);
			jPanel1.add(getJRadioButtonInferioreGasolioUtilizzatoNo(), null);
			jPanel1.add(getJComboBoxInferioreProvincia(), null);
			jPanel1.add(getJComboBoxInferioreComune(), null);
			jPanel1.add(getJTextFieldInferioreIndirizzo(), null);
			jPanel1.add(getJTextFieldInferioreCapacitaSerbatoio(), null);*/
			jPanel1.setBounds(12, 88, 766, 386);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Distributore", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return jPanel1;
	}
	
	private javax.swing.JLabel getJLabelIconSerbatoioSup10() {
		
		jLabelIconSerbSup10.setBounds(3, 30, 12, 22);	
		jLabelIconSerbSup10.setVisible(false);		
		return jLabelIconSerbSup10;
	  }
	  
	  private javax.swing.JLabel getJLabelIconSerbatoioInf10() {	
	  		
		jLabelIconSerbInf10.setBounds(3, 50, 12, 22);
		jLabelIconSerbInf10.setVisible(false);					
		  return jLabelIconSerbInf10;
		}
	
	private javax.swing.JLabel getJLabelSerbatoioSup10() {
	if(jLabel1 == null) {
		jLabel1 = new javax.swing.JLabel();
		jLabel1.setBounds(15, 30, 400, 22);
		jLabel1.setText("Collegato con serbatoio/i avente capacit superiore a 10 mc :");
	}
	return jLabel1;
  }
  private javax.swing.JLabel getJLabelSerbatoioInf10() {
	  if(jLabel2 == null) {
		jLabel2 = new javax.swing.JLabel();		
		jLabel2.setBounds(15, 50, 400, 22);
		jLabel2.setText("Collegato con serbatoio/i avente capacit inferiore o pari a 10 mc :");
	  }
	  return jLabel2;
	}
	
 private javax.swing.JRadioButton getJRadioButtonSuperiore() {
	if(jRadioButtonSuperiore == null) {
		jRadioButtonSuperiore = new javax.swing.JRadioButton();
		jRadioButtonSuperiore.setBounds(350, 30, 400, 22);
			
		buttonGroupSelezioneInfSup.add(jRadioButtonSuperiore);
		jRadioButtonSuperiore.addActionListener(this);
	}
	return jRadioButtonSuperiore;
  }
  
  private javax.swing.JRadioButton getJRadioButtonInferiore() {
	if(jRadioButtonInferiore == null) {
			jRadioButtonInferiore = new javax.swing.JRadioButton();
			jRadioButtonInferiore.setBounds(350, 50, 400, 22);
	
			buttonGroupSelezioneInfSup.add(jRadioButtonInferiore);
			jRadioButtonInferiore.addActionListener(this);
		}
		return jRadioButtonInferiore;
	}
	
	private javax.swing.JRadioButton getJRadioButtonInvisibile() {
		
		if(jRadioButtonInvisibile == null) {
			
			jRadioButtonInvisibile = new javax.swing.JRadioButton();	
			buttonGroupSelezioneInfSup.add(jRadioButtonInvisibile);
			jRadioButtonInvisibile.setVisible(false);
			}
			return jRadioButtonInvisibile;
	}
	
 private javax.swing.JLabel getJLabel3() {
	if(jLabel3 == null) {
		jLabel3 = new javax.swing.JLabel();
		jLabel3.setBounds(15, 70, 400, 22);
		jLabel3.setText("Gasolio utilizzato per rifornimento dei soli autoveicoli presenti nel Quadro A :");
		jLabel3.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
		jLabel3.setVisible(false);
	}
	return jLabel3;
}
	private javax.swing.JRadioButton getJRadioButtonGasolioUtilizzatoSi() {
		if(jRadioButtonGasolioUtilizzatoSi == null) {
			jRadioButtonGasolioUtilizzatoSi = new javax.swing.JRadioButton();
			jRadioButtonGasolioUtilizzatoSi.setBounds(350, 70, 40, 20);
			jRadioButtonGasolioUtilizzatoSi.setText("Si");
	
			buttonGroupGasolioUtilizzato.add(jRadioButtonGasolioUtilizzatoSi);			
			jRadioButtonGasolioUtilizzatoSi.addActionListener(this);			
			jRadioButtonGasolioUtilizzatoSi.setVisible(false);
		}
		return jRadioButtonGasolioUtilizzatoSi;
	}
	private javax.swing.JRadioButton getJRadioButtonGasolioUtilizzatoNo() {
			if(jRadioButtonGasolioUtilizzatoNo == null) {
				jRadioButtonGasolioUtilizzatoNo = new javax.swing.JRadioButton();
				jRadioButtonGasolioUtilizzatoNo.setBounds(390, 70, 40, 20);
				jRadioButtonGasolioUtilizzatoNo.setText("No");

				buttonGroupGasolioUtilizzato.add(jRadioButtonGasolioUtilizzatoNo);
				jRadioButtonGasolioUtilizzatoNo.addActionListener(this);				
				jRadioButtonGasolioUtilizzatoNo.setVisible(false);
			}
			return jRadioButtonGasolioUtilizzatoNo;
	}
	
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelIntestazioneQuadro(), null);
			jPanel.setBounds(10, 16, 789, 61);
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					titolo,
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabelIntestazioneQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelIntestazioneQuadro() {
		if (jLabelIntestazioneQuadro == null) {
			jLabelIntestazioneQuadro = new javax.swing.JLabel();
			jLabelIntestazioneQuadro.setBounds(100, 20, 580, 21);
			jLabelIntestazioneQuadro.setText(
				"Autoveicoli adibiti al trasporto merci con massa massima complessiva superiore A 3.5T/ Autoveicoli adibiti a trasporto di persone");
			jLabelIntestazioneQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelIntestazioneQuadro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelIntestazioneQuadro;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			jPanel1.add(getJPanel2(), null);
			jPanel1.add(getJScrollPaneLista(), null);
			jPanel1.add(getJTextFieldTarga(), null);
			jPanel1.add(getJComboBoxTitoloPossesso(), null);
			jPanel1.add(getJTextFieldDataIniPoss(), null);
			jPanel1.add(getJTextFieldDataFinPoss(), null);
			jPanel1.add(getJTextFieldNumFatt(), null);
			jPanel1.add(getJTextFieldNumSchede(), null);
			jPanel1.add(getJTextFieldLitrCons(), null);
			jPanel1.add(getJTextFieldKmPerc(), null);
			jPanel1.add(getJTextFieldImporto(), null);
			jPanel1.add(getJPanel3(), null);
			jPanel1.setBounds(10, 87, 789, 329);
			jPanel1.setBackground(java.awt.Color.lightGray);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			jPanel2.setLayout(null);
			jPanel2.setLayout(FullScreenLayoutManager.getInstance());
			jPanel2.add(getJLabelTarga(), null);
			jPanel2.add(getJLabelTitPoss1(), null);
			jPanel2.add(getJLabelTitPoss2(), null);
			jPanel2.add(getJLabelDataInizPoss(), null);
			jPanel2.add(getJLabelDataInizPoss2(), null);
			jPanel2.add(getJLabelDataInizPoss3(), null);
			jPanel2.add(getJLabelDataFinPoss1(), null);
			jPanel2.add(getJLabelDataFinPoss2(), null);
			jPanel2.add(getJLabelDataFinPoss3(), null);
			jPanel2.add(getJLabelNumFatture(), null);
			jPanel2.add(getJLabelNumSchede(), null);
			jPanel2.add(getJLabel1LitriConsumati(), null);
			jPanel2.add(getJLabel1Kmpercorsi(), null);
			jPanel2.add(getJLabel1ImportEuro(), null);
			jPanel2.add(getJLabel(), null);
			//jPanel2.setBounds(14, 194, 766, 55);
			jPanel2.setBounds(14, 300, 766, 55);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jLabelTarga
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTarga() {
		if (jLabelTarga == null) {
			jLabelTarga = new javax.swing.JLabel();
			jLabelTarga.setBounds(0, 16, 90, 19);
			jLabelTarga.setText("Targa");
			jLabelTarga.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTarga.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTarga;
	}
	/**
	 * This method initializes jLabelTitPoss1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitPoss1() {
		if (jLabelTitPoss1 == null) {
			jLabelTitPoss1 = new javax.swing.JLabel();
			jLabelTitPoss1.setBounds(87, 11, 58, 19);
			jLabelTitPoss1.setText("Titolo");
			jLabelTitPoss1.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTitPoss1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTitPoss1;
	}
	/**
	 * This method initializes jLabelTitPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTitPoss2() {
		if (jLabelTitPoss2 == null) {
			jLabelTitPoss2 = new javax.swing.JLabel();
			jLabelTitPoss2.setBounds(87, 29, 58, 19);
			jLabelTitPoss2.setText("possesso");
			jLabelTitPoss2.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTitPoss2.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTitPoss2;
	}
	/**
	 * This method initializes jLabelDataInizPoss
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss() {
		if (jLabelDataInizPoss == null) {
			jLabelDataInizPoss = new javax.swing.JLabel();
			jLabelDataInizPoss.setBounds(149, 2, 91, 19);
			jLabelDataInizPoss.setText("Data");
			jLabelDataInizPoss.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss;
	}
	/**
	 * This method initializes jLabelDataInizPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss2() {
		if (jLabelDataInizPoss2 == null) {
			jLabelDataInizPoss2 = new javax.swing.JLabel();
			jLabelDataInizPoss2.setBounds(149, 16, 91, 19);
			jLabelDataInizPoss2.setText("inizio possesso");
			jLabelDataInizPoss2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss2;
	}
	/**
	 * This method initializes jLabelDataInizPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss3() {
		if (jLabelDataInizPoss3 == null) {
			jLabelDataInizPoss3 = new javax.swing.JLabel();
			jLabelDataInizPoss3.setBounds(149, 31, 91, 19);
			jLabelDataInizPoss3.setText("ggmm");
			jLabelDataInizPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss3;
	}
	/**
	 * This method initializes jLabelDataFinPoss1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss1() {
		if (jLabelDataFinPoss1 == null) {
			jLabelDataFinPoss1 = new javax.swing.JLabel();
			jLabelDataFinPoss1.setBounds(245, 2, 91, 19);
			jLabelDataFinPoss1.setText("Data");
			jLabelDataFinPoss1.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss1;
	}
	/**
	 * This method initializes jLabelDataFinPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss2() {
		if (jLabelDataFinPoss2 == null) {
			jLabelDataFinPoss2 = new javax.swing.JLabel();
			jLabelDataFinPoss2.setBounds(245, 16, 91, 19);
			jLabelDataFinPoss2.setText("fine possesso");
			jLabelDataFinPoss2.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss2.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss2;
	}
	/**
	 * This method initializes jLabelDataFinPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss3() {
		if (jLabelDataFinPoss3 == null) {
			jLabelDataFinPoss3 = new javax.swing.JLabel();
			jLabelDataFinPoss3.setBounds(245, 32, 91, 19);
			jLabelDataFinPoss3.setText("ggmm");
			jLabelDataFinPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss3;
	}
	
	/**
	 * This method initializes jLabelNumSchede
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelNumSchede() {
		if (jLabelNumSchede == null) {
			jLabelNumSchede = new javax.swing.JLabel();
			jLabelNumSchede.setBounds(412, 25, 59, 19);
			jLabelNumSchede.setText("N Schede");
			jLabelNumSchede.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelNumSchede.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelNumSchede;
	}
	/**
	 * This method initializes jLabel1LitriConsumati
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1LitriConsumati() {
		if (jLabel1LitriConsumati == null) {
			jLabel1LitriConsumati = new javax.swing.JLabel();
			jLabel1LitriConsumati.setBounds(475, 11, 76, 19);
			jLabel1LitriConsumati.setText("Litri");
			jLabel1LitriConsumati.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabel1LitriConsumati.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel1LitriConsumati;
	}
	/**
	 * This method initializes jLabel1Kmpercorsi
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1Kmpercorsi() {
		if (jLabel1Kmpercorsi == null) {
			jLabel1Kmpercorsi = new javax.swing.JLabel();
			jLabel1Kmpercorsi.setBounds(555, 22, 105, 19);
			jLabel1Kmpercorsi.setText("Km percorsi");
			jLabel1Kmpercorsi.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel1Kmpercorsi.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabel1Kmpercorsi;
	}
	/**
	 * This method initializes jLabel1ImportEuro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1ImportEuro() {
		if (jLabel1ImportEuro == null) {
			jLabel1ImportEuro = new javax.swing.JLabel();
			jLabel1ImportEuro.setBounds(661, 22, 100, 19);
			jLabel1ImportEuro.setText("Importo");
			jLabel1ImportEuro.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabel1ImportEuro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabel1ImportEuro;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if (jTable == null) {
			jTable = new javax.swing.JTable(); // se torna il CellRenderer, togliere la ";" e decommentare
//			{
//					TableCellRenderer tcr=new AutotrasportatoriTableCellRender();
//					/* (non Javadoc)
//					 * @see javax.swing.JTable#getCellRenderer(int, int)
//					 */
//					public TableCellRenderer getCellRenderer(
//						int arg0,
//						int arg1) {
//						// TODO Stub di metodo generato automaticamente
//						return tcr;
//					}
//
//			};
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPaneLista
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPaneLista() {
		if (jScrollPaneLista == null) {
			jScrollPaneLista = new javax.swing.JScrollPane();
			jScrollPaneLista.setBounds(15, 110, 700, 150);
			jScrollPaneLista.setViewportView(getJTable());
			jScrollPaneLista.setVisible(false);
			
		}
		return jScrollPaneLista;
	}
	/**
	 * This method initializes jTextFieldTarga
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTarga() {
		if (jTextFieldTarga == null) {
			jTextFieldTarga = new javax.swing.JTextField();
			jTextFieldTarga.setBounds(14, 251, 90, 21);
			jTextFieldTarga.setDocument(
				new StringDocument(AutotrasportatoriQuadroA.getDimTarga()));
			jTextFieldTarga.addFocusListener(this);
		}
		return jTextFieldTarga;
	}
	/**
	 * This method initializes jComboBoxTitoloPossesso
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getJComboBoxTitoloPossesso() {
		if (jComboBoxTitoloPossesso == null) {
			jComboBoxTitoloPossesso = new javax.swing.JComboBox();
			jComboBoxTitoloPossesso.setBounds(108, 251, 51, 21);
			//jComboBoxTitoloPossesso.setDocument(new StringDocument(AutotrasportatoriQuadroA.getDimTitoloPossesso()));
		}
		return jComboBoxTitoloPossesso;
	}
	/**
	 * This method initializes jTextFieldDataIniPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataIniPoss() {
		if (jTextFieldDataIniPoss == null) {
			jTextFieldDataIniPoss = new javax.swing.JTextField();
			jTextFieldDataIniPoss.setBounds(163, 251, 91, 21);
			jTextFieldDataIniPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimDataInizioPossesso()));
			jTextFieldDataIniPoss.addFocusListener(this);
		}
		return jTextFieldDataIniPoss;
	}
	/**
	 * This method initializes jTextFieldDataFinPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataFinPoss() {
		if (jTextFieldDataFinPoss == null) {
			jTextFieldDataFinPoss = new javax.swing.JTextField();
			jTextFieldDataFinPoss.setBounds(258, 251, 92, 21);
			jTextFieldDataFinPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimDataFinePossesso()));
			jTextFieldDataFinPoss.addFocusListener(this);
		}
		return jTextFieldDataFinPoss;
	}
	/**
	 * This method initializes jTextFieldNumFatt
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNumFatt() {
		if (jTextFieldNumFatt == null) {
			jTextFieldNumFatt = new javax.swing.JTextField();
			jTextFieldNumFatt.setBounds(354, 251, 67, 21);
			jTextFieldNumFatt.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimNumeroFatture()));
			jTextFieldNumFatt.addFocusListener(this);
		}
		return jTextFieldNumFatt;
	}
	/**
	 * This method initializes jTextFieldNumSchede
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldNumSchede() {
		if (jTextFieldNumSchede == null) {
			jTextFieldNumSchede = new javax.swing.JTextField();
			jTextFieldNumSchede.setBounds(425, 251, 60, 21);
			jTextFieldNumSchede.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimNumeroSchede()));
			jTextFieldNumSchede.addFocusListener(this);
		}
		return jTextFieldNumSchede;
	}
	/**
	 * This method initializes jTextFieldLitrCons
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldLitrCons() {
		if (jTextFieldLitrCons == null) {
			jTextFieldLitrCons = new javax.swing.JTextField();
			jTextFieldLitrCons.setBounds(490, 251, 76, 21);
			jTextFieldLitrCons.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimLitriConsumati()));
			jTextFieldLitrCons.addFocusListener(this);
		}
		return jTextFieldLitrCons;
	}
	/**
	 * This method initializes jTextFieldKmPerc
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldKmPerc() {
		if (jTextFieldKmPerc == null) {
			jTextFieldKmPerc = new javax.swing.JTextField();
			jTextFieldKmPerc.setBounds(570, 251, 105, 21);
			jTextFieldKmPerc.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroA.getDimChilometriPercorsi()));
			jTextFieldKmPerc.addFocusListener(this);
		}
		return jTextFieldKmPerc;
	}
	/**
	 * This method initializes jTextFieldImporto
	 * 
	 * @return javax.swing.JTextField
	 */
	protected javax.swing.JTextField getJTextFieldImporto() {
		if (jTextFieldImporto == null) {
			jTextFieldImporto = new javax.swing.JTextField();
			jTextFieldImporto.setBounds(678, 251, 100, 21);
			jTextFieldImporto.setDocument(
				new BigDecimalDocument(
					AutotrasportatoriQuadroA.getDimImportoInt(),
					AutotrasportatoriQuadroA.getDimImportoDec()));
			jTextFieldImporto.addFocusListener(this);
		}
		return jTextFieldImporto;
	}
	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(null);
			jPanel3.setLayout(FullScreenLayoutManager.getInstance());
			jPanel3.add(getJButtonInserisci(), null);
			jPanel3.add(getJButtonModifica(), null);
			jPanel3.add(getJButtonElimina(), null);
			jPanel3.setBounds(420, 330, 340, 44);
			jPanel3.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
			jPanel3.setVisible(false);
		}
		return jPanel3;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if (jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(17, 7, 93, 28);
			jButtonInserisci.setText("Inserisci");
			jButtonInserisci.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonInserisci.addActionListener(this);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if (jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(121, 8, 93, 28);
			jButtonModifica.setText("Modifica");
			jButtonModifica.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonModifica.addActionListener(this);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if (jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(229, 8, 93, 28);
			jButtonElimina.setText("Elimina");
			jButtonElimina.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonElimina.addActionListener(this);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(12, 485, 110, 35);
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonConferma.addActionListener(this);
			jButtonConferma.setVisible(false);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(12, 485, 110, 35);
			jButtonChiudi.setText("Chiudi");
			
			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	
	private javax.swing.JButton getJButtonChiudiQuadroB() {
			if (jButtonChiudiQuadroB == null) {
				jButtonChiudiQuadroB = new javax.swing.JButton();
				jButtonChiudiQuadroB.setBounds(130, 485, 110, 35);
				jButtonChiudiQuadroB.setText("Chiudi");
			
				jButtonChiudiQuadroB.addActionListener(this);
				jButtonChiudiQuadroB.setVisible(false);
			}
			return jButtonChiudiQuadroB;
		}
	
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setBounds(475, 29, 76, 19);
			jLabel.setText("consumati");
			jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabel;
	}
	public void plot(PdfBuilder pdfBuilder) {}
	
	private javax.swing.JLabel getJLabelCodDitta() {
			if(jLabelCodDitta == null) {
				jLabelCodDitta = new javax.swing.JLabel();
				jLabelCodDitta.setBounds(35, 16, 90, 19);
				jLabelCodDitta.setText("Codice ditta");
				jLabelCodDitta.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
				jLabelCodDitta.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
			}
			return jLabelCodDitta;
		}
		
		private javax.swing.JLabel getJLabelNumFatture() {
			if(jLabelNumFatture == null) {
				jLabelNumFatture = new javax.swing.JLabel();
				jLabelNumFatture.setBounds(200, 16, 120, 29);
				jLabelNumFatture.setText("<html><p style='text-align: center;'>Numero fattture<br>d'acquisto</p></html>");
				jLabelNumFatture.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
				jLabelNumFatture.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);					
			}
			return jLabelNumFatture;
		}
		
		private javax.swing.JLabel getJLabelTotLitri() {
					if(jLabelTotLitri == null) {
						jLabelTotLitri = new javax.swing.JLabel();
						jLabelTotLitri.setBounds(375, 16, 120, 19);
						jLabelTotLitri.setText("Totale litri fatturati");
						jLabelTotLitri.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
						jLabelTotLitri.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
					}
					return jLabelTotLitri;
		}
	
		private javax.swing.JLabel getJLabelTotImporto() {
				if(jLabelTotImporto== null) {
					jLabelTotImporto = new javax.swing.JLabel();
					jLabelTotImporto.setBounds(550, 16, 120, 19);
					jLabelTotImporto.setText("Totale importo");
					jLabelTotImporto.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
					jLabelTotImporto.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
				}
			return jLabelTotImporto;
		}
		
		private javax.swing.JPanel getJPanelSerbSup10() {
				if (jPanelSerbSup10 == null) {
					jPanelSerbSup10 = new javax.swing.JPanel();
					jPanelSerbSup10.setLayout(null);
					jPanelSerbSup10.setLayout(FullScreenLayoutManager.getInstance());
					jPanelSerbSup10.add(getJLabelCodDitta(), null);
					jPanelSerbSup10.add(getJLabelNumFatture(), null);
					jPanelSerbSup10.add(getJLabelTotLitri(), null);
					jPanelSerbSup10.add(getJLabelTotImporto(), null);
					jPanelSerbSup10.add(getJTextCodDitta(), null);
					jPanelSerbSup10.add(getJTextNumFatture(), null);
					jPanelSerbSup10.add(getJTextTotLitri(), null);
					jPanelSerbSup10.add(getJTextTotImporto(), null);
					
					jPanelSerbSup10.setBounds(15, 260, 700, 70);
					jPanelSerbSup10.setVisible(false);
				}
				return jPanelSerbSup10;
			}
			
			int y = 45;
			
				private javax.swing.JTextField getJTextCodDitta() {
					if(jTextCodDitta == null) {
						jTextCodDitta = new javax.swing.JTextField();
						jTextCodDitta.setBounds(20, y, 120, 20);											
						jTextCodDitta.setDocument(new StringDocument(AutotrasportatoriQuadroB.dimSuperioreCodiceDitta));
					}
					return jTextCodDitta;
			}
			
		private javax.swing.JTextField getJTextNumFatture() {
			if(jTextNumFatture == null) {
				jTextNumFatture = new javax.swing.JTextField();
				jTextNumFatture.setBounds(210, y, 90, 20);								
				jTextNumFatture.setDocument(new BigIntegerDocument(AutotrasportatoriQuadroB.dimSuperioreNumeroFatture));
			}
			return jTextNumFatture;
	}
	
	private javax.swing.JTextField getJTextTotLitri() {
		if(jTextTotLitri == null) {
			jTextTotLitri = new javax.swing.JTextField();
			jTextTotLitri.setBounds(375, y, 110, 20);								
			jTextTotLitri.setDocument(new BigIntegerDocument(AutotrasportatoriQuadroB.dimSuperioreTotaleLitri));
		}
		return jTextTotLitri;
	}
	
	private javax.swing.JTextField getJTextTotImporto() {
			if(jTextTotImporto == null) {
				jTextTotImporto = new javax.swing.JTextField();
				jTextTotImporto.setBounds(550, y, 110, 20);								
				jTextTotImporto.setDocument(new BigDecimalDocument(AutotrasportatoriQuadroB.dimSuperioreTotaleImportoInt, AutotrasportatoriQuadroB.dimSuperioreTotaleImportoDec));
			}
			return jTextTotImporto;
	}
	
 private javax.swing.JLabel getJLabelProvincia() {
	if(jLabelProvincia == null) {
		jLabelProvincia = new javax.swing.JLabel();
		jLabelProvincia.setBounds(0, 16, 100, 19);
		jLabelProvincia.setText("Provincia");
		jLabelProvincia.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabelProvincia.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
	}
	return jLabelProvincia;
 }
 
 private javax.swing.JLabel getJLabelComune() {
   if(jLabelComune == null) {
	jLabelComune = new javax.swing.JLabel();
	jLabelComune.setBounds(100, 16, 90, 19);
	jLabelComune.setText("Comune");
	jLabelComune.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
	jLabelComune.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
   }
   return jLabelComune;
}
	private javax.swing.JLabel getJLabelIndirizzo () {
	   if(jLabelIndirizzo == null) {
		jLabelIndirizzo = new javax.swing.JLabel();
		jLabelIndirizzo.setBounds(185, 16, 260, 19);
		jLabelIndirizzo.setText("Indirizzo");
		jLabelIndirizzo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabelIndirizzo.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
	   }
	   return jLabelIndirizzo;
	}
	
 private javax.swing.JLabel getJLabelCapStoccaggio () {
	if(jLabelCapStoccaggio == null) {
		jLabelCapStoccaggio = new javax.swing.JLabel();
		jLabelCapStoccaggio.setBounds(415, 16, 90, 29);
		jLabelCapStoccaggio.setText("<html><p style='text-align: center;'>Capacita' di<br>stoccaggio mc</p></html>");
		jLabelCapStoccaggio.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabelCapStoccaggio.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
	}
	return jLabelCapStoccaggio;
 }
	 private javax.swing.JLabel getJLabelNumFattureInf () {
	   if(jLabelNumFattureInf == null) {
		jLabelNumFattureInf = new javax.swing.JLabel();
		jLabelNumFattureInf.setBounds(470, 16, 120, 29);
		jLabelNumFattureInf.setText("<html><p style='text-align: center;'>Numero fattture<br> d'acquisto</p></html>");
		jLabelNumFattureInf.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabelNumFattureInf.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
	   }
	   return jLabelNumFattureInf;
	}
	
	 private javax.swing.JLabel getJLabelTotLitriInf () {
		if(jLabelTotLitriInf == null) {
			jLabelTotLitriInf = new javax.swing.JLabel();
			jLabelTotLitriInf.setBounds(535, 16, 120, 29);
			jLabelTotLitriInf.setText("<html><p style='text-align: center;'>Totale litri<br>fatturati</p></html>");
			jLabelTotLitriInf.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelTotLitriInf.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabelTotLitriInf;
	 }
	 
	 private javax.swing.JLabel getJLabelTotImportoInf () {
		 if(jLabelTotImportoInf == null) {
			jLabelTotImportoInf = new javax.swing.JLabel();
			jLabelTotImportoInf.setBounds(595, 16, 120, 29);
			jLabelTotImportoInf.setText("Totale importo");
			jLabelTotImportoInf.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelTotImportoInf.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		 }
		 return jLabelTotImportoInf;
	  }

 
 
 private javax.swing.JPanel getJPanelSerbInf10() {
		if (jPanelSerbInf10 == null) {
			jPanelSerbInf10 = new javax.swing.JPanel();
			jPanelSerbInf10.setLayout(null);
			jPanelSerbInf10.setLayout(FullScreenLayoutManager.getInstance());
			jPanelSerbInf10.add(getJLabelProvincia(), null);
			jPanelSerbInf10.add(getJLabelComune(), null);
			jPanelSerbInf10.add(getJLabelIndirizzo(), null);
			jPanelSerbInf10.add(getJLabelCapStoccaggio(), null);
			jPanelSerbInf10.add(getJLabelNumFattureInf(), null);
			jPanelSerbInf10.add(getJLabelTotLitriInf(), null);
			jPanelSerbInf10.add(getJLabelTotImportoInf(), null);
			jPanelSerbInf10.add(getJComboBoxInferioreProvincia(), null);
			jPanelSerbInf10.add(getJComboBoxInferioreComune(), null);
			jPanelSerbInf10.add(getJTextIndirizzo(), null);
			jPanelSerbInf10.add(getJTextCapStoccaggio(), null);
			jPanelSerbInf10.add(getJTextNumFattureInf(), null);
			jPanelSerbInf10.add(getJTextTotLitriInf(), null);
			jPanelSerbInf10.add(getJTextTotImportoInf(), null);	
						
			jPanelSerbInf10.setBounds(15, 260, 700, 70);
			jPanelSerbInf10.setVisible(false);
		}
		return jPanelSerbInf10;
	}
	
	int yInf = 45;
	
	private javax.swing.JComboBox getJComboBoxInferioreProvincia() {
		if(jComboBoxInferioreProvincia == null) {
			jComboBoxInferioreProvincia = new javax.swing.JComboBox();
			jComboBoxInferioreProvincia.setBounds(0, yInf, 100, 20);
		}
		return jComboBoxInferioreProvincia;
	}
				
	private javax.swing.JComboBox getJComboBoxInferioreComune() {
			if(jComboBoxInferioreComune == null) {
				jComboBoxInferioreComune = new javax.swing.JComboBox();
				jComboBoxInferioreComune.setBounds(105, yInf, 90, 20);
				jComboBoxInferioreComune.setRenderer(new AutotrasportatoriFrame.ComuneComboBoxRenderer());
			}
			return jComboBoxInferioreComune;
	}		
	private javax.swing.JTextField getJTextIndirizzo() {
			if(jTextIndirizzo == null) {
				jTextIndirizzo = new javax.swing.JTextField();
				jTextIndirizzo.setBounds(200, yInf, 230, 20);
			
				jTextIndirizzo.setDocument(new StringDocument(AutotrasportatoriQuadroB.dimInferioreIndirizzoUbicazioneImpianto));
			}
			return jTextIndirizzo;
	}
	
  private javax.swing.JTextField getJTextCapStoccaggio() {
	if(jTextCapStoccaggio == null) {
		jTextCapStoccaggio = new javax.swing.JTextField();
		jTextCapStoccaggio.setBounds(435, yInf, 60, 20);

		jTextCapStoccaggio.setDocument(new BigDecimalDocument(AutotrasportatoriQuadroB.dimCapStoccaggioInt, AutotrasportatoriQuadroB.dimCapStoccaggioDec));
	}
	return jTextCapStoccaggio;
	}
	
	private javax.swing.JTextField getJTextNumFattureInf() {
			if(jTextNumFattureInf == null) {
				jTextNumFattureInf = new javax.swing.JTextField();
				jTextNumFattureInf.setBounds(500, yInf, 60, 20);

				jTextNumFattureInf.setDocument(new BigIntegerDocument(AutotrasportatoriQuadroB.dimInferioreNumeroFatture));
			}
			return jTextNumFattureInf;
	}
	
 private javax.swing.JTextField getJTextTotLitriInf() {
	if(jTextTotLitriInf == null) {
		jTextTotLitriInf = new javax.swing.JTextField();
		jTextTotLitriInf.setBounds(565, yInf, 60, 20);
	
		jTextTotLitriInf.setDocument(new BigIntegerDocument(AutotrasportatoriQuadroB.dimSuperioreTotaleLitri));
		}
		return jTextTotLitriInf;
	}
 
 private javax.swing.JTextField getJTextTotImportoInf() {
	if(jTextTotImportoInf == null) {
		jTextTotImportoInf = new javax.swing.JTextField();
		jTextTotImportoInf.setBounds(630, yInf, 60, 20);

		jTextTotImportoInf.setDocument(new BigDecimalDocument(AutotrasportatoriQuadroB.dimInferioreTotaleImportoInt, AutotrasportatoriQuadroB.dimInferioreTotaleImportoDec));
	}
	return jTextTotImportoInf;
}
	/**
	 * @return
	 */
	public List getListaInf10() {
		return listaInf10;
	}

	/**
	 * @return
	 */
	public List getListaSup10() {
		return listaSup10;
	}

	/**
	 * @return
	 */
	public AutotrasportatoriQuadroB2TM getModelInf10() {
		return modelInf10;
	}

	/**
	 * @return
	 */
	public AutotrasportatoriQuadroB1TM getModelSup10() {
		return modelSup10;
	}

	/**
	 * @param list
	 */
	public void setListaInf10(List list) {
		listaInf10 = list;
	}

	/**
	 * @param list
	 */
	public void setListaSup10(List list) {
		listaSup10 = list;
	}

	/**
	 * @param quadroB2TM
	 */
	public void setModelInf10(AutotrasportatoriQuadroB2TM quadroB2TM) {
		modelInf10 = quadroB2TM;
	}

	/**
	 * @param quadroB1TM
	 */
	public void setModelSup10(AutotrasportatoriQuadroB1TM quadroB1TM) {
		modelSup10 = quadroB1TM;
	}

	

	/**
	 * @return
	 */
	public List getListaDiPartenzaInf10() {
		return listaDiPartenzaInf10;
	}

	/**
	 * @return
	 */
	public List getListaDiPartenzaSup10() {
		return listaDiPartenzaSup10;
	}

	/**
	 * @param list
	 */
	public void setListaDiPartenzaInf10(List list) {
		listaDiPartenzaInf10 = list;
	}

	/**
	 * @param list
	 */
	public void setListaDiPartenzaSup10(List list) {
		listaDiPartenzaSup10 = list;
	}

} 