package it.finanze.dogane.accise.aautotrasportatori.ui;

import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroC;
import it.finanze.dogane.accise.aautotrasportatori.model.Frontespizio;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.ui.quadri.Quadro;
import it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel.AutotrasportatoriQuadroCTM;
import it.finanze.dogane.accise.combo.ComboDataSource;
import it.finanze.dogane.accise.combo.TipoPeriodo;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PdfPrintable;
import it.finanze.dogane.accise.ui.FullScreenLayoutManager;
import it.finanze.dogane.accise.ui.RealDim;
import it.finanze.dogane.accise.ui.TableUtil;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import it.finanze.dogane.accise.ui.validation.BigIntegerDocument;
import it.finanze.dogane.accise.ui.validation.StringDocument;
import it.finanze.dogane.accise.util.StringUtil;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.math.BigInteger;
import java.util.Iterator;
import java.util.List;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;

public class AutotrasportatoriQuadroCDialog
	extends JDialog
	implements
		ActionListener,
		ListSelectionListener,
		QuadroDialog,
		PdfPrintable,
		FocusListener {

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JPanel jPanel = null;
	private javax.swing.JLabel jLabelIntestazioneQuadro = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JPanel jPanel2 = null;
	private javax.swing.JLabel jLabelTarga = null;
	private javax.swing.JLabel jLabelDataInizPoss = null;
	private javax.swing.JLabel jLabelDataInizPoss2 = null;
	private javax.swing.JLabel jLabelDataInizPoss3 = null;
	private javax.swing.JLabel jLabelDataFinPoss1 = null;
	private javax.swing.JLabel jLabelDataFinPoss2 = null;
	private javax.swing.JLabel jLabelDataFinPoss3 = null;
	private javax.swing.JScrollPane jScrollPaneLista = null;
	private javax.swing.JTable jTable = null;
	private javax.swing.JTextField jTextFieldTarga = null;
	private javax.swing.JTextField jTextFieldDataIniPoss = null;
	private javax.swing.JTextField jTextFieldDataFinPoss = null;
	private javax.swing.JPanel jPanel3 = null;
	private javax.swing.JButton jButtonInserisci = null;
	private javax.swing.JButton jButtonModifica = null;
	private javax.swing.JButton jButtonElimina = null;
	private javax.swing.JButton jButtonConferma = null;
	private javax.swing.JButton jButtonChiudi = null;
	private ProspettoConsumo prospettoConsumo = null;
	private Quadro quadro = null;
	private boolean flagModifica = false;
	private List listaValidate = null;

	private javax.swing.JTextField jTextFieldTipoAutoveicolo = null;
	private javax.swing.JLabel jLabelTipoAutoveicolo = null;
	/**
	 * This is the default constructor
	 */
	public AutotrasportatoriQuadroCDialog(
		Frame frame,
		String description,
		String secondDescription) {
		super(frame, "Quadro C", true);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		// this.setSize(800, 600);
		this.setSize(
			RealDim.getAbsoluteXValue(800),
			RealDim.getAbsoluteYValue(600));
		this.setContentPane(getJContentPane());
		this.setTitle(
			"Altri automezzi, riforniti a mezzo distributore privato (Quadro B), non aventi titolo alla riduzione degli oneri");

	}

	public void prepareValues(Prospect prospect, GestoreQuadro gestoreQuadro) {
		prospettoConsumo = (ProspettoConsumo) prospect;
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		this.quadro = (Quadro) gestoreQuadro;
		List lista = prospettoConsumo.getListaQuadro(quadro.getTipiRecord());
		listaValidate = lista;
		AutotrasportatoriQuadroCTM model =
			new AutotrasportatoriQuadroCTM(lista);

		jTable.setModel(model);		
		
		TableUtil.redimTable(jTable, jScrollPaneLista);

	}

	public void plot(PdfBuilder builder) {
		builder.startCommandBlock();

		float y = builder.getYPen();
		String quadroStr = "Quadro C";
		builder.writeLeftLabel(quadroStr.toUpperCase(), 12);
		builder.moveXPen(50);
		//SALVATORE
		builder.endCommandBlock();
		builder.startDefineTableHeader();		
		//
		
		float y2 = builder.getYPen();
		builder.moveYPen(y - y2); // All'interno di un blocco non si pu utilizzare una setYPen		
		String titolo1 = "";
		String titolo2 = "";
		if (this.getTitle().length() > 43) {
			titolo1 =
				this.getTitle().substring(0, this.getTitle().length() - 57);
			titolo2 =
				this.getTitle().substring(
					this.getTitle().length() - 57,
					this.getTitle().length());
		}
		builder.writeRightLabel(titolo1.toUpperCase(), 12);
		builder.writeRightLabel(titolo2.toUpperCase(), 12);
		builder.writeLeftLabel("", 20);
		builder.setXPen(PdfBuilder.MARGINE);
		//SALVATORE
		//builder.endCommandBlock();
		builder.endDefineTableHeader();		
		//


		builder.writeTable(this, jTable, jScrollPaneLista);
		builder.setXPen(PdfBuilder.MARGINE);

	}

	/**************************************************************************************
	 * INIZIO GESTIONE EVENTI
	 **************************************************************************************/

	public void actionPerformed(ActionEvent event) {
		try {
			if (event.getSource() == jButtonChiudi) {
				doClose();
			} else if (event.getSource() == jButtonConferma) {
				doConfirm();
			} else if (event.getSource() == jButtonElimina) {
				doDelete();
			} else if (event.getSource() == jButtonInserisci) {
				doInsert();
			} else if (event.getSource() == jButtonModifica) {
				doUpdate();
			}
		} catch (Exception e) {
			e.printStackTrace();
			JOptionPane.showMessageDialog(
				this,
				e.getMessage(),
				"Errore",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void doUpdate() {
		boolean modificaEffettuata=false;		
		if( campiobbligatori() ){
			boolean inputValidato=false;

			AutotrasportatoriQuadroCTM model =
				(AutotrasportatoriQuadroCTM) jTable.getModel();
			int selectedRow = jTable.getSelectedRow();
			if (selectedRow != -1) {
				AutotrasportatoriQuadroC record =
					(AutotrasportatoriQuadroC) model.getRecord(selectedRow);
					inputValidato=!(validateUpdateMatricola(listaValidate,selectedRow));
				try {			
					if(inputValidato){					
						loadRecordFromUI(record);
						model.setRecord(selectedRow, record);
						flagModifica = true;
						modificaEffettuata=true;							
					}
				} catch (Exception e) {
					JOptionPane.showMessageDialog(
						this,
						e.getMessage(),
						"Errore",
						JOptionPane.ERROR_MESSAGE);
				}
			} else {
				JOptionPane.showMessageDialog(
					this,
					"Selezionare un elemento dalla lista",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
			}
			
		}
		if(modificaEffettuata) jTable.removeRowSelectionInterval( 0, jTable.getRowCount()-1 );// aggiunto reply
	}

	/**
	 * 
	 */
	private void doInsert() {
		if (campiobbligatori()) {
			boolean insert = false;
			AutotrasportatoriQuadroCTM model =
				(AutotrasportatoriQuadroCTM) jTable.getModel();
			AutotrasportatoriQuadroC record =
				AutotrasportatoriQuadroC.getNewObject(prospettoConsumo);
			record.setTipoRecord(BigInteger.valueOf(quadro.getTipiRecord()[0]));
			try {
				loadRecordFromUI(record);
				insert = validateMatricola(listaValidate);
				if (!insert) {
					model.insertRecord(record);
					clearFields();
					flagModifica = true;
				}
			} catch (Exception e) {
				JOptionPane.showMessageDialog(
					this,
					e.getMessage(),
					"Errore",
					JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	private boolean validateData(String dataGGMM) {
		boolean isValida = true;
		// la data in ingresso  del tipo ggmm
		String giornoStr = "";
		String meseStr = "";
		if (dataGGMM.length() == 4) {
			giornoStr = StringUtil.nullify(dataGGMM.substring(0, 2));
			meseStr = StringUtil.nullify(dataGGMM.substring(2, 4));
		} else if (dataGGMM.length() == 3) {
			giornoStr = StringUtil.nullify(dataGGMM.substring(0, 1));
			meseStr = StringUtil.nullify(dataGGMM.substring(1, 3));
		} else {
			isValida = false; // data non valida
			return isValida;
		}

		if (giornoStr == null
			|| meseStr == null
			|| Integer.parseInt(giornoStr) <= 0
			|| Integer.parseInt(giornoStr) > 31
			|| Integer.parseInt(meseStr) <= 0
			|| Integer.parseInt(meseStr) > 12
		|| ((Integer.parseInt(giornoStr)>30) && (Integer.parseInt(meseStr)==4 || Integer.parseInt(meseStr)==9 
				|| Integer.parseInt(meseStr)==11 || Integer.parseInt(meseStr)==6 ))
		|| ((Integer.parseInt(meseStr)==2)&& (Integer.parseInt(giornoStr)>29))
		|| ((Integer.parseInt(meseStr)==2)&& (Integer.parseInt(giornoStr)==29) && ((VisualConfig.ANNO_DI_RIFERIMENTO_INT%4)!=0))			
			) {
			isValida = false; // giorno o mese non valido
		}
		// TO DO..: bisognerebbe considerare il mese di febbraio che pu essere di 28 o 29 giorni
		// tale controllo non  implementato sull'applicazione originale quindi viene tralasciato
		return isValida;
	}

	private String validateDataInPeriodo(String dataGGMM) {
		String msg="";
		
		if (dataGGMM.length()==3) dataGGMM="0"+dataGGMM;

		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		
		String periodo = frontespizio.getPeriodoCarbontax();
		// OLD FHF BigInteger periodo = frontespizio.getPeriodoCarbontax();
		
		/*commentato reply
		TipoPeriodo tipoPeriodo = ComboDataSource.getInstance().getPeriodo(frontespizio.getAnnoDic(), periodo);

		//ggmm
		BigInteger minInt = tipoPeriodo.getDataInizio();
		BigInteger maxInt = tipoPeriodo.getDataFine();
		String minStr = minInt.toString();
		String maxStr = maxInt.toString();
		if (minStr.length()==3) minStr="0"+minStr;
		if (maxStr.length()==3) maxStr="0"+maxStr;
		*/
		// aggiunto reply
		String minStr = this.getDataInizioPeriodo();
		String maxStr = this.getDataFinePeriodo();
		// fine
		
		//mmgg
		String minMMStr = minStr.substring(2,4);
		String minGGStr = minStr.substring(0,2);
		BigInteger newMin=new BigInteger(minMMStr+minGGStr);
		//mmgg
		String maxMMStr = maxStr.substring(2,4);
		String maxGGStr = maxStr.substring(0,2);
		BigInteger newMax=new BigInteger(maxMMStr+maxGGStr);

		String dataInMM = dataGGMM.substring(2,4);
		String dataInGG = dataGGMM.substring(0,2);
		BigInteger dataIn=new BigInteger(dataInMM+dataInGG);

		if (dataIn.compareTo(newMin)<0){
			msg="La data di posseso " +AutotrasportatoriQuadroADialog.formatDate(dataGGMM)+" deve essere maggiore o uguale del " + AutotrasportatoriQuadroADialog.formatDate(minStr);
		} else if (dataIn.compareTo(newMax)>0){
			msg="La data di posseso " +AutotrasportatoriQuadroADialog.formatDate(dataGGMM)+" deve essere minore o uguale del " + AutotrasportatoriQuadroADialog.formatDate(maxStr);
		} else {
			msg="ok";
		}
		return msg;
	}
	
	private String getDataInizioPeriodo(){
		return "0101";
		/*
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		BigInteger periodo = frontespizio.getPeriodoCarbontax();
		TipoPeriodo tipoPeriodo = ComboDataSource.getInstance().getPeriodo(frontespizio.getAnnoDic(), periodo);
		//ggmm
		BigInteger minInt = tipoPeriodo.getDataInizio();
		String minStr = minInt.toString();
		if (minStr.length()==3) minStr="0"+minStr;
		return minStr;	
		*/
	}

	private String getDataFinePeriodo(){
		return "3112";
		/*
		Frontespizio frontespizio = prospettoConsumo.getFrontespizio();
		BigInteger periodo = frontespizio.getPeriodoCarbontax();
		TipoPeriodo tipoPeriodo = ComboDataSource.getInstance().getPeriodo(frontespizio.getAnnoDic(), periodo);
		//ggmm
		BigInteger maxInt = tipoPeriodo.getDataFine();
		String maxStr = maxInt.toString();
		if (maxStr.length()==3) maxStr="0"+maxStr;
		return maxStr;
		*/
	}

	private boolean validateMatricola(List list) {
		boolean isPresent = false;

		Iterator it = list.iterator();
		boolean found = false;
		while (it.hasNext()) {
			AutotrasportatoriQuadroC record =
				(AutotrasportatoriQuadroC) it.next();
			if (record.getTarga().equals(jTextFieldTarga.getText())) {
				JOptionPane.showMessageDialog(
					this,
					"Targa gi presente nel quadro",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isPresent = true;

			}

		}
		return isPresent;
	}
	
	private boolean validateUpdateMatricola(List list,int rowToUpdate) {
		boolean isPresent = false;

		Iterator it = list.iterator();
		boolean found = false;
		int rowToCheck=-1;
		while (it.hasNext()) {
			rowToCheck++;
			AutotrasportatoriQuadroC record =
				(AutotrasportatoriQuadroC) it.next();
			if (record.getTarga().equals(jTextFieldTarga.getText())&&(rowToCheck!=rowToUpdate)) {
				JOptionPane.showMessageDialog(
					this,
					"Targa gi presente nel quadro",
					"Attenzione",
					JOptionPane.WARNING_MESSAGE);
				isPresent = true;

			}

		}
		return isPresent;
	}

	private boolean campiobbligatori() {
		boolean isOk = true;

		if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) == null) {
			jTextFieldDataIniPoss.setText(this.getDataInizioPeriodo());
		}
		if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) == null) {
			jTextFieldDataFinPoss.setText(this.getDataFinePeriodo());
		}

		if (StringUtil.nullify(jTextFieldTarga.getText()) == null) {
			JOptionPane.showMessageDialog(
				this,
				"Digitare la targa.",
				"Attenzione",
				JOptionPane.ERROR_MESSAGE);
			isOk = false;
			jTextFieldTarga.selectAll();
			jTextFieldTarga.grabFocus();
		/***
		} else if (StringUtil.nullify(jTextFieldTipoAutoveicolo.getText()) == null) {
			JOptionPane.showMessageDialog(
				this,
				"Specificare il tipo autoveicolo.",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
			isOk = false;
			jTextFieldTipoAutoveicolo.selectAll();
			jTextFieldTipoAutoveicolo.grabFocus();
		***/
		} else if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) == null) {
			JOptionPane.showMessageDialog(
				this,
				"Specificare la data di inizio possesso.",
				"Attenzione",
				JOptionPane.ERROR_MESSAGE);
			isOk = false;
			jTextFieldDataIniPoss.selectAll();
			jTextFieldDataIniPoss.grabFocus();
		} else if (StringUtil.nullify(jTextFieldDataIniPoss.getText()) != null) {
			String msg = "";
			// controllo se  una data valida (controllo sintattico)
			boolean isValida=false;
			isValida=validateData(StringUtil.nullify(this.jTextFieldDataIniPoss.getText()));
			if (isValida) {
				// devo controllare se la data  nel range
				msg = this.validateDataInPeriodo(StringUtil.nullify(this.jTextFieldDataIniPoss.getText()));
				if (!StringUtil.nullify(msg).equals("ok")){
					isValida=false;
				}
			}
			if (!isValida) {
				jTextFieldDataFinPoss.setText("");
				if (StringUtil.nullify(msg)==null)
					JOptionPane.showMessageDialog(this,"La data di inizio possesso "+StringUtil.nullify(this.jTextFieldDataIniPoss.getText())+" non  valida!","Errore",JOptionPane.ERROR_MESSAGE);
				else
					JOptionPane.showMessageDialog(this,msg,"Errore",JOptionPane.ERROR_MESSAGE);
				isOk = false;
				jTextFieldDataIniPoss.selectAll();
				jTextFieldDataIniPoss.grabFocus();
			/**
			} else if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) == null) {
				JOptionPane.showMessageDialog(this,"Specificare la data di fine possesso.","Attenzione",JOptionPane.WARNING_MESSAGE);
				isOk = false;
				jTextFieldDataFinPoss.selectAll();
				jTextFieldDataFinPoss.grabFocus();
			**/
				} else if (StringUtil.nullify(jTextFieldDataFinPoss.getText()) != null) {
					isValida=false;
					isValida=validateData(StringUtil.nullify(this.jTextFieldDataFinPoss.getText()));
					msg = "";
					if (isValida) {
						// devo controllare se la data  nel range
						msg = this.validateDataInPeriodo(StringUtil.nullify(this.jTextFieldDataFinPoss.getText()));
						if (StringUtil.nullify(msg).equals("ok")){
							// controllo se la data di inizio  successiva alla data di fine possesso
							msg = AutotrasportatoriQuadroADialog.compareDataInizioFine(this.jTextFieldDataIniPoss.getText(),this.jTextFieldDataFinPoss.getText());
						}
						if (!StringUtil.nullify(msg).equals("ok")){
							isValida=false;
						}
					}
					if (!isValida) {
						if (StringUtil.nullify(msg)==null)
							JOptionPane.showMessageDialog(this,"La data di fine possesso "+StringUtil.nullify(this.jTextFieldDataFinPoss.getText())+" non  valida!","Errore",JOptionPane.ERROR_MESSAGE);
						else
							JOptionPane.showMessageDialog(this,msg,"Errore",JOptionPane.ERROR_MESSAGE);
						isOk = false;
						jTextFieldDataFinPoss.selectAll();
						jTextFieldDataFinPoss.grabFocus();
					}
				}
		}
		return isOk;
		}

	/**
	 * 
	 */
	private void doDelete() {
		AutotrasportatoriQuadroCTM model =
			(AutotrasportatoriQuadroCTM) jTable.getModel();
		int selectedRow = jTable.getSelectedRow();
		if (selectedRow != -1) {
			model.removeRecord(selectedRow);
			clearFields();
			flagModifica = true;
		} else {
			JOptionPane.showMessageDialog(
				this,
				"Selezionare un elemento dalla lista",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
		}
	}

	/**
	 * 
	 */
	private void doConfirm() {
		AutotrasportatoriQuadroCTM model =
			(AutotrasportatoriQuadroCTM) jTable.getModel();
		List listaQuadro = model.getRecords();

		prospettoConsumo.setListaQuadro(listaQuadro, quadro.getTipiRecord());
		this.setVisible(false);
	}

	private void doClose() {
		int val = validateExitText();
		if (val == JOptionPane.YES_OPTION) {
			doConfirm();
		} else if (val == JOptionPane.NO_OPTION) {
			this.setVisible(false);
		} else if (val == JOptionPane.CANCEL_OPTION) {
		}
	}

	private int validateExitText() {
		int retvalue = JOptionPane.NO_OPTION;
		if (flagModifica == true) {
			retvalue =
				JOptionPane.showConfirmDialog(
					this,
					"Le modifiche effettuate verranno perse. Vuoi salvare le modifiche?",
					"",
					JOptionPane.YES_NO_CANCEL_OPTION);
		}
		return retvalue;
	}

	public void valueChanged(ListSelectionEvent event) {
		if (event.getSource() == jTable.getSelectionModel()) {
			loadUIFromRecord();
		}
	}

	/**
	 * @param record
	 */
	private void loadRecordFromUI(AutotrasportatoriQuadroC record) {

		String str = null;

		try {
			str = jTextFieldDataIniPoss.getText();
			BigInteger i = new BigInteger(str);
			record.setDataInizioPossesso(i);
		} catch (NumberFormatException e) {
			record.setDataInizioPossesso(BigInteger.ZERO);
		}

		try {
			str = jTextFieldDataFinPoss.getText();
			BigInteger i = new BigInteger(str);
			record.setDataFinePossesso(i);
		} catch (NumberFormatException e) {
			record.setDataFinePossesso(BigInteger.ZERO);
		}

		record.setTipoAutoveicolo(jTextFieldTipoAutoveicolo.getText());
		record.setTarga(jTextFieldTarga.getText());

	}

	private void loadUIFromRecord() {
		AutotrasportatoriQuadroCTM model =
			(AutotrasportatoriQuadroCTM) jTable.getModel();

		int selectedRow = jTable.getSelectedRow();
		if (selectedRow == -1) {
			clearFields();
		} else {

			AutotrasportatoriQuadroC record =
				(AutotrasportatoriQuadroC) model.getRecord(selectedRow);

			jTextFieldDataIniPoss.setText(
				record.getDataInizioPossesso().toString());
			jTextFieldDataFinPoss.setText(
				record.getDataFinePossesso().toString());

			jTextFieldTipoAutoveicolo.setText(record.getTipoAutoveicolo());
			jTextFieldTarga.setText(record.getTarga());

		}
	}

	private void clearFields() {
		jTextFieldDataIniPoss.setText("");
		jTextFieldDataFinPoss.setText("");
		jTextFieldTipoAutoveicolo.setText("");
		jTextFieldTarga.setText("");

	}

	public void focusGained(FocusEvent event) {
	}

	public void focusLost(FocusEvent event) {
	}

	/**************************************************************************************
	 * FINE GESTIONE EVENTI
	 **************************************************************************************/

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.setLayout(FullScreenLayoutManager.getInstance());
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJButtonConferma(), null);
			jContentPane.add(getJButtonChiudi(), null);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new javax.swing.JPanel();
			jPanel.setLayout(null);
			jPanel.setLayout(FullScreenLayoutManager.getInstance());
			jPanel.add(getJLabelIntestazioneQuadro(), null);
			jPanel.setBounds(10, 16, 767, 61);
			jPanel.setBackground(java.awt.Color.lightGray);
			jPanel.setBorder(
				javax.swing.BorderFactory.createTitledBorder(
					null,
					"Quadro C",
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION,
					null,
					null));
		}
		return jPanel;
	}
	/**
	 * This method initializes jLabelIntestazioneQuadro
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelIntestazioneQuadro() {
		if (jLabelIntestazioneQuadro == null) {
			jLabelIntestazioneQuadro = new javax.swing.JLabel();
			jLabelIntestazioneQuadro.setBounds(136, 19, 614, 21);
			jLabelIntestazioneQuadro.setText(
				"Altri automezzi, riforniti a mezzo distributore privato (Quadro B), non aventi titolo alla riduzione degli oneri");
			jLabelIntestazioneQuadro.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelIntestazioneQuadro.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelIntestazioneQuadro;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			jPanel1.setLayout(null);
			jPanel1.setLayout(FullScreenLayoutManager.getInstance());
			jPanel1.add(getJPanel2(), null);
			jPanel1.add(getJScrollPaneLista(), null);
			jPanel1.add(getJTextFieldTarga(), null);
			jPanel1.add(getJTextFieldDataIniPoss(), null);
			jPanel1.add(getJTextFieldDataFinPoss(), null);
			jPanel1.add(getJPanel3(), null);
			jPanel1.add(getJTextFieldTipoAutoveicolo(), null);
			jPanel1.setBounds(10, 87, 769, 329);
			jPanel1.setBackground(java.awt.Color.lightGray);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new javax.swing.JPanel();
			jPanel2.setLayout(null);
			jPanel2.setLayout(FullScreenLayoutManager.getInstance());
			jPanel2.add(getJLabelTarga(), null);
			jPanel2.add(getJLabelDataInizPoss(), null);
			jPanel2.add(getJLabelDataInizPoss2(), null);
			jPanel2.add(getJLabelDataInizPoss3(), null);
			jPanel2.add(getJLabelDataFinPoss1(), null);
			jPanel2.add(getJLabelDataFinPoss2(), null);
			jPanel2.add(getJLabelDataFinPoss3(), null);
			jPanel2.add(getJLabelTipoAutoveicolo(), null);
			jPanel2.setBounds(14, 194, 745, 55);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jLabelTarga
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTarga() {
		if (jLabelTarga == null) {
			jLabelTarga = new javax.swing.JLabel();
			jLabelTarga.setBounds(10, 18, 96, 19);
			jLabelTarga.setText("Targa");
			jLabelTarga.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelTarga.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelTarga;
	}
	/**
	 * This method initializes jLabelDataInizPoss
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss() {
		if (jLabelDataInizPoss == null) {
			jLabelDataInizPoss = new javax.swing.JLabel();
			jLabelDataInizPoss.setBounds(333, 1, 94, 19);
			jLabelDataInizPoss.setText("Data");
			jLabelDataInizPoss.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss;
	}
	/**
	 * This method initializes jLabelDataInizPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss2() {
		if (jLabelDataInizPoss2 == null) {
			jLabelDataInizPoss2 = new javax.swing.JLabel();
			jLabelDataInizPoss2.setBounds(333, 18, 94, 19);
			jLabelDataInizPoss2.setText("inizio possesso");
			jLabelDataInizPoss2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss2;
	}
	/**
	 * This method initializes jLabelDataInizPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataInizPoss3() {
		if (jLabelDataInizPoss3 == null) {
			jLabelDataInizPoss3 = new javax.swing.JLabel();
			jLabelDataInizPoss3.setBounds(333, 35, 94, 19);
			jLabelDataInizPoss3.setText("ggmm");
			jLabelDataInizPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataInizPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataInizPoss3;
	}
	/**
	 * This method initializes jLabelDataFinPoss1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss1() {
		if (jLabelDataFinPoss1 == null) {
			jLabelDataFinPoss1 = new javax.swing.JLabel();
			jLabelDataFinPoss1.setBounds(434, 1, 91, 19);
			jLabelDataFinPoss1.setText("Data");
			jLabelDataFinPoss1.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss1.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss1;
	}
	/**
	 * This method initializes jLabelDataFinPoss2
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss2() {
		if (jLabelDataFinPoss2 == null) {
			jLabelDataFinPoss2 = new javax.swing.JLabel();
			jLabelDataFinPoss2.setBounds(434, 18, 91, 19);
			jLabelDataFinPoss2.setText("fine possesso");
			jLabelDataFinPoss2.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss2.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss2;
	}
	/**
	 * This method initializes jLabelDataFinPoss3
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelDataFinPoss3() {
		if (jLabelDataFinPoss3 == null) {
			jLabelDataFinPoss3 = new javax.swing.JLabel();
			jLabelDataFinPoss3.setBounds(434, 35, 91, 19);
			jLabelDataFinPoss3.setText("ggmm");
			jLabelDataFinPoss3.setHorizontalAlignment(
				javax.swing.SwingConstants.CENTER);
			jLabelDataFinPoss3.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);
		}
		return jLabelDataFinPoss3;
	}
	/**
	 * This method initializes jTable
	 * 
	 * @return javax.swing.JTable
	 */
	private javax.swing.JTable getJTable() {
		if (jTable == null) {
			jTable = new javax.swing.JTable();
			jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

			jTable.getSelectionModel().addListSelectionListener(this);
		}
		return jTable;
	}
	/**
	 * This method initializes jScrollPaneLista
	 * 
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPaneLista() {
		if (jScrollPaneLista == null) {
			jScrollPaneLista = new javax.swing.JScrollPane();
			jScrollPaneLista.setBounds(11, 9, 751, 178);
			jScrollPaneLista.setViewportView(getJTable());
		}
		return jScrollPaneLista;
	}
	/**
	 * This method initializes jTextFieldTarga
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTarga() {
		if (jTextFieldTarga == null) {
			jTextFieldTarga = new javax.swing.JTextField();
			jTextFieldTarga.setBounds(23, 251, 96, 21);
			jTextFieldTarga.setDocument(
				new StringDocument(AutotrasportatoriQuadroC.getDimTarga()));
		}
		return jTextFieldTarga;
	}
	/**
	 * This method initializes jTextFieldDataIniPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataIniPoss() {
		if (jTextFieldDataIniPoss == null) {
			jTextFieldDataIniPoss = new javax.swing.JTextField();
			jTextFieldDataIniPoss.setBounds(348, 250, 94, 21);
			jTextFieldDataIniPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroC.getDimDataInizioPossesso()));
		}
		return jTextFieldDataIniPoss;
	}
	/**
	 * This method initializes jTextFieldDataFinPoss
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldDataFinPoss() {
		if (jTextFieldDataFinPoss == null) {
			jTextFieldDataFinPoss = new javax.swing.JTextField();
			jTextFieldDataFinPoss.setBounds(447, 250, 94, 21);
			jTextFieldDataFinPoss.setDocument(
				new BigIntegerDocument(
					AutotrasportatoriQuadroC.getDimDataFinePossesso()));
		}
		return jTextFieldDataFinPoss;
	}
	/**
	 * This method initializes jPanel3
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new javax.swing.JPanel();
			jPanel3.setLayout(null);
			jPanel3.setLayout(FullScreenLayoutManager.getInstance());
			jPanel3.add(getJButtonInserisci(), null);
			jPanel3.add(getJButtonModifica(), null);
			jPanel3.add(getJButtonElimina(), null);
			jPanel3.setBounds(421, 275, 337, 44);
			jPanel3.setBorder(
				javax.swing.BorderFactory.createLineBorder(
					java.awt.Color.black,
					1));
		}
		return jPanel3;
	}
	/**
	 * This method initializes jButtonInserisci
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonInserisci() {
		if (jButtonInserisci == null) {
			jButtonInserisci = new javax.swing.JButton();
			jButtonInserisci.setBounds(17, 7, 93, 28);
			jButtonInserisci.setText("Inserisci");
			jButtonInserisci.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonInserisci.addActionListener(this);
		}
		return jButtonInserisci;
	}
	/**
	 * This method initializes jButtonModifica
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonModifica() {
		if (jButtonModifica == null) {
			jButtonModifica = new javax.swing.JButton();
			jButtonModifica.setBounds(121, 8, 93, 28);
			jButtonModifica.setText("Modifica");
			jButtonModifica.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonModifica.addActionListener(this);
		}
		return jButtonModifica;
	}
	/**
	 * This method initializes jButtonElimina
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonElimina() {
		if (jButtonElimina == null) {
			jButtonElimina = new javax.swing.JButton();
			jButtonElimina.setBounds(229, 8, 93, 28);
			jButtonElimina.setText("Elimina");
			jButtonElimina.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonElimina.addActionListener(this);
		}
		return jButtonElimina;
	}
	/**
	 * This method initializes jButtonConferma
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonConferma() {
		if (jButtonConferma == null) {
			jButtonConferma = new javax.swing.JButton();
			jButtonConferma.setBounds(15, 429, 93, 28);
			jButtonConferma.setText("Conferma");
			jButtonConferma.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonConferma.addActionListener(this);
		}
		return jButtonConferma;
	}
	/**
	 * This method initializes jButtonChiudi
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getJButtonChiudi() {
		if (jButtonChiudi == null) {
			jButtonChiudi = new javax.swing.JButton();
			jButtonChiudi.setBounds(112, 429, 93, 28);
			jButtonChiudi.setText("Chiudi");
			jButtonChiudi.setHorizontalTextPosition(
				javax.swing.SwingConstants.CENTER);

			jButtonChiudi.addActionListener(this);
		}
		return jButtonChiudi;
	}
	/**
	 * This method initializes jTextFieldTipoAutoveicolo
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextFieldTipoAutoveicolo() {
		if (jTextFieldTipoAutoveicolo == null) {
			jTextFieldTipoAutoveicolo = new javax.swing.JTextField();
			jTextFieldTipoAutoveicolo.setBounds(130, 251, 206, 21);
			jTextFieldTipoAutoveicolo.setDocument(
				new StringDocument(
					AutotrasportatoriQuadroC.getDimTipoAutoveicolo()));
		}
		return jTextFieldTipoAutoveicolo;
	}
	/**
	 * This method initializes jLabelTipoAutoveicolo
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabelTipoAutoveicolo() {
		if (jLabelTipoAutoveicolo == null) {
			jLabelTipoAutoveicolo = new javax.swing.JLabel();
			jLabelTipoAutoveicolo.setBounds(116, 18, 206, 19);
			jLabelTipoAutoveicolo.setText("Tipo autoveicolo");
			jLabelTipoAutoveicolo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			jLabelTipoAutoveicolo.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		}
		return jLabelTipoAutoveicolo;
	}
}
