package it.finanze.dogane.accise.aautotrasportatori.ui.quadri;

import it.finanze.dogane.accise.aautotrasportatori.config.VisualConfig;
import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroB;
import it.finanze.dogane.accise.aautotrasportatori.model.ProspettoConsumo;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroA1Dialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroBNewDialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroDialogDisabled;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroA2Dialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroADialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroBDialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroCDialog;
import it.finanze.dogane.accise.aautotrasportatori.ui.AutotrasportatoriQuadroSubADialog;
import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;
import it.finanze.dogane.accise.pdf.PrintDriver;
import it.finanze.dogane.accise.ui.quadri.DefaultEtichettaQuadro;
import it.finanze.dogane.accise.ui.quadri.GestoreQuadro;
import it.finanze.dogane.accise.ui.quadri.dialog.QuadroDialog;
import java.awt.Component;
import java.awt.Frame;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
public class Quadro extends DefaultEtichettaQuadro implements GestoreQuadro {
	
	private static List listQuadriA = null;
	private static List listTipoQuadriA = null;
	
//	modifica reply
	public static final int[] QUADRO_A= { 10 };
	public static String TIPO_QUADRO_A  = "A";
	public static final String LETTERA_QUADRO_A = "A";
	
	public static final int[] QUADRO_A1 = { 10 };
	public static final int[] QUADRO_A2 = { 10 };
	public static final String TIPO_QUADRO_A1 = "1";
	public static final String TIPO_QUADRO_A2 = "2";
	// fine
	public static final int[] QUADRO_B = { 20 };
	public static final int[] QUADRO_C = { 30 };
	//	modifica reply
	public static final String LETTERA_QUADRO_A1 = "A-1";
	public static final String LETTERA_QUADRO_A2 = "A-2";
	// fine
	public static final String LETTERA_QUADRO_B = "B";
	public static final String LETTERA_QUADRO_C = "C";
	ProspettoConsumo prospettoConsumo = null;
	private int[] tipiRecord = null;
	private String lettera = null;
	public Quadro(int[] tipi) {
		if (tipi == null || tipi.length == 0) {
			throw new IllegalArgumentException("Si devono specificare i tipi.");
		}
		tipiRecord = tipi;
		lettera = getLetteraQuadro(tipi);
	}
	public static String getLetteraQuadro(int[] tipiRecord) {
		String retvalue = null;
		if (QUADRO_A.equals(tipiRecord)) {
			
			retvalue = LETTERA_QUADRO_A;
			
		} else if (QUADRO_B.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_B;
		} else if (QUADRO_C.equals(tipiRecord)) {
			retvalue = LETTERA_QUADRO_C;
		}
		return retvalue;
	}
	public void setProspect(Prospect prospect) {
		setProspect(prospect, null);
	}
	/**
	 * Il parametro non viene preso in considerazione
	 */
	public void setProspect(Prospect prospect, Object parameter) {
		if (prospect instanceof ProspettoConsumo) {
			prospettoConsumo = (ProspettoConsumo) prospect;
			updateEmptyValue();
		} else {
			throw new IllegalArgumentException(
				"Il prospetto deve essere di tipo: "
					+ ProspettoConsumo.class.getName()
					+ " e non di tipo: "
					+ prospettoConsumo.getClass().getName());
		}
	}
	public Object getParameter() {
		return null;
	}
	private void updateEmptyValue() {
		List recordPerQuadro =
			prospettoConsumo.getListaQuadro(tipiRecord, this.getTipoQuadroA());
		if (recordPerQuadro.size() > 0) {
			setEmpty(false);
		} else {
			setEmpty(true);
		}
	}
	public void showDialog(Frame frame) {
		if (isShowAvailable(frame)) {
			QuadroDialog quadroDialog = initDialog(frame,true);
			if (quadroDialog == null)
				return;
			quadroDialog.prepareValues(prospettoConsumo, this);
			JDialog jDialog = (JDialog) quadroDialog;
			jDialog.setVisible(true);
			updateEmptyValue();
		}
	}
	public void printDialog(Frame frame, PdfBuilder builder) {
		if (isShowAvailable(frame)) {
			QuadroDialog quadroDialog = initDialog(frame,false);
	//		if(quadroDialog instanceof AutotrasportatoriQuadroA2Dialog)
	//		{
				quadroDialog.prepareValues(prospettoConsumo, this); 
				Component c = (Component) quadroDialog;
				PrintDriver.print(c, builder);
//			}
		}
	}
	private boolean isShowAvailable(Frame frame) {
		boolean retvalue = true;
		if (getTipiRecord().equals(QUADRO_C)) {
			List lista = prospettoConsumo.getListaQuadro(QUADRO_B);
			if (lista == null || lista.size() == 0) {
				retvalue = false;
			} else {
				AutotrasportatoriQuadroB record =
					(AutotrasportatoriQuadroB) lista.get(0);
				boolean flagValue =record.isGasolioUtilizzatoRifornimAutovQuadroA();
				/*if (record.isSuperiore()) {
					flagValue =
						
				} else {
					flagValue =
						record
							.isGasolioUtilizzatoRifornimAutovQuadroA();
				}*/
				if (flagValue == true) {
					retvalue = false;
				}
			}
		}
		if (retvalue == false) {
			JOptionPane.showMessageDialog(
				frame,
				"Per selezionare il Quadro C, inserire il Quadro B e scegliere NO (Autoveicoli solo Quadro A)",
				"Attenzione",
				JOptionPane.WARNING_MESSAGE);
		}
		return retvalue;
	}
	private QuadroDialog initDialog(Frame frame, boolean alert) {
		QuadroDialog quadroDialog = null;
		
		/*
		if (tipiRecord.equals(QUADRO_A1)) {
			quadroDialog =
				new AutotrasportatoriQuadroA1Dialog(
					frame,
					getDescription(),
					getSecondDescription());
		} else if (tipiRecord.equals(QUADRO_A2)) {
			if (VisualConfig.QUADRO_A2_OPZIONE_SELEZIONATA
				== VisualConfig.QUADRO_A2_VISIBLE)
				quadroDialog =
					new AutotrasportatoriQuadroA2Dialog(
						frame,
						getDescription(),
						getSecondDescription());
			else {
				if(alert) JOptionPane.showMessageDialog(
					null,
					"Quadro Disabilitato",
					"Attenzione",
					0);
				//	JOptionPane.showMessageDialog(null,"Quadro Disabilitato");
				//quadroDialog=new AutotrasportatoriQuadroDialogDisabled();
			}*/
			if (tipiRecord.equals(getQuadroA(getQuadroSelezionato()))) {
					quadroDialog = new AutotrasportatoriQuadroSubADialog(
								frame,
								getTitle(),
								getDescription(),
								getSecondDescription());
								
				((AutotrasportatoriQuadroSubADialog)quadroDialog).setDataInizioPossesso(getDataInizioPossesso());
				((AutotrasportatoriQuadroSubADialog)quadroDialog).setDataFinePossesso(getDataFinePossesso());
				((AutotrasportatoriQuadroSubADialog)quadroDialog).setAliquota(getAliquota());
				((AutotrasportatoriQuadroSubADialog)quadroDialog).setQuadroSelezionato(getQuadroSelezionato());				
			}	
								
		 else if (tipiRecord.equals(QUADRO_B)) {
			quadroDialog =
				new AutotrasportatoriQuadroBNewDialog(
					frame,"",
					getDescription(),
					getSecondDescription());
		} else if (tipiRecord.equals(QUADRO_C)) {
			quadroDialog =
				new AutotrasportatoriQuadroCDialog(
					frame,
					getDescription(),
					getSecondDescription());
		} else {
			throw new RuntimeException(
				"Dialogo non previsto per questo quadro. "
					+ Quadro.getLetteraQuadro(tipiRecord));
		}
		return quadroDialog;
	}
	// aggiunto reply
	public String getTipoQuadroA() {
		if (tipiRecord == null)
			return null;
					
		int len = getListQuadriA().size();
		for (int i = 0; i < len; i++) {
			int[]q =(int[])listQuadriA.get(i);
			if (tipiRecord.equals(q))
				return getTipoQuadroA(i);
		}	
		
		return null;
	}
	public int[] getTipiRecord() {
		return tipiRecord;
	}
	public List getSottoQuadri() {
		return null;
	}
	public void showIntermediateDialog(Frame frame) {
	}
	/**
	 * @return
	 */
	public static String getTIPO_QUADRO_A() {
		return TIPO_QUADRO_A;
	}
	
	public static List initListaQuadroA(int size) {
		
		if(listQuadriA == null){			
		
			listQuadriA = new ArrayList();
			listTipoQuadriA = new ArrayList();
			
			String tipoQuadroA ="";
			int contatoreTipoA =1;
			
			for (int i = 0; i < size; i++) {
				int[] quadroA= new int[]{ 10 };
				listQuadriA.add(i,quadroA);
				listTipoQuadriA.add(i,tipoQuadroA+contatoreTipoA);
				contatoreTipoA++;
			}
		
		}
		return 	listQuadriA; 
	}

	/**
	 * @return
	 */
	private static List getListQuadriA() {
		return listQuadriA;
	}
	
	private static int[] getQuadroA(int quadroSelezionato) {
			return (int[])listQuadriA.get(quadroSelezionato);
	}
	
	public static String getTipoQuadroA(int quadroSelezionato) {
				return (String)listTipoQuadriA.get(quadroSelezionato);
	}

	/**
	 * @return
	 */
	public ProspettoConsumo getProspettoConsumo() {
		return prospettoConsumo;
	}
	/* (non Javadoc)
	 * @see it.finanze.dogane.accise.ui.quadri.GestoreQuadro#getProspect()
	 */
	public Object getProspect() {
		return prospettoConsumo;
		
	}

}
// modifica reply	public static final int[] QUADRO_A1 = { 10 };	public static final int[] QUADRO_A2 = { 10 };	public static final String TIPO_QUADRO_A1 = "1";	public static final String TIPO_QUADRO_A2 = "2";	// fine	public static final int[] QUADRO_B = { 20 };	public static final int[] QUADRO_C = { 30 };	//	modifica reply	public static final String LETTERA_QUADRO_A1 = "A-1";	public static final String LETTERA_QUADRO_A2 = "A-2";	// fine	public static final String LETTERA_QUADRO_B = "B";	public static final String LETTERA_QUADRO_C = "C";	ProspettoConsumo prospettoConsumo = null;	private int[] tipiRecord = null;	private String lettera = null;	public Quadro(int[] tipi) {		if (tipi == null || tipi.length == 0) {			throw new IllegalArgumentException("Si devono specificare i tipi.");		}		tipiRecord = tipi;		lettera = getLetteraQuadro(tipi);	}	public static String getLetteraQuadro(int[] tipiRecord) {		String retvalue = null;		if (QUADRO_A1.equals(tipiRecord)) {			retvalue = LETTERA_QUADRO_A1;		} else if (QUADRO_A2.equals(tipiRecord)) {			retvalue = LETTERA_QUADRO_A2;		} else if (QUADRO_B.equals(tipiRecord)) {			retvalue = LETTERA_QUADRO_B;		} else if (QUADRO_C.equals(tipiRecord)) {			retvalue = LETTERA_QUADRO_C;		}		return retvalue;	}	public void setProspect(Prospect prospect) {		setProspect(prospect, null);	}	/**	 * Il parametro non viene preso in considerazione	 */	public void setProspect(Prospect prospect, Object parameter) {		if (prospect instanceof ProspettoConsumo) {			prospettoConsumo = (ProspettoConsumo) prospect;			updateEmptyValue();		} else {			throw new IllegalArgumentException(				"Il prospetto deve essere di tipo: "					+ ProspettoConsumo.class.getName()					+ " e non di tipo: "					+ prospettoConsumo.getClass().getName());		}	}	public Object getParameter() {		return null;	}	private void updateEmptyValue() {		List recordPerQuadro =			prospettoConsumo.getListaQuadro(tipiRecord, this.getTipoQuadroA());		if (recordPerQuadro.size() > 0) {			setEmpty(false);		} else {			setEmpty(true);		}	}	public void showDialog(Frame frame) {		if (isShowAvailable(frame)) {			QuadroDialog quadroDialog = initDialog(frame);			if (quadroDialog == null)				return;			quadroDialog.prepareValues(prospettoConsumo, this);			JDialog jDialog = (JDialog) quadroDialog;			jDialog.setVisible(true);			updateEmptyValue();		}	}	public void printDialog(Frame frame, PdfBuilder builder) {		if (isShowAvailable(frame)) {			QuadroDialog quadroDialog = initDialog(frame);			quadroDialog.prepareValues(prospettoConsumo, this);			Component c = (Component) quadroDialog;			PrintDriver.print(c, builder);		}	}	private boolean isShowAvailable(Frame frame) {		boolean retvalue = true;		if (getTipiRecord().equals(QUADRO_C)) {			List lista = prospettoConsumo.getListaQuadro(QUADRO_B);			if (lista == null || lista.size() == 0) {				retvalue = false;			} else {				AutotrasportatoriQuadroB record =					(AutotrasportatoriQuadroB) lista.get(0);				boolean flagValue = false;				if (record.isSuperiore()) {					flagValue =						record							.isSuperioreGasolioUtilizzatoRifornimAutovQuadroA();				} else {					flagValue =						record							.isInferioreGasolioUtilizzatoRifornimAutovQuadroA();				}				if (flagValue == true) {					retvalue = false;				}			}		}		if (retvalue == false) {			JOptionPane.showMessageDialog(				frame,				"Per selezionare il Quadro C, inserire il Quadro B e segliere NO (Autoveicoli solo Quadro A)",				"Attenzione",				JOptionPane.WARNING_MESSAGE);		}		return retvalue;	}	private QuadroDialog initDialog(Frame frame) {		QuadroDialog quadroDialog = null;		if (tipiRecord.equals(QUADRO_A1)) {			quadroDialog =				new AutotrasportatoriQuadroA1Dialog(					frame,					getDescription(),					getSecondDescription());		} else if (tipiRecord.equals(QUADRO_A2)) {			if (VisualConfig.QUADRO_A2_OPZIONE_SELEZIONATA				== VisualConfig.QUADRO_A2_VISIBLE)				quadroDialog =					new AutotrasportatoriQuadroA2Dialog(						frame,						getDescription(),						getSecondDescription());			else {				JOptionPane.showMessageDialog(					null,					"Quadro Disabilitato",					"Attenzione",					0);				//	JOptionPane.showMessageDialog(null,"Quadro Disabilitato");				//quadroDialog=new AutotrasportatoriQuadroDialogDisabled();			}		} else if (tipiRecord.equals(QUADRO_B)) {			quadroDialog =				new AutotrasportatoriQuadroBDialog(					frame,					getDescription(),					getSecondDescription());		} else if (tipiRecord.equals(QUADRO_C)) {			quadroDialog =				new AutotrasportatoriQuadroCDialog(					frame,					getDescription(),					getSecondDescription());		} else {			throw new RuntimeException(				"Dialogo non previsto per questo quadro. "					+ Quadro.getLetteraQuadro(tipiRecord));		}		return quadroDialog;	}	// aggiunto reply	public String getTipoQuadroA() {		if (tipiRecord == null)			return null;		else if (tipiRecord.equals(QUADRO_A1))			return Quadro.TIPO_QUADRO_A1;		else if (tipiRecord.equals(QUADRO_A2))			return Quadro.TIPO_QUADRO_A2;		return null;	}	public int[] getTipiRecord() {		return tipiRecord;	}	public List getSottoQuadri() {		return null;	}	public void showIntermediateDialog(Frame frame) {	}}