package it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroB;
import it.finanze.dogane.accise.pdf.PrintableTableModel;
import it.finanze.dogane.accise.util.StringUtil;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class AutotrasportatoriQuadroB1TM extends AutotrasportatoriQuadroBTM {

	
	
	private static final int numeroColonne = 4;
	private static final String[] arrayNomiColonne = new String[]{"Codice Ditta","Numero fatture d'acquisto","Totale litri fatturati","Totale importo"};

	public AutotrasportatoriQuadroB1TM(List lista) {
		listaRecord = lista;				
	}
	

	public int getColumnCount() {
		return numeroColonne;
	}

		

	public Object getValueAt(int rowIndex, int columnIndex) {
		AutotrasportatoriQuadroB record = (AutotrasportatoriQuadroB)listaRecord.get(rowIndex);
		
		Object retvalue = null;
		if(columnIndex == 0) {
			retvalue = record.getSuperioreCodiceDitta();
		} else if(columnIndex == 1) {
			retvalue = record.getSuperioreNumeroFatture();
		} else if(columnIndex == 2) {
			retvalue = record.getSuperioreTotaleLitri();
		} else if(columnIndex == 3) {
			retvalue = record.getSuperioreTotaleImporto();
		} 
		return retvalue;
	}

		
	

	public String getColumnName(int columnIndex) {	
		
		return arrayNomiColonne[columnIndex];
	}

	

	
	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new AutotrasportatoriQuadroB1TM(newListaRecord);
	}

}
