package it.finanze.dogane.accise.aautotrasportatori.ui.tablemodel;

import it.finanze.dogane.accise.aautotrasportatori.model.AutotrasportatoriQuadroB;
import it.finanze.dogane.accise.pdf.PrintableTableModel;
import it.finanze.dogane.accise.util.StringUtil;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class AutotrasportatoriQuadroB2TM extends AutotrasportatoriQuadroBTM {

	
	private static final int numeroColonne = 7;
	private static final String[] arrayNomiColonne = new String[]{"Provincia","Comune","Indirizzo","Capacita'","Numero fatt.","Totale litri","Totale importo"};

	public AutotrasportatoriQuadroB2TM(List lista) {
		listaRecord = lista;
				
	}

	public int getColumnCount() {
		return numeroColonne;
	}

	
	public Object getValueAt(int rowIndex, int columnIndex) {
		AutotrasportatoriQuadroB record = (AutotrasportatoriQuadroB)listaRecord.get(rowIndex);
		
		Object retvalue = null;
		if(columnIndex == 0) {
			retvalue = record.getInferioreProvinciaUbicazioneImpianto();
		} else if(columnIndex == 1) {
			retvalue = record.getInferioreComuneUbicazioneImpianto();
		} else if(columnIndex == 2) {
			retvalue = record.getInferioreIndirizzoUbicazioneImpianto();
		} else if(columnIndex == 3) {
			retvalue = record.getInferioreCapacitaStoccaggioSerbatoio();
		} else if(columnIndex == 4) {
			retvalue = record.getInferioreNumeroFatture();
		}else if(columnIndex == 5) {
			retvalue = record.getInferioreTotaleLitri();
		}else if(columnIndex == 6) {
			retvalue = record.getInferioreTotaleImporto();
		}    
		
		return retvalue;
	}

	public String getColumnName(int columnIndex) {	
		
		return arrayNomiColonne[columnIndex];
	}	

	public PrintableTableModel split(int index, int offset) {
		List newListaRecord = new LinkedList();
		
		Iterator it = listaRecord.iterator();
		int i = 0;
		while(it.hasNext()) {
			Object obj = it.next();
			if(i>=index && i<=index+offset-1) {
				newListaRecord.add(obj);
			}
			i++;
		}
		
		return new AutotrasportatoriQuadroB2TM(newListaRecord);
	}
}
