package it.finanze.dogane.accise.pdf;
/*
 * $Id: PageNumbersWatermark.java 3373 2008-05-12 16:21:24Z xlv $
 *
 * This code is part of the 'iText Tutorial'.
 * You can find the complete tutorial at the following address:
 * http://itextdocs.lowagie.com/tutorial/
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * itext-questions@lists.sourceforge.net
 */



import java.io.IOException;


import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;

import com.lowagie.text.pdf.BaseFont;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfGState;

import com.lowagie.text.pdf.PdfPageEventHelper;
import com.lowagie.text.pdf.PdfTemplate;
import com.lowagie.text.pdf.PdfWriter;
/**
 * Demonstrates the use of templates to add Watermarks and Pagenumbers.
 */
public class PageNumbers extends PdfPageEventHelper {

    public PdfGState gstate;   
    public PdfTemplate tpl;  
    public BaseFont helv;
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onOpenDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onOpenDocument(PdfWriter writer, Document document) {
    	
    	
    	 try {
			helv = BaseFont.createFont("Helvetica", BaseFont.WINANSI, false);
		} catch (DocumentException e) {			
			e.printStackTrace();
		} catch (IOException e) {		
			e.printStackTrace();
		}
		tpl = writer.getDirectContent().createTemplate(100,100);
        
    }    
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onEndPage(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onEndPage(PdfWriter writer, Document document) {
        PdfContentByte cb = writer.getDirectContent();
        cb.saveState();
      
        String text = "Pagina " + writer.getPageNumber() + " di ";
        float textSize = helv.getWidthPoint(text, 14);
        float textBase = document.bottom()+5 ;//- 20;
        cb.beginText();
        cb.setFontAndSize(helv, 14);
       
            float adjust = helv.getWidthPoint("0", 14);
            cb.setTextMatrix(document.right() - textSize - adjust, textBase);
            cb.showText(text);
            cb.endText();
           // cb.addTemplate(tpl, document.right()- adjust , textBase);
		   cb.addTemplate(tpl, document.right()- adjust , textBase);
      
        cb.saveState();
        
    }
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onStartPage(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onStartPage(PdfWriter writer, Document document) {
       
    }
    
    /**
     * @see com.lowagie.text.pdf.PdfPageEventHelper#onCloseDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
     */
    public void onCloseDocument(PdfWriter writer, Document document) {
      tpl.beginText();
       tpl.setFontAndSize(helv, 14);
       tpl.setTextMatrix(0, 0);
       tpl.showText(Integer.toString(writer.getPageNumber() - 1));
       tpl.endText();
    }
}
