package it.finanze.dogane.accise.pdf;

import it.finanze.dogane.accise.ui.GrayGlassPane;

import java.awt.Component;

import javax.swing.JDialog;
import javax.swing.RootPaneContainer;

/*
 * Effettua tutte le operazini necessarie per stampare su pdf un Component che implementi l'interfaccia PdfPrintable 
 */
public class PrintDriver {

	private Component component = null;
	private PdfBuilder pdfBuilder = null;

	private PrintDriver(Component c, PdfBuilder builder) {
		if(c == null || builder == null) {
			throw new NullPointerException();
		}
		pdfBuilder = builder;
		component = c;
	}

	private void go() {
		try {

			if(component instanceof RootPaneContainer) {
				RootPaneContainer container = (RootPaneContainer)component;
				GrayGlassPane glass = new GrayGlassPane();
				container.setGlassPane(glass);
				glass.setVisible(true);
			}

			Thread thread = new Thread(new ShowMan(true));
			thread.start();

			synchronized(this) {
				while(component.isVisible() == false) {
					wait(20);
				}
			}

			PdfPrintable pdfPrintable = (PdfPrintable)component;
			pdfPrintable.plot(pdfBuilder);
			
			component.setVisible(false);
			
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}


	public static void print(Component c, PdfBuilder builder) {
		PrintDriver driver = new PrintDriver(c, builder);
		driver.go();
	}

	/**
	 * Chiama la plot del componente printabile 
	 */
//	private class PrintJob implements Runnable {
//		public void run() {
//			if(component instanceof PdfPrintable) {
//				PdfPrintable pdfPrintable = (PdfPrintable)component;
//				pdfPrintable.plot(pdfBuilder);
//			}
//		}
//	}

	/**
	 * Rende il componente visibile o invisibile
	 */
	private class ShowMan implements Runnable {

		private boolean visible = false;

		public ShowMan(boolean visible) {

			this.visible = visible;
		}

		public void run() {
			component.setVisible(visible);
		}

	}
}
