package it.finanze.dogane.accise.ui.laf;

import javax.swing.UIDefaults;
import javax.swing.border.CompoundBorder;
import javax.swing.border.LineBorder;
import javax.swing.plaf.BorderUIResource;
import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;

public class ContrastTheme extends DefaultMetalTheme {

	public String getName()
	{
		return "Contrast";
	}

	protected ColorUIResource getPrimary1()
	{
		return primary1;
	}

	protected ColorUIResource getPrimary2()
	{
		return primary2;
	}

	protected ColorUIResource getPrimary3()
	{
		return primary3;
	}

	public ColorUIResource getPrimaryControlHighlight()
	{
		return primaryHighlight;
	}

	protected ColorUIResource getSecondary2()
	{
		return secondary2;
	}

	protected ColorUIResource getSecondary3()
	{
		return secondary3;
	}

	public ColorUIResource getControlHighlight()
	{
		return super.getSecondary3();
	}

	public ColorUIResource getFocusColor()
	{
		return getBlack();
	}

	public ColorUIResource getTextHighlightColor()
	{
		return getBlack();
	}

	public ColorUIResource getHighlightedTextColor()
	{
		return getWhite();
	}

	public ColorUIResource getMenuSelectedBackground()
	{
		return getBlack();
	}

	public ColorUIResource getMenuSelectedForeground()
	{
		return getWhite();
	}

	public ColorUIResource getAcceleratorForeground()
	{
		return getBlack();
	}

	public ColorUIResource getAcceleratorSelectedForeground()
	{
		return getWhite();
	}

	public void addCustomEntriesToTable(UIDefaults uidefaults)
	{
		BorderUIResource borderuiresource = new BorderUIResource(new LineBorder(getBlack()));
		BorderUIResource borderuiresource1 = new BorderUIResource(new LineBorder(getWhite()));
		BorderUIResource borderuiresource2 = new BorderUIResource(new CompoundBorder(borderuiresource, new javax.swing.plaf.basic.BasicBorders.MarginBorder()));
		uidefaults.put("ToolTip.border", borderuiresource);
		uidefaults.put("TitledBorder.border", borderuiresource);
		uidefaults.put("Table.focusCellHighlightBorder", borderuiresource1);
		uidefaults.put("Table.focusCellForeground", getWhite());
		uidefaults.put("TextField.border", borderuiresource2);
		uidefaults.put("PasswordField.border", borderuiresource2);
		uidefaults.put("TextArea.border", borderuiresource2);
		uidefaults.put("TextPane.font", borderuiresource2);
	}

	private final ColorUIResource primary1 = new ColorUIResource(0, 0, 0);
	private final ColorUIResource primary2 = new ColorUIResource(204, 204, 204);
	private final ColorUIResource primary3 = new ColorUIResource(255, 255, 255);
	private final ColorUIResource primaryHighlight = new ColorUIResource(102, 102, 102);
	private final ColorUIResource secondary2 = new ColorUIResource(204, 204, 204);
	private final ColorUIResource secondary3 = new ColorUIResource(255, 255, 255);
	private final ColorUIResource controlHighlight = new ColorUIResource(102, 102, 102);


}
