package it.finanze.dogane.accise.ui.quadri;

import it.finanze.dogane.accise.model.Prospect;
import it.finanze.dogane.accise.pdf.PdfBuilder;

import java.awt.Frame;
import java.util.List;

public interface GestoreQuadro {


	/**
	 * Imposta il modello in modo tale che il GestoreQuadro possa estrapolarne le informazioni
	 * che gli competono.
	 * @param prospettoConsumo
	 */
	public void setProspect(Prospect prospettoConsumo);

	/**
	 * Imposta il modello in modo tale che il GestoreQuadro possa estrapolarne le informazioni
	 * @param prospettoConsumo
	 * @param parameter si tratta di un oggetto che pu influenzare il caricamento dei valori a seconda dell'implementazione
	 */
	public void setProspect(Prospect prospettoConsumo, Object parameter);

	/**
	 * Ritorna il parametro impostato dalla ultima setProspect o oppure null
	 * @return
	 */
	public Object getParameter();

	/**
	 * Mostra una finestra di dialogo modale a quella principale
	 * @param frame
	 */
	public void showDialog(Frame frame);

	/**
	 * Mostra una finestra di dialogo modale a quella principale
	 * @param frame
	 */
	public void printDialog(Frame frame, PdfBuilder builder);

	/**
	 * Mostra una finestra di dialogo modale a quella principale
	 * @param frame
	 */
	public void showIntermediateDialog(Frame frame);

	/**
	 * Ritorna null se il quadro non  complesso altrimenti la lista dei suoi sotto quadri
	 * @return
	 */
	public List getSottoQuadri();
	
	public Object getProspect();

}
